      program asku

c     Copyright 2012 Leon van Dommelen.  This software is made available
c     under the GNU Public License version 3.

c     Ask the user for input and output it formatted.  Or just do
c     formatted output.

c     Usage: See web page asku.html.

c     Notes:
c     Do not try to define a "**" or "* " command.
c     Do not do an index(tmp(...),'/') since */ is defined.  Use fndcls.

c     avoid typos
      implicit none

c external

c     number of command arguments
      integer iargc
      external iargc

c common

c     INPUT indicator
      character*1 inind
c     parameter
      character*8 param
c     location in TEMPLATE
      integer tmpi
      common/cmerr/tmpi,param,inind

c     stored strings
      integer ssdim,sstdim
      parameter (ssdim=16,sstdim=8192)
      integer ss,ss1,ss2
      integer sstl(0:ssdim)
      character*(sstdim) sst(0:ssdim)
      common/cmss/sstl,sst

c local

c     whether we have found the end of standard input
      integer stieof
      data stieof/0/
c     last read standard input line
      character*(sstdim+2) stil
      integer still
      data still/0/
c     character position in the standard input line
      integer sti
      data sti/0/

c     last character in the input character buffer and reduced value
      integer ipcmax,ipcmxr
      data ipcmax/0/,ipcmxr/0/
c     saved value of ipcmax
      integer ipcmx0
c     first character in the input character buffer
      integer ipcmin
      data ipcmin/0/
c     character in the input character buffer and reduced value
      integer ipc,ipc1,ipc2,ipcr
c     declared number of buffered input characters
      integer ipcsiz
      parameter (ipcsiz=524288)
c     the buffered input characters in cyclic storage
      character*1 ipcbuf(0:ipcsiz-1)

c     EOF input line or if unknown minus the current lowest value for it
      integer ipleof
      data ipleof/-1/
c     last line in the input buffers and its reduced value
      integer iplmax,iplmxr
      data iplmax/0/,iplmxr/0/
c     first line fully in the input buffers and its reduced value
      integer iplmin,iplmnr
      data iplmin/1/,iplmnr/1/
c     generic reduced value
      integer iplr
c     declared number of buffered input line starting points
      integer iplsiz
      parameter (iplsiz=16384)
c     the buffered input line end points in cyclic storage
      integer iplbuf(0:iplsiz-1)
      data iplbuf(0)/0/
c     task to perform for the current input line, if it is in range
      character*1 ipltsk
      data ipltsk/' '/
c     current input line, any value MUST be located using ipltsk='l'
      integer iplcur
      data iplcur/0/
c     input line to locate (an initial negative value means from EOF)
      integer iplloc
      data iplloc/0/
c     line to read in from the input file
      integer iplget
      data iplget/0/
c     saved value of iplcur
      integer iplsav
      data iplsav/0/

c     copy limits of the *pp/ command
      integer iplub,iplue
      data iplub/0/,iplue/-1/
c     line range currently shown
      integer iplvb,iplve
      data iplvb/0/,iplve/0/
c     new line write count
      integer iplwct
      data iplwct/0/
c     range of iplcur values that has been established as being valid
      integer iplulo,ipluhi
      data iplulo/1234567890/,ipluhi/0/
c     best estimates for the lower and upper range limits
      integer iplul,ipluh
      data iplul/0/,ipluh/1234567890/
c     please forgive the *pp/ command
      integer iplufg
      data iplufg/0/
c     user task
      character*1 utask

c     declared number of nested labels
      integer labdim
      parameter (labdim=1024)
c     actual number of nested labels
      integer labmax
      data labmax/0/
c     label index
      integer lab
c     position of the label in the template
      integer labpos(0:labdim)
      data labpos(0)/0/
c     where its ending *b is
      integer labend(0:labdim)
c     lower limits on input lines in the loops (negative values are from EOF)
      integer labipb(0:labdim)
      data labipb(0)/0/
c     upper limit (negative values are from EOF if labipr is nonzero)
      integer labipe(0:labdim),labipr(0:labdim)
      data labipe(0)/-1/,labipr(0)/1/
c     current input line
      integer labipc(0:labdim)
      data labipc(0)/0/
c     whether the label loop is finished
      integer labfin(0:labdim)
      data labfin(0)/0/

c     declared number of characters in the gathering storage
      integer gthdim
      parameter (gthdim=524288)
c     actual number of characters in the gathering storage
      integer gthl
      data gthl/0/
c     gathering storage
      character*(gthdim) gth
      character*1 gthbuf(0:gthdim-1)
      equivalence (gth(1:1),gthbuf(0))
c     whether we are gathering
      integer ingth
      data ingth/0/

c     character replacement table
      character*8 crep(0:255)
      integer crepl(0:255)
c     whether we are in replacement mode
      integer repmod
      data repmod/1/

c     current working directory
      character*1024 cwd
      integer cwdl
c     directory divider
      character*1 dd
c     new line string
      character*2 nl
      integer nll

c     date and time string
      character*46 dattim
      integer havdt
      data havdt/0/
c     time data
      integer tdat(9)
c     time and increment
      integer time,timinc

c     declared number of arguments
      integer argdim
      parameter (argdim=9)
c     actual number of arguments
      integer argmx
c     argument index
      integer arg
c     argument string
      character*256 argt(argdim)
      integer argtl(argdim)
c     task to perform and its named values
      integer task,task0
      data task0/-9/
      integer tsksti,tskfil,tskmen,tskcol,tskfol,tsknum,tskstr,tskval
      parameter (tsksti=-1,tskfil=0,
     & tskmen=1,tskcol=2,tskfol=3,tsknum=4,tskstr=5,tskval=6)
c     where we are truncating standard input
      integer trunci
      data trunci/256/
c     output file and its length to its file extension
      character*256 fil
      integer fill,extl
      data extl/0/
c     how we are truncating/wrapping output: line length, tab stops, utf-8 mode
      integer trunco(3)
      data trunco/0,0,0/
c     output character count
      integer outcnt
      data outcnt/0/
c     paging screen size
      integer scrnsz
      data scrnsz/21/
c     template and its character indices
      character*32770 tmp
      integer tmpl
      integer tmpi1,tmpi2
c     jump limits
      integer tmpij1(100),tmpij2(100),tmpijm
      data tmpijm/0/
c     item type and whether it starts with a capital
      character*77 typ
      integer typl,typc
c     default value and whether we have one
      character*79 def
      integer defl,intdef,havdef
      real fltdef
c     external help
      character*256 help
      integer helpl
c     maximum allowed value and whether the exact value is excluded
      character*76 cmax
      integer cmaxl,intmax,excmax
      real fltmax
c     minimum allowed value and whether the exact value is excluded
      character*76 cmin
      integer cminl,intmin,excmin
      real fltmin
c     field(s) in the menu list
      integer fld,fld2
c     field separator(s)
      character*256 sep
      integer sepl
      data sepl/0/

c     user's input number
      integer intsel
      real fltsel

c     selectable menu items
      integer sdim,smax,s
      parameter (sdim=459)
      character*80 sit(sdim)
      integer sitl(sdim),sitlmx

c     screen lines
      integer l
      character*79 lin(18)

c     menu counter
      integer menu,menumx

c     menu keys
      integer key,keymax
      character*62 keychr
      integer keys(62)
c     default key character
      character*1 defkey

c     menu item offset and length
      integer menoff,menl

c     declared number of entries in the string to find
      integer fnddim
      parameter (fnddim=512)
c     actual number of entries in the string to find
      integer fndmax
      data fndmax/0/
c     data on the entries in the string to find,
      integer fnddat(-1:255,fnddim)
c     source of the data above (1: template, 2: user)
      integer fndsrc
      data fndsrc/1/
c     last template-entered string to find
      character*256 fndts
      integer fndtsl
      data fndtsl/0/
c     last user-entered string to find
      character*80 fndus
      integer fndusl
      data fndusl/0/
c     the start and end points of the string parts found
      integer fndbeg(0:9),fndend(0:9)
c     last defined parameter
      integer parmax

c     color entered by the user
      character*6 color
      data color/'      '/

c     hex digits
      character*16 hex
      data hex/'0123456789ABCDEF'/

c     location of file extension point
      integer ipt
c     location of the drive letter colon
      integer icolon

c     prompt
      character*80 prompt
      integer prompl

c     prompt line
      character*80 line
      integer linel

c     text line
      character*316 text
      integer textl
      data textl/0/

c     temporary line
      character*(sstdim) tmplin

c     ascii code and the value of 'a'
      integer asc,asca
      data asc/0/

c     error status
      integer istat
      character*67 cstat

c     good characters
      character*256 good
      integer goodl

c     whether the folder exists
      logical exists

c     input unit number, may be 4 or 5 (standard input)
      integer iunit
      data iunit/0/

c     output unit number, may include 2 and/or 6 (standard output)
      integer ounit
      data ounit/0/

c     file status
      integer flstat(13)
      data flstat/13*0/
c     user ID
      integer getuid

c     verify command tasks
      character*1 task1,task2
      integer taski
c     test
      character*1 test
c     whether the test passed
      logical yes

c     return label
      integer iret
      data iret/0/

c     number as string
      character*20 cval
      integer cvall

c     generic character
      character*1 chr
      integer ichr

c     generic indices
      integer i,i1,i2

c executable

c     formats
 10   format(a)
 11   format(a,$)
 15   format(a256)
 20   format(79a1)
 25   format(f5.3)

c     allow I/O to use units 7 and on
      call libini(7)

c     set the error exit status to 1
      call errset(1)

c     initialize the common blocks
      inind='?'
      param=' '
      tmpi=0
      do 30 ss=0,ssdim
         sstl(ss)=-1
 30   continue

c     initialize to nontrivial characters
      ipcbuf(0)=char(10)

c     set the ascii code for 'a'
      asca=ichar('a')

c     initialize the system data
      call sysini(cwd,cwdl,dd,nl,nll)
      call nxtchr(dd,1,i,chr,ichr)

c     initialize the character replacement table
      do 40 i=0,255
         crepl(i)=-i-1
 40   continue

c     get the command line arguments
      argmx=iargc()
      if(argmx.le.1)goto 990
      if(argmx.gt.9)call errp('Too many parameters!')
      do 50 arg=1,argmx
         i2=len(argt(1))
         if(arg.eq.3)i2=len(tmp)-2
         argtl(arg)=min(2*i2,gthdim)
         gth(1:argtl(arg))=' '
         call getarg(arg,gth)
         do 45 i=argtl(arg),1,-1
            if(gth(i:i).ne.' ')goto 49
            argtl(arg)=i-1
 45      continue
 49      if(argtl(arg).gt.i2)then
            call errp(
     &       'Command parameter '//char(arg+48)//' is too long!')
         else if(argtl(arg).gt.0)then
            if(arg.ne.3)argt(arg)(1:argtl(arg))=gth(1:argtl(arg))
            if(arg.eq.3)tmp(1:argtl(arg))=gth(1:argtl(arg))
            if(argtl(arg).eq.1 .and. gth(1:1).eq.'-')argtl(arg)=0
         endif
 50   continue
      do 55 arg=argmx+1,9
         argtl(arg)=0
 55   continue
      do 60 arg=argmx,1,-1
         if(argtl(arg).gt.0)goto 61
         argmx=arg-1
 60   continue
 61   continue

c     determine task
      if(argtl(1).le.0)then
         task=tsksti
      else if(argt(1)(1:1).eq.'?')then
         task=tskfil
         if(argtl(1).le.1)call errp('INPUT: missing FILE!')
      else
         if(index(argt(1)(1:argtl(1)),' ').ne.0)
     &    call errp('INPUT TASK cannot contain blanks!')
         task=(index(
     &    ' menu  '//
     &    ' color '//
     &    ' folder'//
     &    ' number'//
     &    ' string'//
     &    ' value ',
     &    ' '//argt(1)(1:argtl(1)))+6)/7
         if(task.le.0)call errp('Invalid INPUT!')
      endif
      inind=argt(1)(1:1)

c     determine OUTPUT
      fill=argtl(2)
      if(fill.le.0)then
         fill=1
         fil(1:1)='-'
      else
         fil(1:fill)=argt(2)(1:fill)
         if(index('?+',fil(1:1)).le.0)call errp('OUTPUT is invalid!')
         if(fill.le.1)call errp('OUTPUT file cannot be blank!')
      endif

c     determine TEMPLATE
      tmpl=argtl(3)
      if(tmpl.gt.0)then
         if(tmp(tmpl:tmpl).eq.'*')tmpl=tmpl-1
      endif
      labend(0)=tmpl
      tmp(tmpl+1:tmpl+2)='*)'
      i=-2
      call fndcls(tmp,tmpl+2,i)
      if(i.ne.tmpl+2)call errp('Extra *) in TEMPLATE!')

c     determine TYPE
 70   typl=argtl(4)
      if(typl.le.0 .and. task.gt.0)call errp('TYPE cannot be blank!')
      if(typl.gt.76)call errp('TYPE is too long!')
      typc=0
      if(typl.gt.0)then
         typ(1:typl)=argt(4)(1:typl)
         if(index(typ(1:typl),':').ne.0)
     &    call errp('TYPE may not contain colons!')
         if(typ(1:1).ge.'A' .and. typ(1:1).le.'Z')typc=1
         if(typ(1:1).eq.' ')typc=1
      endif

c     determine DEFAULT
      defl=argtl(5)
      if(defl.gt.0)then
         if(defl.gt.79)call errp('DEFAULT is too long!')
         havdef=1
         def(1:defl)=argt(5)(1:defl)
      else
         havdef=0
         defl=1
         def(1:1)=' '
      endif

c     determine HELP
      helpl=0
      if(argtl(6).gt.0)then
         help(1:1)=argt(6)(1:1)
         helpl=1
         if(index('?*',help(1:1)).le.0)
     &    call errp('HELP must start with ? or *!')
         i=helpl
 80      call nxtchr(argt(6),argtl(6),i,chr,ichr)
         if(ichr.eq.-1)goto 81
         if(ichr.eq.-2)
     &    call errp('Incomplete * character in HELP!')
         if(ichr.lt.0)call errp(
     &    'Invalid *'//char(-ichr)//' character in HELP!')
         helpl=helpl+1
         help(helpl:helpl)=chr
         goto 80
 81      if(helpl.le.1 .and. help(1:1).eq.'?')
     &    call errp('Missing HELP file!')
         if(helpl.le.1 .and. help(1:1).ne.'?')
     &    call errp('Missing HELP command!')
      endif

c     go finish the task
      if(task.eq.tskmen)goto 100
      if(task.eq.tskcol)goto 300
      if(task.eq.tskfol)goto 400
      if(task.eq.tsknum)goto 500
      if(task.eq.tskstr)goto 550
      if(task.eq.tskval)goto 600
      if(task.eq.tsksti)goto 800
      if(task.eq.tskfil)goto 800
      call erri('81')

c menu task

c     jump-to point
 100  continue

c     determine MAX
      intmax=0
      if(argtl(7).gt.0)then
         i=0
         call rdint(argt(7),argtl(7),i,intmax,istat)
         if(istat.ne.0 .or. i.ne.argtl(7))
     &    call errp('Invalid MAX value!')
         if(intmax.gt.79 .or. intmax.lt.-79)call errp('MAX is too big!')
      endif

c     determine FIELD and SEP
      fld=0
      if(argtl(8).gt.0)then
         i=0
         call rdint(argt(8),argtl(8),i,fld,istat)
         if(istat.ne.0 .or. i.ne.argtl(8))
     &    call errp('Invalid FIELD value!')
      endif
      if(fld.ne.0)then
         if(argtl(9).gt.0)then
            sepl=0
            i=0
 102        call nxtchr(argt(9),argtl(9),i,chr,ichr)
            if(ichr.eq.-1)goto 103
            if(ichr.eq.-2)call errp('Unterminated * command in SEP!')
            if(ichr.lt.0)call errp('Illegal or undefined "*'//
     &       char(-ichr)//'" command in SEP!')
            sepl=sepl+1
            sep(sepl:sepl)=chr
            goto 102
 103        continue
         else
            sepl=1
            sep(1:1)=' '
         endif
      else
         if(argmx.ge.9)call errp('SEP without FIELD!')
      endif

c     open the file with menu items
      if(fil(1:fill).eq.'-')
     & call errp('INPUT menu must have an OUTPUT file!')
      do 105 i=fill,2,-1
         extl=i
         if(fil(i:i).eq.'.')goto 107
         if(fil(i:i).eq.dd)goto 106
 105  continue
 106  call errp('OUTPUT file extension not located!')
 107  open(1,file=fil(2:extl)//'lst',status='old',err=950)
c     read the menu items
      sitlmx=0
      s=0
 110  read(1,15,end=190,err=960)tmplin(1:256)
c     initialize the menu item limits
      i1=1
      i2=256
c     get rid of trailing spaces
      do 120 i=256,1,-1
         if(tmplin(i:i).gt.' ')goto 121
         i2=i-1
 120  continue
      call errr('There is a blank item in the menu list!')
c     restrict to any requested field(s)
 121  if(fld.ne.0)then
         fld2=1
         if(fld2.eq.abs(fld) .and. fld.lt.0)goto 131
         do 130 i=i2,1,-1
            if(index(sep(1:sepl),tmplin(i:i)).le.0)goto 130
            fld2=fld2+1
            if(fld2.gt.abs(fld))then
               i1=i+1
               goto 131
            endif
            i2=i-1
            if(fld2.eq.abs(fld) .and. fld.lt.0)goto 131
 130     continue
c        ignore lines that do not have that many fields???
         if(fld2.lt.abs(fld))goto 110
 131     continue
      endif
c     ignore empty fields???
      if(i2-i1+1.le.0)goto 110
      if(i2-i1+1.gt.79)
     & call errr('An item in the menu list is too long!')
      if(tmplin(i1:i2).eq.' ')call errr('Blank menu item!')
      s=s+1
      if(s.gt.sdim)call errr('Too many menu items!')
      sitl(s)=i2-i1+1
      sitlmx=max(sitlmx,i2-i1+1)
      sit(s)=tmplin(i1:i2)
      goto 110
 190  close(1,err=970)
      smax=s
      if(smax.lt.1)call errr('No menu items to select!')

c     number of menus
      menumx=(smax+51-1)/51
      if(menumx.gt.9)call errr('Too many menus!')

c     create the prompt
      if(typc.ne.0)then
         prompl=typl
         if(prompl.gt.76)call errp('TYPE is too long!')
         prompt=typ(1:typl)
      else if(menumx.gt.1)then
         prompl=typl+21+16
         if(prompl.gt.76)call errp('TYPE is too long!')
         prompt='Press the key of the '//typ(1:typl)//' (or Space or ?)'
      else
         prompl=typl+21+12
         if(typl+21+16.gt.76)call errp('TYPE is too long!')
         prompt='Press the key of the '//typ(1:typl)//' (or ? or q)'
      endif

c     initialize
      menu=1

c     create the current menu
 200  defkey=' '
      s=(menu-1)*51
      key=0
      asc=asca
      if(smax.gt.35)then
         menoff=1
         menl=25
      else if(smax.gt.17)then
         menoff=1
         menl=38
      else
         menoff=max(1,(80-3-sitlmx)/2)
         menl=79-menoff
      endif
      do 210 l=1,18
         lin(l)=' '
         s=s+1
         if(s.le.smax)then
            key=key+1
            keys(key)=s
            keychr(key:key)=char(asc)
            if(sit(s)(1:sitl(s)).eq.def(1:defl))defkey=char(asc)
            lin(l)(menoff+1:menoff+3)=char(asc)//': '
            lin(l)(menoff+4:menoff+menl)=sit(s)
            if(asc.ge.asca)then
               asc=asc-32
            else
               asc=asc+32+1
            endif
            if(asc.eq.ichar('q'))asc=asc-32
         endif
 210  continue
      if(smax.gt.35)then
         menoff=27
      else if(smax.gt.17)then
         menoff=40
      endif
      do 220 l=1,18
         s=s+1
         if(s.le.smax)then
            key=key+1
            keys(key)=s
            keychr(key:key)=char(asc)
            if(sit(s)(1:sitl(s)).eq.def(1:defl))defkey=char(asc)
            lin(l)(menoff+1:menoff+3)=char(asc)//': '
            lin(l)(menoff+4:menoff+menl)=sit(s)
            if(asc.ge.asca)then
               asc=asc-32
            else
               asc=asc+32+1
            endif
            if(asc.eq.ichar('q'))asc=asc-32
         endif
 220  continue
      if(smax.gt.35)then
         menoff=53
      endif
      do 230 l=1,15
         s=s+1
         if(s.le.smax)then
            key=key+1
            keys(key)=s
            keychr(key:key)=char(asc)
            if(sit(s)(1:sitl(s)).eq.def(1:defl))defkey=char(asc)
            lin(l)(menoff+1:menoff+3)=char(asc)//': '
            lin(l)(menoff+4:menoff+menl)=sit(s)
            if(asc.ge.asca)then
               asc=asc-32
            else
               asc=asc+32+1
            endif
            if(asc.eq.ichar('q'))asc=asc-32
         endif
 230  continue
      if(menumx.gt.1)then
         if(menu.gt.1)then
            lin(16)(menoff+1:79)='1: first screen'
            key=key+1
            keys(key)=0
            keychr(key:key)='1'
         else
            lin(16)(menoff+1:79)='-- first screen'
         endif
         lin(17)(menoff+1:79)=' : next screen'
         key=key+1
         keys(key)=0
         keychr(key:key)=' '
         do 240 i=2,menumx
            if(i.eq.menu)goto 240
            key=key+1
            keys(key)=0
            keychr(key:key)=char(i+48)
 240     continue
      endif
      lin(18)(menoff+1:79)='q: quit'
      key=key+1
      keys(key)=0
      keychr(key:key)='q'
      key=key+1
      keys(key)=0
      keychr(key:key)='?'
      keymax=key

c     write the menu
      i1=3
      print10,(' ',i=1,i1)
      print20,('=',i=1,79)
      if(menumx.eq.1)then
         print10,'                               AVAILABLE CHOICES'
      else
         print10,'                        AVAILABLE CHOICES, PAGE '//
     &    char(menu+48)//' OF '//char(menumx+48)
      endif
      print10
      do 290 l=1,18
         if(l.gt.smax .and. l.ne.18)goto 290
         do 250 i=79,1,-1
            if(lin(l)(i:i).gt.' ')then
               print10,lin(l)(1:i)
               goto 290
            endif
 250     continue
         print10
 290  continue
      print10
      if(menumx.gt.1)then
         print10,'Press Space for more choices, ? for help, q to '//
     &    'quit. Keys are *case sensitive*.'
      else
         print10,'Press ? for help or q to quit. Please note that '//
     &    'keys are *case sensitive*.'
      endif

c     get the response by the user
      line=prompt(1:prompl)//': '//defkey
      call inkey(4,keychr(1:keymax),line,chr)

c     process it
      if(chr.eq.'q')goto 890
      if(chr.eq.'?')then
         print10,'To choose an item from the above list, '//
     &    'press its key (a or A or b or B, ...).'
         if(menumx.gt.1)print10,'To see more possible choices, press '//
     &    'the space bar or a digit from 1 to '//char(menumx+48)//'.'
         print10,'Or press the q key to quit and abort what you are '//
     &    'doing.'
         if(helpl.le.0)then
            line=
     &       'Press c to continue with menu selection or q to quit: c'
            call inkey(5,'cq',line,chr)
         else
            line='Press ? for more help, c to continue with menu '//
     &       'selection, or q to quit: c'
 295        call inkey(5,'?cq',line,chr)
            if(chr.eq.'?')then
               if(help(1:1).eq.'*')then
                  call system(help(2:helpl),istat)
               else
                  call type(help(2:helpl))
               endif
               line='Press ? to repeat, c to continue with menu '//
     &          'selection, or q to quit: c'
               goto 295
            endif
         endif
         if(chr.eq.'q')goto 890
         goto 200
      endif
      if(chr.eq.' ')then
         menu=menu+1
         if(menu.gt.menumx)menu=1
         goto 200
      endif
      if(chr.ge.'1' .and. chr.le.'9')then
         menu=min(menumx,ichar(chr)-48)
         goto 200
      endif
      key=index(keychr(1:keymax),chr)
      if(key.le.0)call erri('295')
      s=keys(key)
      if(s.lt.1 .or. s.gt.smax)call erri('296')

c     copy the selection text and go output it
      sstl(0)=sitl(s)
      sst(0)(1:sstl(0))=sit(s)(1:sitl(s))
      if(intmax.ne.0)then
         sstl(ssdim)=intmax
         if(intmax.lt.0)sstl(ssdim)=min(sstl(0),-intmax)
         sst(ssdim)(1:sstl(ssdim))=sst(0)(1:sstl(0))
      endif

c     go output the result
      goto 800

c color task

c     jump-to point
 300  continue

c     check number of arguments
      if(argmx.gt.6)goto 990

c     convert the default to capital hex digits and check
      if(havdef.ne.0)then
         if(defl.ne.6)call errp(
     &    'Any DEFAULT color must be a six digit HEX string!')
         do 310 i=1,6
            if(def(i:i).ge.'a' .and. def(i:i).le.'z')
     &       def(i:i)=char(ichar(def(i:i))-32)
            if(index(hex,def(i:i)).le.0)call errp(
     &       'Any DEFAULT color must be a six digit HEX string!')
 310     continue
      endif

c     create prompt
      if(typc.ne.0)then
         prompl=typl
         if(prompl.gt.66)call errp('TYPE is too long!')
         prompt=typ(1:typl)
      else
         prompl=22+typl
         if(prompl.gt.66)call errp('TYPE is too long!')
         prompt='Enter the '//typ(1:typl)//' (or q or ?)'
      endif

c     ask for the color
 320  call askcol(helpl,prompt(1:prompl),def(1:defl),color)

c     user quit
      if(color.eq.'q')goto 890

c     user asked for external help
      if(color.eq.'?')then
 330     if(help(1:1).eq.'*')then
            call system(help(2:helpl),istat)
         else
            call type(help(2:helpl))
         endif
         line='Press ? to repeat, c to continue with color '//
     &    'entry, or q to quit: c'
         call inkey(5,'?cq',line,chr)
         if(chr.eq.'q')goto 890
         if(chr.eq.'c')goto 320
         goto 330
      endif

c     define selection
      sstl(0)=6
      sst(0)(1:6)=color

c     go output the result
      goto 800

c folder task

c     jump-to point
 400  continue

c     check number of arguments
      if(argmx.gt.6)goto 990

c     clean up the default
      if(havdef.ne.0)then
         call clnfol(dd,nl,nll,def,defl,icolon,istat)
         if(istat.eq.-1 .and. dd.eq.'/')
     &    call errp('DEFAULT path must be an absolute one!')
         if(istat.eq.-1 .and. dd.ne.'/')call errp(
     &    'DEFAULT path must be an absolute one with disk!')
         if(istat.eq.-2)
     &    call errp('Nonexisting .. folder in the DEFAULT path!')
         if(istat.gt.0)then
            chr=def(istat:istat)
            if(chr.lt.' ' .or. chr.eq.char(127))chr='?'
            call encint(istat,cvall,cval)
            call errp('Character '//cval(1:cvall)//', "'//
     &       chr//'", in DEFAULT path is illegal!')
         endif
         if(defl.le.icolon)then
            defl=icolon+1
            def(defl:defl)=dd
         endif
      endif

c     create prompt
      if(typc.eq.0)then
         prompl=22+typl
         prompt='Enter the '//typ(1:typl)//' (or q or ?)'
      else
         prompl=typl
         prompt=typ(1:typl)
      endif
      if(prompl+2+defl.gt.79)
     & call errp('TYPE is too long!')

c     ask the user
      goto 420
 419  call out('   Please reenter the folder path, or enter ? for '//
     & 'help, or q to quit')
 420  line=prompt(1:prompl)//': '//def(1:defl)
      call in2(line,linel)

c     user quit
      if(line(1:linel).eq.'q')goto 890

c     user asked for external help
      if(index(line(1:linel),'??').ne.0 .and. helpl.gt.0)then
 430     if(help(1:1).eq.'*')then
            call system(help(2:helpl),istat)
         else
            call type(help(2:helpl))
         endif
         line='Press ? to repeat, c to continue with folder '//
     &    'entry, or q to quit: c'
         call inkey(5,'?cq',line,chr)
         if(chr.eq.'q')goto 890
         if(chr.eq.'c')goto 420
         goto 430
      endif

c     user asked for basic help
      if(index(line(1:linel),'?').ne.0)then
         print10,
     &    ' ',
     &    '                    BASIC HELP ON SPECIFYING FOLDER PATHS',
     &    ' '
         if(dd.eq.'/')then
            print10,
     &       'Some example Unix folder paths are:',
     &       '    /                      '//
     &       '(everything is inside this folder)',
     &       '    /bin                   '//
     &       '(where some basic program files are)',
     &       '    /usr/bin               '//
     &       '(where some other program files are)',
     &       '    /usr/local/bin         '//
     &       '(where some other program files are)',
     &       '    /home/username         '//
     &       '(the folder of the user with user name "username")',
     &       'The general format is',
     &       '    /subfolder/subfolder/.../subfolder',
     &       'Each subfolder is inside the previous one.  So in the '//
     &       'example /home/username,',
     &       'the username folder is inside the home folder, which '//
     &       'is in turn inside the /',
     &       'top system folder.  And any subfolders that user '//
     &       'username creates inside his',
     &       'or her HOME folder are inside username.',
     &       ' ',
     &       'To find the path specification of a folder, one way is '//
     &       'to open "File System"',
     &       'and browse down to the desired folder, keeping note of '//
     &       'the names of',
     &       'the folders that you enter on the way down.  Then '//
     &       'enter it at the prompt',
     &       'with each (sub)folder name preceded by a slash as above.'
         else
            print10,
     &       'Some example Windows folder paths are:',
     &       '    C:\\                           '//
     &       '(the main system hard disk)',
     &       '    C:\\Program Files              '//
     &       '(where the usual program files are)',
     &       '    C:\\Program Files (x86)        '//
     &       '(where older program files are)',
     &       '    C:\\Windows                    '//
     &       '(where the basic Windows files are)',
     &       '    C:\\Windows\\System32           '//
     &       '(where the usual Windows system files are)',
     &       'The general format is',
     &       '   D:\\subfolder\\subfolder\\...\\subfolder',
     &       'Here D is a "disk letter".  Look in "My Computer" '//
     &       'for what disk letters your',
     &       'computer has besides C.  Each subfolder is inside '//
     &       'the previous one.  So in',
     &       'the example C:\\Windows\\System32, the System32 folder '//
     &       'is inside the Windows',
     &       'folder which is in turn inside the top C disk folder.',
     &       ' ',
     &       'To find the path specification of a folder, one way '//
     &       'is to open "My Computer"',
     &       'and browse down to the desired folder.  Then right-'//
     &       'click a plain file in the',
     &       'folder and select "Properties".  The shown "Location" '//
     &       'of the file should be',
     &       'what you need to enter behind the prompt here.  '//
     &       'Alternatively, just keep',
     &       'track of the names of the folder that you enter going '//
     &       'down.  Those are the',
     &       'successive subfolders in the generic path format above.'
         endif
         if(helpl.gt.0)print10,'For further information, enter a '//
     &    'double question mark.'
         print10,'To quit, and abort what you are doing, enter a q.'
         print10
         goto 420
      endif

c     check the folder specification for sanity
      if(dd.eq.'/')then
         if(line(1:1).ne.'/')then
            call out('** a folder path must start with a /.')
            goto 419
         endif
      else
         if(line(1:1).ge.'a' .and. line(1:1).le.'z')
     &    line(1:1)=char(ichar(line(1:1))-32)
         if(linel.lt.3 .or. line(1:1).lt.'A' .or. line(1:1).gt.'Z'
     &    .or. line(2:2).ne.':' .or. line(3:3).ne.'\\')then
            call out('** a folder path must start with a disk letter '//
     &       'followed by a : followed by a \\.')
            goto 419
         endif
      endif
      if(index(line(1:linel),dd//dd).ne.0)then
         call out('** Please do not double '//dd//
     &    'in the folder path.  Enter ? for help.')
         goto 419
      endif

c     remove any final divider
      if(line(linel:linel).eq.dd)linel=linel-1

c     see whether the folder exists
      inquire(file=line(1:linel)//dd//'.',exist=exists)
      if(.not.exists)then
         call out('** The entered folder does not exist.  (Or you '//
     &    'have no privileges to look in')
         call out('   it.)   Check for typos and for your access to '//
     &    'the folder.')
         goto 419
      endif

c     add a trailer to the top folder
      if(dd.eq.'/')then
         if(linel.eq.0)then
            linel=2
            line(1:2)='/.'
         endif
      else
         if(linel.eq.2)then
            linel=4
            line(3:4)='\\.'
         endif
      endif

c     go output the result
      sstl(0)=linel
      sst(0)(1:linel)=line(1:linel)
      goto 800

c number task

c     jump-to point
 500  continue

c     check number of arguments
      if(argmx.gt.8)goto 990

c     determine DEFAULT
      if(havdef.ne.0)then
         i=0
         call rdint(def,defl,i,intdef,istat)
         if(istat.ne.0 .or. i.ne.defl)
     &    call errp('Invalid DEFAULT value!')
      endif

c     determine MAX
      cmaxl=argtl(7)
      if(cmaxl.gt.0)then
         if(cmaxl.gt.76)call errp('MAX is too long!')
         cmax=argt(7)(1:cmaxl)
         i=0
         call rdint(cmax,cmaxl,i,intmax,istat)
         if(istat.ne.0 .or. i.ne.cmaxl)
     &    call errp('Invalid MAX value!')
         if(havdef.ne.0 .and. intmax.lt.intdef)
     &    call errp('DEFAULT value is too high!')
      endif

c     determine MIN
      cminl=argtl(8)
      if(cminl.gt.0)then
         if(cminl.gt.76)call errp('MIN is too long!')
         cmin=argt(8)(1:cminl)
         i=0
         call rdint(cmin,cminl,i,intmin,istat)
         if(istat.ne.0 .or. i.ne.cminl)
     &    call errp('Invalid MIN value!')
         if(havdef.ne.0 .and. intmin.gt.intdef)
     &    call errp('DEFAULT value is too low!')
         if(cmaxl.gt.0 .and. intmin.gt.intmax)
     &    call errp('MIN exceeds MAX!')
      endif

c     create prompt
      if(typc.eq.0)then
         prompl=22+typl
         prompt='Enter the '//typ(1:typl)//' (or q or ?)'
      else
         prompl=typl
         prompt=typ(1:typl)
      endif
      if(prompl+2+max(1,defl,cmaxl,cminl).gt.79)
     & call errp('TYPE is too long!')

c     ask the user
      goto 520
 519  call out('   Please reenter the number, or enter ? for '//
     & 'help, or q to quit')
 520  line=prompt(1:prompl)//': '//def(1:defl)
      call in2(line,linel)

c     refuse blank inputs
      if(line(1:linel).eq.' ')then
         call out('** The number cannot be blank.')
         goto 519
      endif

c     user quit
      if(line(1:linel).eq.'q')goto 890

c     user asked for external help
      if(index(line(1:linel),'??').ne.0 .and. helpl.gt.0)then
 530     if(help(1:1).eq.'*')then
            call system(help(2:helpl),istat)
         else
            call type(help(2:helpl))
         endif
         line='Press ? to repeat, c to continue with number '//
     &    'entry, or q to quit: c'
         call inkey(5,'?cq',line,chr)
         if(chr.eq.'q')goto 890
         if(chr.eq.'c')goto 520
         goto 530
      endif

c     user asked for basic help
      if(index(line(1:linel),'?').ne.0)then
         print10,
     &    ' ',
     &    'Please enter a whole number here without spaces, commas, '//
     &    'or points.'
         if(cminl.gt.0)print10,
     &    'The number that you enter must be at least '//cmin(1:cminl)
         if(cmaxl.gt.0)print10,
     &    'The number that you enter can be at most '//cmax(1:cmaxl)
         if(havdef.ne.0)print10,'The default value is '//def(1:defl)
         if(helpl.gt.0)print10,'For further information, enter a '//
     &    'double question mark.'
         print10,'To quit, and abort what you are doing, enter a q.'
         print10
         goto 520
      endif

c     check the validity of the number
      call readiv('** ',line,1,linel,intsel,istat)
      if(istat.ne.0)goto 519
      if(cminl.gt.0 .and. intsel.lt.intmin)then
         call out('** The number must be at least '//cmin(1:cminl))
         goto 519
      endif
      if(cmaxl.gt.0 .and. intsel.gt.intmax)then
         call out('** The number cannot exceed '//cmax(1:cmaxl))
         goto 519
      endif

c     go output the result
      sstl(0)=linel
      sst(0)(1:linel)=line(1:linel)
      goto 800

c string task

c     jump-to point
 550  continue

c     check number of arguments
      if(argmx.gt.8)goto 990

c     determine MAX
      cmaxl=argtl(7)
      if(cmaxl.gt.0)then
         if(cmaxl.gt.76)call errp('MAX is too long!')
         cmax=argt(7)(1:cmaxl)
         i=0
         call rdint(cmax,cmaxl,i,intmax,istat)
         if(istat.ne.0 .or. i.ne.cmaxl)
     &    call errp('Invalid MAX value!')
         if(havdef.ne.0 .and. intmax.lt.defl)
     &    call errp('DEFAULT is too long!')
      endif

c     determine MIN
      cminl=argtl(8)
      intmin=0
      if(cminl.gt.0)then
         if(cminl.gt.76)call errp('MIN is too long!')
         cmin=argt(8)(1:cminl)
         i=0
         call rdint(cmin,cminl,i,intmin,istat)
         if(istat.ne.0 .or. i.ne.cminl)
     &    call errp('Invalid MIN value!')
         if(havdef.ne.0 .and. intmin.gt.defl)
     &    call errp('DEFAULT is too short!')
         if(cmaxl.gt.0 .and. intmin.gt.intmax)
     &    call errp('MIN exceeds MAX!')
      endif

c     create prompt
      if(typc.eq.0)then
         prompl=22+typl
         prompt='Enter the '//typ(1:typl)//' (or q or ?)'
      else
         prompl=typl
         prompt=typ(1:typl)
      endif
      i=intmin
      if(cmaxl.gt.0)i=max(i,intmax)
      if(prompl+2+max(defl,i).gt.79)
     & call errp('TYPE and/or MIN and/or MAX are too long!')

c     ask the user
      goto 570
 569  call out('   Please reenter, or enter ? for help, or q to quit')
 570  if(intmin.gt.0)then
         line=prompt(1:prompl)//': '//def(1:defl)
      else
         line=prompt(1:prompl)//':?'//def(1:defl)
      endif
      call in2(line,linel)

c     user quit
      if(line(1:linel).eq.'q')goto 890

c     user asked for external help
      if(line(1:linel).eq.'??' .and. helpl.gt.0)then
 580     if(help(1:1).eq.'*')then
            call system(help(2:helpl),istat)
         else
            call type(help(2:helpl))
         endif
         line='Press ? to repeat, c to continue with text string '//
     &    'entry, or q to quit: c'
         call inkey(5,'?cq',line,chr)
         if(chr.eq.'q')goto 890
         if(chr.eq.'c')goto 570
         goto 580
      endif

c     user asked for basic help
      if(line(1:linel).eq.'?')then
         print10,
     &    ' ',
     &    'Please enter a string here here.  Do not use tabs or '//
     &    'other control characters.'
         if(intmin.gt.0)print10,
     &    'The string that you enter must be at least '//
     &    cmin(1:cminl)//' characters long.'
         if(cmaxl.gt.0)print10,
     &    'The string that you enter can be at most '//
     &    cmax(1:cmaxl)//' characters long.'
         if(havdef.ne.0)
     &    print10,'The default string is "'//def(1:defl)//'"'
         if(helpl.gt.0)print10,'For further information, enter a '//
     &    'double question mark.'
         print10,'To quit, and abort what you are doing, enter a q.'
         print10
         goto 570
      endif

c     check the validity of the string
      if(linel.lt.intmin)then
         call out('** The string must be at least '//cmin(1:cminl)//
     &    ' characters long.')
         goto 569
      endif
      if(cmaxl.gt.0 .and. linel.gt.intmax)then
         call out('** The string cannot exceed '//cmax(1:cmaxl)//
     &    'characters in length.')
         goto 569
      endif
      i2=0
      do 590 i=1,linel
         asc=ichar(line(i:i))
         if(asc.ge.32 .and. asc.ne.127)goto 590
         i2=i2+1
         line(i:i)='?'
 590  continue
      if(i2.gt.0)then
         if(i2.eq.1)then
            call out('** The string you entered contains '//
     &       'an illegal character indicated by "?":')
         else
            call encint(i2,cvall,cval)
            call out('** The string you entered contains '//
     &       cval(1:cvall)//' illegal characters indicated by "?":')
         endif
         print10,'   '//line(1:linel)
         goto 569
      endif

c     go output the result
      sstl(0)=linel
      sst(0)(1:linel)=line(1:linel)
      goto 800

c value task

c     jump-to point
 600  continue

c     check number of arguments
      if(argmx.gt.8)goto 990

c     determine DEFAULT
      if(havdef.ne.0)then
         call readrv('*** asku '//inind//': ',def,1,defl,fltdef,istat)
         if(istat.ne.0)
     &    call out('   Program error: Invalid DEFAULT value!')
      endif

c     determine MAX
      cmaxl=argtl(7)
      excmax=0
      if(cmaxl.gt.0)then
         if(argt(7)(cmaxl:cmaxl).eq.'x')then
            excmax=1
            cmaxl=cmaxl-1
         endif
         if(cmaxl.gt.76)call errp('MAX is too long!')
         cmax=argt(7)(1:cmaxl)
         call readrv('*** asku '//inind//': ',cmax,1,cmaxl,fltmax,istat)
         if(istat.ne.0)call out('    Program error: Invalid MAX value!')
         if(havdef.ne.0 .and. fltmax.lt.fltdef)
     &    call errp('DEFAULT value is too high!')
         if(havdef.ne.0 .and. fltmax.eq.fltdef .and. excmax.ne.0)
     &    call errp('DEFAULT value is too high!')
      endif

c     determine MIN
      cminl=argtl(8)
      excmin=0
      if(cminl.gt.0)then
         if(argt(8)(cminl:cminl).eq.'x')then
            excmin=1
            cminl=cminl-1
         endif
         if(cminl.gt.76)call errp('MIN is too long!')
         cmin=argt(8)(1:cminl)
         call readrv('*** asku '//inind//': ',cmin,1,cminl,fltmin,istat)
         if(istat.ne.0)call out('    Program error: Invalid MIN value!')
         if(havdef.ne.0 .and. fltmin.gt.fltdef)
     &    call errp('DEFAULT value is too low!')
         if(havdef.ne.0 .and. fltmin.eq.fltdef .and. excmin.ne.0)
     &    call errp('DEFAULT value is too low!')
         if(cmaxl.gt.0 .and. fltmin.gt.fltmax)
     &    call errp('MIN exceeds MAX!')
         if(cmaxl.gt.0 .and. fltmin.eq.fltmax .and. excmin+excmax.ne.0)
     &    call errp('MIN exceeds MAX!')
      endif

c     create prompt
      if(typc.eq.0)then
         prompl=22+typl
         prompt='Enter the '//typ(1:typl)//' (or q or ?)'
      else
         prompl=typl
         prompt=typ(1:typl)
      endif
      if(prompl+2+max(1,defl,cmaxl,cminl).gt.79)
     & call errp('TYPE is too long!')

c     ask the user
      goto 620
 619  call out('   Please reenter the value, or enter ? for '//
     & 'help, or q to quit')
 620  line=prompt(1:prompl)//': '//def(1:defl)
      call in2(line,linel)

c     refuse blank inputs
      if(line(1:linel).eq.' ')then
         call out('** The value cannot be blank.')
         goto 619
      endif

c     user quit
      if(line(1:linel).eq.'q')goto 890

c     user asked for external help
      if(index(line(1:linel),'??').ne.0 .and. helpl.gt.0)then
 630     if(help(1:1).eq.'*')then
            call system(help(2:helpl),istat)
         else
            call type(help(2:helpl))
         endif
         line='Press ? to repeat, c to continue with number '//
     &    'entry, or q to quit: c'
         call inkey(5,'?cq',line,chr)
         if(chr.eq.'q')goto 890
         if(chr.eq.'c')goto 620
         goto 630
      endif

c     user asked for basic help
      if(index(line(1:linel),'?').ne.0)then
         print10,
     &    ' ',
     &    'Please enter a valid number here without spaces or commas '//
     &    '(decimal point OK).'
         if(cminl.gt.0 .and. excmin.eq.0)print10,
     &    'The number that you enter must be at least '//cmin(1:cminl)
         if(cminl.gt.0 .and. excmin.ne.0)print10,
     &    'The number that you enter must be more than '//cmin(1:cminl)
         if(cmaxl.gt.0 .and. excmax.eq.0)print10,
     &    'The number that you enter can be at most '//cmax(1:cmaxl)
         if(cmaxl.gt.0 .and. excmax.ne.0)print10,
     &    'The number that you enter must be less than '//cmax(1:cmaxl)
         if(havdef.ne.0)print10,'The default value is '//def(1:defl)
         if(helpl.gt.0)print10,'For further information, enter a '//
     &    'double question mark.'
         print10,'To quit, and abort what you are doing, enter a q.'
         print10
         goto 620
      endif

c     check the validity of the number
      call readrv('** ',line,1,linel,fltsel,istat)
      if(istat.ne.0)goto 619
      if(cminl.gt.0 .and. fltsel.lt.fltmin .and. excmin.eq.0)then
         call out('** The number must be at least '//cmin(1:cminl))
         goto 619
      endif
      if(cminl.gt.0 .and. fltsel.le.fltmin .and. excmin.ne.0)then
         call out('** The number must be more than '//cmin(1:cminl))
         goto 619
      endif
      if(cmaxl.gt.0 .and. fltsel.gt.fltmax .and. excmax.eq.0)then
         call out('** The number cannot exceed '//cmax(1:cmaxl))
         goto 619
      endif
      if(cmaxl.gt.0 .and. fltsel.ge.fltmax .and. excmax.ne.0)then
         call out('** The number must be less than '//cmax(1:cmaxl))
         goto 619
      endif

c     go output the result
      sstl(0)=linel
      sst(0)(1:linel)=line(1:linel)
      goto 800

c Read and output input lines according to instructions

c     jump-to point
 700  continue

c     determine what line must be located
      if(ipltsk.eq.'l')then
         iplloc=iplcur
      else if(ipltsk.eq.'c' .or. ipltsk.eq.'f' .or. ipltsk.eq.'n')then
         iplloc=iplcur+1
      else if(ipltsk.eq.'p')then
         if(iplcur.le.0)goto 740
         iplloc=iplcur-1
      else
         call erri('700')
      endif

c     locate line iplloc absolutely
      iplget=1234567890
      if(iplloc.lt.0 .and. ipleof.le.0)goto 750
      if(iplloc.lt.0)goto 740
      if(iplloc.gt.ipleof .and. ipleof.gt.0)goto 740
      iplget=iplloc
      if(iplloc.gt.abs(ipleof))goto 750
      if(labipb(labmax).ge.0)then
         if(iplloc.lt.labipb(labmax))goto 740
      else
         if(iplloc.lt.abs(ipleof)+1+labipb(labmax))goto 740
         iplget=iplloc-labipb(labmax)
         goto 750
      endif
      if(labipr(labmax).eq.0)then
         if(iplloc.gt.labipe(labmax))goto 740
      else
         iplget=iplloc-1-labipe(labmax)
         if(iplloc.gt.abs(ipleof)+1+labipe(labmax))goto 750
      endif
      if(ipltsk.eq.'l')goto 745

c     copy the next line to the output and advance
      if(ipltsk.ne.'c' .and. ipltsk.ne.'f')goto 720
      iplget=iplcur+1
      if(iplget.lt.iplmin)goto 751
      if(iplget.gt.iplmax)goto 750
      iplr=mod(iplcur,iplsiz)
      ipc1=iplbuf(iplr)
      iplr=iplr+1
      if(iplr.ge.iplsiz)iplr=0
      ipc2=iplbuf(iplr)
      if(ipc2.ge.ipc1+nll .and. ipltsk.eq.'f')then
         do 710 i=1,nll
            if(ipcbuf(mod(ipc2-nll+i,ipcsiz)).ne.nl(i:i))goto 711
 710     continue
         ipc2=ipc2-nll
 711     continue
      endif
      ipcr=mod(ipc1,ipcsiz)
      do 715 ipc=ipc1+1,ipc2
         ipcr=ipcr+1
         if(ipcr.ge.ipcsiz)ipcr=0
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    ipcbuf(ipcr),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
 715  continue
      iplcur=iplcur+1
      goto 745

c     check the next line for the search string and advance if not found
 720  if(ipltsk.ne.'n')goto 730
      iplget=iplcur+1
      if(iplget.lt.iplmin)goto 751
      if(iplget.gt.iplmax)goto 750
      iplr=mod(iplcur,iplsiz)
      ipc1=iplbuf(iplr)
      iplr=iplr+1
      if(iplr.ge.iplsiz)iplr=0
      ipc2=iplbuf(iplr)
      call fndit(ipcsiz,ipcbuf,ipc1,ipc2,fnddim,fndmax,fnddat,
     & fndbeg,fndend,parmax,istat)
      if(istat.ne.0)iplcur=iplcur+1
      goto 745

c     check the previous line for the search string and back up if not found
 730  if(ipltsk.ne.'p')call erri('730')
      iplget=iplcur
      if(iplget.lt.iplmin)goto 751
      if(iplget.gt.iplmax)goto 750
      iplr=mod(iplcur-1,iplsiz)
      ipc1=iplbuf(iplr)
      iplr=iplr+1
      if(iplr.ge.iplsiz)iplr=0
      ipc2=iplbuf(iplr)
      call fndit(ipcsiz,ipcbuf,ipc1,ipc2,fnddim,fndmax,fnddat,
     & fndbeg,fndend,parmax,istat)
      if(istat.ne.0)iplcur=iplcur-1
      goto 745

c     on failure, mark it and skip to the end of the current loop
 740  if(iplufg.ne.0)then
         iplufg=0
         goto 745
      endif
      labfin(labmax)=1
      tmpi=labend(labmax)
      goto 810

c     update labipc and return to caller
 745  labipc(labmax)=iplcur
      if(iret.eq.810)goto 810
      if(iret.eq.840)goto 840
      if(iret.eq.861)goto 861
      if(iret.eq.863)goto 863
      call erri('745')

c     read the input up to line iplget or to eof
 750  goto 752
c     reopen the input file before reading in iplget, but read EOF first
 751  if(task.eq.tsksti)then
         call out('*** asku '//inind//
     &    ': The available input storage is too small.')
         call out(
     &    '    Put the input to asku in a file instead of a pipe.')
         call out(
     &    '    Or increase the asku input storage and remake it')
         call out('    Must abort now!')
      endif
      if(task.ne.tskfil)call erri('751')
      if(ipleof.lt.0)then
         iplget=1234567890
         goto 752
      endif
      close(iunit,err=940)
      iunit=0
c     read the input up to line iplget or to eof
 752  if(iunit.eq.0)then
         if(task.eq.tsksti)then
            iunit=5
         else if(task.eq.tskfil)then
            iunit=4
            if(argtl(1).lt.2)call errr('752')
            open(iunit,file=argt(1)(2:argtl(1)),
     &       status='old',form='unformatted',err=920)
         else
            call errp(
     &       'INPUT must be "-" or "?FILE" for *c, *n, and *pp/!')
         endif
         ipcmax=0
         ipcmxr=0
         ipcmin=0
         ipcbuf(0)=char(10)
         iplmax=0
         iplmxr=0
         iplmin=1
         iplmnr=1
         iplbuf(0)=0
      endif
c     remember the previous characters in the buffer
      ipcmx0=ipcmax
c     next line
 760  continue
c     see whether done
      if(iplget.le.iplmax)goto 795
      if(ipleof.gt.0 .and. iplmax.ge.ipleof)goto 795
c     read the next character from the input file
 770  if(iunit.eq.5)goto 775
      call fgetc(iunit,chr,istat)
      if(istat.eq.-1)goto 790
      if(istat.ne.0)goto 930
      goto 780
c     read the next character from standard input
 775  if(sti.ge.still .and. stieof.eq.0)then
         stil(1:trunci)=' '
         read(iunit,10,err=910,end=776)stil(1:trunci)
         goto 777
 776     stieof=1
 777     i1=trunci
         do 778 i=i1,1,-1
            if(stil(i:i).ne.' ')goto 779
            i1=i-1
 778     continue
 779     if(stieof.eq.0)then
            stil(i1+1:i1+nll)=nl(1:nll)
            i1=i1+nll
         endif
         still=i1
         sti=0
      endif
      sti=sti+1
      if(sti.gt.still)goto 790
      chr=stil(sti:sti)
c     store the character
 780  ipcmax=ipcmax+1
      ipcmxr=ipcmxr+1
      if(ipcmxr.ge.ipcsiz)ipcmxr=ipcmxr-ipcsiz
      ipcbuf(ipcmxr)=chr
 785  if(chr.eq.char(10))then
         iplmax=iplmax+1
         if(iplmax.ge.1234567890)
     &    call errr('Too many lines of input!')
         if(ipleof.lt.0)ipleof=min(ipleof,-iplmax-1)
         i=iplmxr
         iplmxr=iplmxr+1
         if(iplmxr.ge.iplsiz)iplmxr=iplmxr-iplsiz
         iplbuf(iplmxr)=ipcmax
         if(iplbuf(iplmxr)-iplbuf(i).ge.ipcsiz)
     &    call errr('Input line too long for buffer!')
         goto 760
      endif
c     repeat
      goto 770
c     end of file found, update data
 790  ipleof=iplmax+1
      do 791 lab=0,labmax
         if(labipb(lab).lt.0)labipb(lab)=max(0,ipleof+1+labipb(lab))
         if(labipr(lab).ne.0)labipe(lab)=ipleof+1+labipe(lab)
         labipr(lab)=0
 791  continue
      if(iplcur.lt.0)iplcur=ipleof+1+iplcur
      if(iplloc.lt.0)iplloc=ipleof+1+iplloc
      chr=char(10)
      goto 785
c     find the first line whose previous line is in iplbuf and partly in ipcbuf
 795  if(ipcmax.ne.ipcmx0)then
         ipcmin=max(0,ipcmax-ipcsiz+1)
         iplmin=max(1,iplmin,iplmax-iplsiz+2)
         iplmnr=mod(iplmin,iplsiz)
         i1=iplmnr-1
         if(i1.lt.0)i1=iplsiz-1
 797     if(iplbuf(i1).lt.ipcmin)then
            iplmin=iplmin+1
            i1=iplmnr
            iplmnr=iplmnr+1
            if(iplmnr.ge.iplsiz)iplmnr=0
            goto 797
         endif
      endif
      goto 700

c output template

c     jump-to point
 800  continue
      param='TEMPLATE'
      if(task0.ne.-9)then
         task=task0
         task0=-9
      endif

c     loop over the characters in TEMPLATE
 810  if(tmpijm.gt.0)then
         if(tmpi.eq.tmpij1(tmpijm))tmpi=tmpij2(tmpijm)
         if(tmpi.ge.tmpij1(tmpijm))then
            tmpijm=tmpijm-1
            goto 810
         endif
      endif
      call nxtchr(tmp,tmpl,tmpi,chr,ichr)
      if(ichr.eq.-1)goto 889
      if(ichr.eq.-2)call errp('Incomplete * character!')

c     write if a normal character
      if(ichr.ge.0)then
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    chr,
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         goto 810
      endif

c     new line
      if(chr.eq.';')then
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    nl(1:nll),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         goto 810
      endif

c     user input
      if(chr.eq.'?')then
         if(sstl(0).lt.0)call errp('User input undefined!')
         if(sstl(0).eq.0)goto 810
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    sst(0)(1:sstl(0)),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         goto 810
      endif

c     stored string
      if(chr.eq.'@')then
         call rdint(tmp,tmpl,tmpi,ss,istat)
         tmpi=min(tmpi+1,tmpl)
         if(istat.gt.1 .or. tmp(tmpi:tmpi).ne.'/')
     &    call errp('Bad or incomplete *@.../ command!')
         if(istat.eq.1)ss=ssdim
         if(ss.gt.ssdim)call errp('Nonexisting *@.../ string!')
         if(sstl(ss).lt.0)call errp('Undefined *@.../ string!')
         if(sstl(ss).eq.0)goto 810
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    sst(ss)(1:sstl(ss)),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         goto 810
      endif

c     turn off gathering or keeping
      if(chr.eq.'.')then
         ingth=0
         goto 810
      endif

c     format color
      if(chr.eq.':')then
         if(color.eq.' ')call errp('No color has been entered!')
         tmpi1=tmpi
         tmpi=tmpi-2
         call fndcls(tmp,tmpl,tmpi)
         linel=0
 820     if(tmpi1.ge.tmpi-1)goto 822
         call nxtchr(tmp,tmpl,tmpi1,chr,ichr)
         if(ichr.lt.0)call errp('Invalid character in *:DIV/!')
         linel=linel+1
         if(linel.gt.32)call errp('DIV too long in *:DIV/!')
         line(linel:linel)=chr
         goto 820
 822     sstl(0)=0
         sstl(ssdim)=0
         do 825 i=1,3
            sst(0)(sstl(0)+1:sstl(0)+2)=color(2*i-1:2*i)
            sstl(0)=sstl(0)+2
            write(sst(ssdim)(sstl(ssdim)+1:sstl(ssdim)+5),25)(
     &       index(hex(2:),color(2*i-1:2*i-1))*16
     &       +index(hex(2:),color(2*i:2*i)))/255.
            sstl(ssdim)=sstl(ssdim)+5
            if(sst(ssdim)(sstl(ssdim):sstl(ssdim)).eq.'0')
     &       sstl(ssdim)=sstl(ssdim)-1
            if(sst(ssdim)(sstl(ssdim):sstl(ssdim)).eq.'0')
     &       sstl(ssdim)=sstl(ssdim)-1
            if(sst(ssdim)(sstl(ssdim):sstl(ssdim)).eq.'0')
     &       sstl(ssdim)=sstl(ssdim)-1
            if(sst(ssdim)(sstl(ssdim):sstl(ssdim)).eq.'.')
     &       sstl(ssdim)=sstl(ssdim)-1
            if(i.eq.3)goto 825
            if(linel.gt.0)then
               sst(0)(sstl(0)+1:sstl(0)+linel)=line(1:linel)
               sstl(0)=sstl(0)+linel
               sst(ssdim)(sstl(ssdim)+1:sstl(ssdim)+linel)=line(1:linel)
               sstl(ssdim)=sstl(ssdim)+linel
            endif
 825     continue
         goto 810
      endif

c     next line number
      if(chr.eq.'#')then
         call rdint(tmp,tmpl,tmpi,i,istat)
         tmpi=min(tmpi+1,tmpl)
         if(istat.ge.2 .or. tmp(tmpi:tmpi).ne.'/'
     &    .or. i.lt.0 .or. i.gt.20)
     &    call errp('Invalid *#.../ command parameter!')
         call encint(iplcur+1,cvall,cval)
         if(i.eq.0 .or. i.eq.cvall)then
            call output(
     &       inind,nl,nll,
     &       fil,fill,trunco,
     &       crep,crepl,repmod,
     &       cval(1:cvall),
     &       gthdim,gth,gthl,ingth,
     &       ounit,outcnt)
         else if(i.lt.cvall)then
            call output(
     &       inind,nl,nll,
     &       fil,fill,trunco,
     &       crep,crepl,repmod,
     &       cval(1+cvall-i:cvall),
     &       gthdim,gth,gthl,ingth,
     &       ounit,outcnt)
         else
            line='00000000000000000000'
            call output(
     &       inind,nl,nll,
     &       fil,fill,trunco,
     &       crep,crepl,repmod,
     &       line(1:i-cvall)//cval(1:cvall),
     &       gthdim,gth,gthl,ingth,
     &       ounit,outcnt)
         endif
         goto 810
      endif

c     toggle output character replacement mode or define replacements
      if(chr.eq.'=')then
         if(tmpi.ge.tmpl)call errp('Unterminated *=.../ command!')
         if(tmp(tmpi+1:tmpi+1).eq.'/')then
            repmod=1-repmod
            tmpi=tmpi+1
         else
            call rdrep(nl,nll,tmp,tmpl,tmpi,crep,crepl)
         endif
         goto 810
      endif

c     read the search string
      if(chr.eq.'/')then
         tmpi1=tmpi+1
         tmpi=tmpi-2
         call fndcls(tmp,tmpl,tmpi)
         fndsrc=1
         fndtsl=tmpi-tmpi1
         if(fndtsl.gt.len(fndts))
     &    call errp('*/.../ SEARCH string too long!')
         if(fndtsl.gt.0)fndts(1:fndtsl)=tmp(tmpi1:tmpi-1)
         call
     &    rdfnd(nl,nll,fndts,fndtsl,fnddim,fndmax,fnddat,istat,cstat)
         if(istat.ne.0)call errp(cstat(1:istat))
         fndsrc=1
         goto 810
      endif

c     edit the gather buffer
      if(chr.eq.'(')then
         tmpi=tmpi-2
         tmpi2=tmpi
         call fndcls(tmp,tmpl,tmpi2)
         if(tmp(tmpi+3:tmpi+3).ne.'0')
     &    call errp('Missing 0 in *(0...*) edit command!')
         call edit(inind,dd,nl,nll,cwd,cwdl,tmp,tmpi2,
     &    tmpi,gthdim,gthl,gthbuf)
         goto 810
      endif

c     change input/output
      if(chr.eq.'~')then
         if(tmpi.ge.tmpl)call errp('Unterminated *~.../ command!')
         tmpi=tmpi+1
         tmpi1=tmpi
         arg=index('io',tmp(tmpi1:tmpi1))
         if(arg.le.0)call errp('U in *~U.../ must be i or o!')
         if(tmpi.ge.tmpl)call errp(
     &    'Unterminated *~'//tmp(tmpi:tmpi)//'.../ command!')
         tmpi=tmpi+1
         argtl(arg)=1
         argt(arg)(1:1)=tmp(tmpi:tmpi)
         i=index('-?+g',tmp(tmpi:tmpi))
         if(arg.eq.1 .and. (i.le.0 .or. i.eq.3))
     &    call errp('C in *~iC.../ must be -, ?, or g!')
         if(arg.eq.2 .and. (i.le.0 .or. i.eq.4))
     &    call errp('C in *~oC.../ must be -, ?, or +!')
         if(i.eq.2 .or. i.eq.3)then
            call rdint(tmp,tmpl,tmpi,ss,istat)
            if(istat.eq.1)ss=ssdim
            if(istat.gt.1 .or. ss.lt.0 .or. ss.gt.ssdim)call errp(
     &       'Invalid number in *~'//tmp(tmpi1:tmpi1+1)//'.../!')
            if(sstl(ss).le.0)call errp(
     &       'No file name for *~'//tmp(tmpi1:tmpi1+1)//'.../ command')
            argtl(arg)=1+sstl(ss)
            if(argtl(arg).gt.len(argt(arg)))
     &       call errr('*~.../ file name too long!')
            argt(arg)(2:argtl(arg))=sst(ss)(1:sstl(ss))
         endif
         tmpi=min(tmpi+1,tmpl)
         if(tmp(tmpi:tmpi).ne.'/')
     &    call errp('Unterminated *~.../ command!')
         if(tmp(tmpi1:tmpi1).eq.'i')then
            if(labmax.ne.0)
     &       call errp('Cannot open a new input file inside a loop!')
            if(iunit.ne.0 .and. iunit.ne.5)close(iunit,err=940)
            iunit=0
            if(i.eq.1 .or. i.eq.4)then
               task=tsksti
               argtl(1)=0
            else
               task=tskfil
            endif
            labipb(0)=0
            labipe(0)=-1
            labipr(0)=1
            labipc(0)=0
            labfin(0)=0
            ipcmax=0
            ipcmxr=0
            ipcmin=0
            ipcbuf(0)=char(10)
            ipleof=-1
            iplmax=0
            iplmxr=0
            iplmin=1
            iplmnr=1
            iplbuf(0)=0
            iplcur=0
            iplloc=0
            iplget=0
            iplsav=0
            iplub=0
            iplue=0
            iplvb=0
            iplve=0
            iplwct=0
            iplulo=1234567890
            ipluhi=0
            iplul=0
            ipluh=1234567890
            iplufg=0
            if(i.eq.4)then
               iunit=5
               do 827 i=1,gthl
                  chr=gthbuf(i-1)
                  ipcmax=ipcmax+1
                  ipcmxr=ipcmxr+1
                  if(ipcmxr.ge.ipcsiz)
     &             call errr('Gather buffer exceeds input buffer!')
                  ipcbuf(ipcmxr)=chr
                  if(chr.eq.char(10))then
                     iplmax=iplmax+1
                     if(iplmax.ge.1234567890)
     &                call errr('Too many lines in gather buffer!')
                     iplmxr=iplmxr+1
                     if(iplmxr.ge.iplsiz)
     &                call errr('Input buffer line storage exceeded!')
                     iplbuf(iplmxr)=ipcmax
                  endif
 827           continue
               ipleof=iplmax+1
               labipe(0)=ipleof
               labipr(0)=0
               iplmax=iplmax+1
               if(iplmax.ge.1234567890)
     &          call errr('Too many lines in gather buffer!')
               iplmxr=iplmxr+1
               if(iplmxr.ge.iplsiz)
     &          call errr('Input buffer line storage exceeded!')
               iplbuf(iplmxr)=ipcmax
            endif
         else
            if(ounit.ne.0 .and. ounit.ne.6)close(abs(ounit),err=980)
            ounit=0
            fill=argtl(2)
            fil(1:fill)=argt(2)(1:fill)
         endif
         goto 810
      endif

c     return an environment variable
      if(chr.eq.'_')then
         tmpi1=tmpi+1
         tmpi=tmpi-2
         call fndcls(tmp,tmpl,tmpi)
         if(tmpi.le.tmpi1)call errp('Missing *_.../ variable name!')
         call getenv(tmp(tmpi1:tmpi-1),tmplin(1:1024))
         i=1024
         do 828 i=1024,1,-1
            if(tmplin(i:i).le.' ')goto 828
            call output(
     &       inind,nl,nll,
     &       fil,fill,trunco,
     &       crep,crepl,repmod,
     &       tmplin(1:i),
     &       gthdim,gth,gthl,ingth,
     &       ounit,outcnt)
            goto 829
 828     continue
 829     continue
         goto 810
      endif

c     ask the user for an item
      if(chr.eq.'a')then
         if(task.ne.tskfil .and. task.ne.tsksti)
     &    call errp('INPUT must be "-" or a file for *a.../!')
         tmpi1=tmpi
         tmpi=tmpi-2
         call fndcls(tmp,tmpl,tmpi)
         task0=task
         tmpi1=tmpi1+1
         task=index('mcfnsv',tmp(tmpi1:tmpi1))
         if(task.le.0)call errp('Invalid INPUT letter in *a.../!')
         do 835 arg=4,9
            if(tmpi1.ge.tmpi-1)goto 836
            tmpi2=index(tmp(tmpi1+1:tmpi-1),' ')+tmpi1
            if(tmpi2.le.tmpi1)tmpi2=tmpi
            if(tmpi1+1.ge.tmpi2)goto 834
            argtl(arg)=0
 832        call nxtchr(tmp,tmpi2-1,tmpi1,chr,ichr)
            if(ichr.eq.-1)goto 833
            if(ichr.eq.-2)
     &       call errp('Incomplete * character in *a.../!')
            if(ichr.lt.0)call errp('Illegal *'//char(-ichr)//
     &       ' character in *a.../!')
            argtl(arg)=argtl(arg)+1
            if(argtl(arg).gt.256)call errp('*a.../ parameter too long!')
            argt(arg)(argtl(arg):argtl(arg))=chr
            if(chr.eq.'*' .and.
     &       ((arg.eq.6.and.argtl(6).ne.1) .or. arg.eq.9))then
               argtl(arg)=argtl(arg)+1
               if(argtl(arg).gt.256)
     &          call errp('*a.../ parameter too long!')
               argt(arg)(argtl(arg):argtl(arg))='X'
            endif
            goto 832
 833        if(argtl(arg).eq.1 .and. argt(arg)(1:1).eq.char(0))
     &       argtl(arg)=0
 834        tmpi1=tmpi2
 835     continue
 836     argmx=9
         do 837 arg=9,4,-1
            if(argtl(arg).gt.0)goto 838
            argmx=arg-1
 837     continue
 838     goto 70
      endif

c     return to the current label if appropriate
      if(chr.eq.'b')then
         if(labmax.le.0)
     &    call errp('Label for *b command not defined!')
         if(labfin(labmax).eq.0)then
            tmpi=labpos(labmax)
            goto 810
         endif
         labmax=labmax-1
         iplcur=labipc(labmax)
         goto 810
      endif

c     copy a line from input
      if(chr.eq.'c')then
         ipltsk='c'
         iret=810
         goto 700
      endif

c     date and time strings or sleep
      i=index('ymdhise',chr)
      if(i.gt.0)then
c        find i and DIGIT
         if(i.eq.1)then
            ichr=2
         else if(i.le.6)then
            ichr=0
         else
            if(tmpi+2.gt.tmpl)
     &       call errp('Incomplete *eITEMDIGIT command!')
            tmpi=tmpi+1
            chr=tmp(tmpi:tmpi)
            i=index('ymdhismmHNDMZS?0123456789',chr)
            if(i.le.0)call errp('Invalid *e ITEM!')
            tmpi=tmpi+1
            ichr=ichar(tmp(tmpi:tmpi))-48
            if(ichr.lt.0 .or. ichr.gt.9)call errp('Invalid *e DIGIT!')
         endif
c        wait command
         if(i.ge.16)then
            i1=i-16
            if(ichr.eq.9 .and. i1.gt.2)
     &       call errp('Wait time is too large!')
            if(ichr.gt.0)i1=i1*10**ichr
            if(i1.gt.0)call sleep(i1)
            goto 810
         endif
c        update time and date data
         if(havdt.eq.0 .or. i.eq.15)then
c           find increment to apply
            timinc=0
            if(i.eq.15)then
               if(ichr.gt.3)call errp('*e? DIGIT is too big!')
               if(ichr.ge.2)then
                  if(tmpi+5.gt.tmpl)call errp('Incomplete *e?'//
     &             char(ichr+48)//' time increment!')
                  i2=ichar(tmp(tmpi+3:tmpi+3))-48
                  timinc=(ichar(tmp(tmpi+2:tmpi+2))-48)*10+i2
                  if(index('+-',tmp(tmpi+1:tmpi+1)).le.0
     &             .or. timinc.lt.0 .or. timinc.gt.12*(4-ichr)
     &             .or. i2.lt.0 .or. i2.gt.9)call errp(
     &             'Invalid *e?'//char(ichr+48)//' time increment!')
                  i2=ichar(tmp(tmpi+5:tmpi+5))-48
                  i1=(ichar(tmp(tmpi+4:tmpi+4))-48)*10+i2
                  timinc=timinc*60+i1
                  if(i1.lt.0 .or. i1.gt.60
     &             .or. timinc.gt.12*60*(4-ichr)
     &             .or. i2.lt.0 .or. i2.gt.9)call errp(
     &             'Invalid *e?'//char(ichr+48)//' time increment!')
                  timinc=60*timinc
                  if(tmp(tmpi+1:tmpi+1).eq.'-')timinc=-timinc
                  tmpi=tmpi+5
               endif
            endif
c           read the date and time
            dattim=' '
            if(i.ne.15 .or. ichr.eq.0 .or.ichr.eq.2)then
               call ltime(time()+timinc,tdat)
            else
               call gmtime(time()+timinc,tdat)
            endif
            call date_and_time(dattim(1:8),dattim(9:18),line(1:5))
            if(dattim(1:1).ne.'2')
     &       call errr('System error: Cannot obtain date and time!')
c           time zone indicator
            dattim(42:46)=line(1:5)
c           year
            tdat(6)=tdat(6)+1900
            i1=tdat(6)
            dattim(1:4)=
     &       char(mod(i1/1000,10)+48)//char(mod(i1/100,10)+48)//
     &       char(mod(i1/10,10)+48)//char(mod(i1,10)+48)
c           month
            tdat(5)=mod(tdat(5),12)+1
            i1=tdat(5)
            dattim(5:6)=char(mod(i1/10,10)+48)//char(mod(i1,10)+48)
            tmplin(1:36)='JanFebMarAprMayJunJulAugSepOctNovDec'
            dattim(32:34)=tmplin(3*i1-2:3*i1)
            tmplin(1:86)='January February March April May June '//
     &       'July August September October November December '
            i1=index(tmplin(1:86),dattim(32:34))
            if(i1.le.0)call erri('839a')
            i2=index(tmplin(i1:86),' ')+i1-2
            if(i2.lt.i1)call erri('839b')
            dattim(32:40)=tmplin(i1:i2)
c           day
            i1=tdat(4)
            dattim(7:8)=char(mod(i1/10,10)+48)//char(mod(i1,10)+48)
c           day of the week
            i1=tdat(7)
            tmplin(1:21)='SunMonTueWedThuFriSat'
            dattim(23:25)=tmplin(3*i1+1:3*i1+3)
            tmplin(1:57)=
     &       'Sunday Monday Tuesday Wednesday Thursday Friday Saturday '
            i1=index(tmplin(1:57),dattim(23:25))
            if(i1.le.0)call erri('839c')
            i2=index(tmplin(i1:57),' ')+i1-2
            if(i2.lt.i1)call erri('839d')
            dattim(23:31)=tmplin(i1:i2)
c           hour
            i1=tdat(3)
            dattim(9:10)=char(mod(i1/10,10)+48)//char(mod(i1,10)+48)
            if(i1.lt.12)then
               if(i1.eq.0)i1=12
               i2=i1/10
               i1=i1-i2*10
               dattim(19:22)=char(i2+48)//char(i1+48)//'am'
            else
               i1=i1-12
               if(i1.eq.0)i1=12
               i2=i1/10
               i1=i1-i2*10
               dattim(19:22)=char(i2+48)//char(i1+48)//'pm'
            endif
c           minute
            i1=tdat(2)
            dattim(11:12)=char(mod(i1/10,10)+48)//char(mod(i1,10)+48)
c           second
            i1=tdat(1)
            dattim(13:14)=char(mod(i1/10,10)+48)//char(mod(i1,10)+48)
c           daylight saving indicator
            if(tdat(9).gt.0)then
               dattim(41:41)='D'
            else if(tdat(9).eq.0)then
               dattim(41:41)='S'
            else
               dattim(41:41)='?'
            endif
            havdt=1
            if(i.eq.15)goto 810
         endif
c        rerurn requested item
         if(i.eq.1)then
c           year
            if(ichr.eq.0)ichr=4
            if(ichr.gt.4)call errp('*ey DIGIT cannot be more than 4!')
            i2=4
            i1=i2-ichr+1
         else if(i.le.9)then
c           month, day, hour, minute, second, am/pm hour
            if(ichr.gt.2)
     &       call errp('*e'//chr//' DIGIT cannot be more than 2!')
            i2=2*i+2
            i1=i2-1
            if(dattim(i1:i1).eq.'0')then
               if(ichr.eq.1)i1=i1+1
               if(ichr.eq.2)dattim(i1:i1)=' '
            endif
         else if(i.eq.10)then
c           am/pm
            if(ichr.gt.2)call errp('*eN DIGIT cannot be more than 2!')
            i2=2*i+2
            i1=i2-1
            if(ichr.eq.1)i2=i2-1
         else if(i.eq.11)then
c           named day
            i1=23
            if(ichr.eq.0)ichr=index(dattim(i1:i1+8),' ')-1
            if(ichr.le.0)ichr=9
            i2=i1+ichr-1
         else if(i.eq.12)then
c           named month
            i1=32
            if(ichr.eq.0)ichr=index(dattim(i1:i1+8),' ')-1
            if(ichr.le.0)ichr=9
            i2=i1+ichr-1
         else if(i.eq.13)then
c           time zone shift
            i1=42
            if(ichr.eq.0)ichr=5
            if(ichr.gt.5)call errp('*eZ length cannot be more than 5!')
            i2=i1+ichr-1
            if(ichr.eq.2)then
               i1=45
               i2=46
            endif
         else if(i.eq.14)then
c           daylight savings indicator
            if(ichr.gt.1)call errp('*eS length cannot be more than 1!')
            i1=41
            i2=41
         else
            call erri('839e')
         endif
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    dattim(i1:i2),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         if(i.ge.2 .and. i.le.9)then
            if(dattim(i1:i1).eq.' ')dattim(i1:i1)='0'
         endif
         goto 810
      endif

c     copy a line from input without newline
      if(chr.eq.'f')then
         ipltsk='f'
         iret=810
         goto 700
      endif

c     turn on gather mode
      if(chr.eq.'g')then
         ingth=1
         goto 810
      endif

c     jump to a new location in the input file
      if(chr.eq.'j')then
         tmpi1=min(tmpl,tmpi+1)
         call rdint(tmp,tmpl,tmpi,i,istat)
         if(istat.ne.0 .or. tmpi.ge.tmpl .or. tmp(tmpi1:tmpi1).eq.' ')
     &    call errp('Invalid *j.../ parameter!')
         tmpi=tmpi+1
         if(index('+-',tmp(tmpi1:tmpi1)).ne.0)then
            if(tmp(tmpi:tmpi).ne.'/')
     &       call errp('Invalid *j.../ parameter!')
            iplcur=iplcur+i
            if(iplcur.lt.0)goto 740
         else
            if(tmp(tmpi:tmpi).eq.'/')then
               iplcur=i
            else
               if(tmp(tmpi:min(tmpl,tmpi+1)).ne.'?/')
     &          call errp('Invalid *j.../ parameter!')
               iplcur=-1-i
               if(ipleof.gt.0)iplcur=ipleof+1+iplcur
               tmpi=tmpi+1
            endif
         endif
         ipltsk='l'
         iret=810
         goto 700
      endif

c     keep as a stored string
      if(chr.eq.'k')then
         call rdint(tmp,tmpl,tmpi,ss,istat)
         tmpi=min(tmpi+1,tmpl)
         if(istat.gt.1 .or. tmp(tmpi:tmpi).ne.'/' .or. ss.lt.0)
     &    call errp('Bad or incomplete *kNUM/ command!')
         if(istat.eq.1)ss=ssdim
         if(ss.gt.ssdim)call errp('NUM too big in *kNUM/!')
         ingth=-ss-1
         sstl(ss)=0
         goto 810
      endif

c     set a label
      if(chr.eq.'l')then
         if(labmax.ge.labdim)
     &    call errp('Too many labels!')
         labmax=labmax+1
         tmpi1=tmpi-2
         call fndcls(tmp,tmpl,tmpi1)
         labend(labmax)=tmpi1-2
         labfin(labmax)=0
         labipc(labmax)=iplcur
         labipb(labmax)=labipb(labmax-1)
         tmpi1=tmpi+1
         call rdint(tmp,tmpl,tmpi,i,istat)
         if(istat.gt.1 .or. tmp(tmpi1:tmpi1).eq.' ')
     &    call errp('Invalid *l.../ lower limit!')
         if(istat.eq.0)then
            if(index('-+',tmp(tmpi1:tmpi1)).ne.0)then
               labipb(labmax)=max(0,iplcur+i)
            else
               if(tmp(tmpi+1:tmpi+1).eq.'?')then
                  labipb(labmax)=-1-i
                  if(ipleof.gt.0)
     &             labipb(labmax)=max(0,ipleof+1+labipb(labmax))
                  tmpi=tmpi+1
               else
                  labipb(labmax)=i
               endif
            endif
         endif
         tmpi=tmpi+1
         labipe(labmax)=labipe(labmax-1)
         labipr(labmax)=labipr(labmax-1)
         if(tmp(tmpi:tmpi).eq.':')then
            tmpi1=tmpi+1
            call rdint(tmp,tmpl,tmpi,i,istat)
            if(istat.ne.0 .or. tmp(tmpi1:tmpi1).eq.' ')
     &       call errp('Invalid *l.../ upper limit!')
            if(index('-+',tmp(tmpi1:tmpi1)).ne.0)then
               labipe(labmax)=iplcur+i
               labipr(labmax)=0
            else
               if(tmp(tmpi+1:tmpi+1).eq.'?')then
                  labipe(labmax)=-1-i
                  labipr(labmax)=1
                  if(ipleof.gt.0)then
                     labipe(labmax)=ipleof+1+labipe(labmax)
                     labipr(labmax)=0
                  endif
                  tmpi=tmpi+1
               else
                  labipe(labmax)=i
                  labipr(labmax)=0
               endif
            endif
            tmpi=tmpi+1
         endif
         if(tmp(tmpi:tmpi).ne.'/')
     &    call errp('Invalid *l.../ line range!')
         labpos(labmax)=tmpi
         ipltsk='l'
         iret=810
         goto 700
      endif

c     find next
      if(chr.ne.'n')goto 849
      if(tmpi+2.gt.tmpl)goto 848
      if(tmp(tmpi+1:tmpi+2).ne.'*(')goto 848
      tmpi1=tmpi
      call fndcls(tmp,tmpl,tmpi1)
      if(tmpi1+2.gt.tmpl)goto 848
      if(tmp(tmpi1+1:tmpi1+2).ne.'*(')goto 848
      tmpi2=tmpi1
      call fndcls(tmp,tmpl,tmpi2)
      if(fndsrc.ne.1)
     & call rdfnd(nl,nll,fndts,fndtsl,fnddim,fndmax,fnddat,istat,cstat)
      fndsrc=1
      iplsav=iplcur
      ipltsk='n'
      iret=840
      goto 700
 840  if(tmpijm.ge.100)
     & call errp('Too many nested conditional commands!')
      tmpijm=tmpijm+1
      if(iplcur.eq.iplsav)then
         tmpi=tmpi+2
         tmpij1(tmpijm)=tmpi1-2
      else
         tmpi=tmpi1+2
         tmpij1(tmpijm)=tmpi2-2
      endif
      tmpij2(tmpijm)=tmpi2
      goto 810
 848  call errp('Invalid *n*(...*)*(...*) grouping!')
 849  continue

c     turn gathering off and output the gather buffer
      if(chr.eq.'o')then
         if(ingth.eq.1)ingth=0
         call rdint(tmp,tmpl,tmpi,i2,istat)
         tmpi=min(tmpi+1,tmpl)
         if(istat.gt.1 .or. tmp(tmpi:tmpi).ne.'/')
     &    call errp('Invalid *o.../ parameter!')
         if(i2.eq.0)then
            if(gthl.gt.0)call output(
     &       inind,nl,nll,
     &       fil,fill,trunco,
     &       crep,crepl,repmod,
     &       gth(1:gthl),
     &       gthdim,gth,gthl,ingth,
     &       ounit,outcnt)
         else if(i2.gt.0)then
            do 854 i=1,gthl
               chr=gth(i:i)
               call output(
     &          inind,nl,nll,
     &          fil,fill,trunco,
     &          crep,crepl,repmod,
     &          chr,
     &          gthdim,gth,gthl,ingth,
     &          ounit,outcnt)
               if(chr.eq.char(10))then
                  i2=i2-1
                  if(i2.le.0)goto 858
               endif
 854        continue
         else
            do 856 i=1,gthl
               chr=gth(i:i)
               if(i2.ge.0)call output(
     &          inind,nl,nll,
     &          fil,fill,trunco,
     &          crep,crepl,repmod,
     &          chr,
     &          gthdim,gth,gthl,ingth,
     &          ounit,outcnt)
               if(chr.eq.char(10))i2=i2+1
 856        continue
         endif
 858     goto 810
      endif

c     prompt the user
      if(chr.ne.'p')goto 869
      tmpi1=tmpi+1
      tmpi=tmpi-2
      call fndcls(tmp,tmpl,tmpi)
c     process an input file paging prompt, if it is one
      if(tmpi-tmpi1.ne.1)goto 867
      if(tmp(tmpi1:tmpi1).ne.'p')goto 867
c     whenever we enter this, we are in writing mode, or need initialize it
      if(iplue.lt.0)then
c        with current libraries, tsksti reads keyboard as standard input
         if(task.ne.tskfil)call errp('Invalid INPUT for *pp/ command!')
         if(index('-+',argt(2)(1:1)).eq.0)
     &    call errp('Invalid OUTPUT for *pp/ command!')
c        try setting a default search string if none
         if(fndusl.eq.0 .and.fndtsl.gt.0 .and. fndtsl.le.73)then
            fndusl=fndtsl
            fndus(1:fndusl)=fndts(1:fndusl)
         endif
c        initialize the limits in between which we are definitely in range
         iplulo=1234567890
         ipluhi=0
c        initialize the limit below which we are definitely out of range
         iplul=0
c        initialize the limit above which we are definitely out of range
         ipluh=1234567890
c        initialize the visible range as no lines around the current location
         iplvb=iplcur
         iplve=iplcur
c        start a "show the next screen" task
         utask=' '
         iplub=iplcur
         iplue=iplcur+scrnsz
         iplwct=0
      endif
c     check if iplcur-1 is in range, if so move to it if iplcur>iplub
 860  continue
c     in case we ever enable tsksti, adjust the limits for lost data
      if(task.eq.tsksti)then
         iplul=max(iplul,min(iplmin-1,iplcur))
         iplulo=max(iplulo,min(iplmin-1,iplcur))
      endif
c     skip if backing up is complete
      if(iplub.lt.0)goto 862
c     start the previous line verification
      if(utask.ne.'P')then
c        go to the previous line and start a safe location verification
         iplcur=iplcur-1
         iplufg=0
         if(iplcur.lt.iplul)goto 861
         iplufg=1
         if(iplcur.ge.iplulo .and. iplcur.le.ipluhi)goto 861
         ipltsk='l'
      else
c        start a search of the last line
         iplsav=iplcur
         iplufg=0
         if(iplcur-1.lt.iplul)goto 861
         iplufg=1
         ipltsk='p'
      endif
c     jump to the quasi-subroutine
      iret=861
      goto 700
 861  if(iplufg.eq.0)then
c        the previous line is not a valid location, so reset location
         if(utask.ne.'P')iplcur=iplcur+1
c        update the limits
         iplul=max(iplul,iplcur)
c        done backing up, obviously
         iplub=-1
c        write a message
         if(task.eq.tsksti
     &    .and. iplmin.gt.1 .and. iplcur.le.iplmin-1)then
            print10,'[============= earlier input data lost from '//
     &       'the available storage ============]'
            if(ipluhi.gt.iplcur)iplcur=min(ipluhi,iplmin-1)
         else if(iplcur.le.0)then
            print10,'[=============================== start of file '//
     &       '===============================]'
         else
            print10,'[=============================== start of range '//
     &       '==============================]'
         endif
c        proceed according to task
         if(utask.eq.'f')then
c           start a "next match" search now
            print10,'[========================= searching for first '//
     &       'match =========================]'
            iplvb=iplcur
            iplve=iplcur
            utask='n'
            iplue=1234567890
         else if(utask.eq.'s')then
c           start a "next screen" now
            utask=' '
            iplue=min(iplcur+scrnsz,iplve)
         else if(index('pP',utask).ne.0)then
c           no luck, quit
            print10,'[=============================== text not found '//
     &       '==============================]'
            iplue=iplcur
         endif
c        repeat
         goto 860
      else
c        the previous line is a valid location
         iplufg=0
c        handle the case that we found the search string
         if(utask.eq.'P')then
            if(iplcur.eq.iplsav)then
c              start a backup now
               utask='b'
               iplue=iplcur
               iplub=max(iplul,iplue-scrnsz)
               iplcur=iplcur-1
            endif
         endif
c        for task 'p', start actually searching after backing up one line
         if(utask.eq.'p')utask='P'
c        update the limits
         iplulo=min(iplulo,iplcur)
         ipluhi=max(ipluhi,iplcur)
c        done backing up if we are at iplub
         if(iplcur+1.le.iplub)then
            iplcur=iplcur+1
            iplub=-1
         endif
c        repeat
         goto 860
      endif
c     check if iplcur+1 is in range, if so move to it if iplcur<iplue
 862  continue
c     start the next line verification
      if(utask.ne.'n')then
c        go to the next line and start a safe location verification
         iplcur=iplcur+1
         iplufg=0
         if(iplcur.gt.ipluh)goto 863
         iplufg=1
         if(iplcur.ge.iplulo .and. iplcur.le.ipluhi)goto 863
         ipltsk='l'
      else
c        start a search of the next line
         iplsav=iplcur
         iplufg=0
         if(iplcur+1.gt.ipluh)goto 863
         iplufg=1
         ipltsk='n'
      endif
c     jump to the quasi-subroutine
      iret=863
      goto 700
 863  if(iplufg.eq.0)then
c        the next line is not a valid location, so reset location
         if(utask.ne.'n')iplcur=iplcur-1
c        update the limits
         ipluh=min(ipluh,iplcur)
         if(utask.eq.'e')then
c           for the "goto end" task, start a backup one now from EOF
            utask='b'
            iplub=iplve
            iplue=iplcur
            i=iplue-scrnsz
            if(i.gt.iplub)then
               print10,'[=============================== skipping '//
     &          'lines ==============================]'
               iplub=i
            endif
            goto 860
         endif
c        write a message
         if(ipleof.gt.0 .and. iplcur.ge.ipleof)then
            print10,'[================================ end of file '//
     &       '================================]'
         else
            print10,'[================================ end of range '//
     &       '===============================]'
         endif
c        go ask the user for the next idea
         if(utask.eq.'n')print10,'[=============================== '//
     &    'text not found ==============================]'
         goto 864
      else
c        the next line is a valid location
         iplufg=0
c        handle the case that we found the search string
         if(utask.eq.'n')then
            if(iplcur.eq.iplsav)then
               iplcur=iplcur+1
c              start a backup now
               utask='b'
               iplub=iplve
               iplue=iplcur
               i=iplue-scrnsz
               if(i.gt.iplub)then
                  iplub=i
                  print10,'[=============================== '//
     &             'skipping lines ==============================]'
               endif
            endif
         endif
c        update the limits
         iplulo=min(iplulo,iplcur)
         ipluhi=max(ipluhi,iplcur)
c        reset location for the coming *c command
         iplcur=iplcur-1
c        except if we have found the search string
         if(iplub.ge.0)goto 860
c        and except that if we have reached the end, we return to user
         if(iplcur.ge.iplue)goto 864
c        and except that the e and n task do not do output yet
         if(utask.eq.'e' .or. utask.eq.'n')then
            iplcur=iplcur+1
            goto 862
         endif
c        update the visible range of lines
         iplwct=iplwct+1
         if(iplwct.eq.1)then
            if(utask.ne.'l')then
               iplvb=iplcur
            else
               iplvb=max(iplvb,iplcur-scrnsz+1)
            endif
         endif
         iplve=iplcur+1
c        skip the *c command if the data is lost
         if(task.eq.tsksti .and. iplcur+1.lt.iplmin)then
            print10,'[================= this line lost from the '//
     &       'available storage =================]'
            iplcur=iplcur+1
            goto 862
         endif
c        return to let the *c command do its job
         goto 810
      endif
c     ask the user what is next
 864  continue
c     update the visible limits to none in case we failed to write anything
      if(iplwct.eq.0)then
         iplvb=iplcur
         iplve=iplcur
      endif
c     find the allowable user choices
      goodl=3
      good(1:goodl)='q/?'
      if(helpl.gt.0)then
         goodl=goodl+1
         good(goodl:goodl)='h'
      endif
      linel=13
      line(1:linel)='[=== Hit key '
      if(iplcur.lt.ipluh)then
         line(linel+1:linel+17)='Space, Enter, e, '
         linel=linel+17
         goodl=goodl+1
         good(goodl:goodl)=' '
         goodl=goodl+1
         good(goodl:goodl)='l'
         goodl=goodl+1
         good(goodl:goodl)='e'
      endif
      if(iplvb.gt.iplul)then
         line(linel+1:linel+6)='b, s, '
         linel=linel+6
         goodl=goodl+1
         good(goodl:goodl)='b'
         goodl=goodl+1
         good(goodl:goodl)='s'
      endif
      line(linel+1:linel+3)='/, '
      linel=linel+3
      if(iplcur.lt.ipluh)then
         line(linel+1:linel+3)='n, '
         linel=linel+3
         goodl=goodl+1
         good(goodl:goodl)='n'
      endif
      if(iplcur.gt.iplul+1)then
         line(linel+1:linel+6)='p, f, '
         linel=linel+6
         goodl=goodl+1
         good(goodl:goodl)='p'
         goodl=goodl+1
         good(goodl:goodl)='f'
      endif
      line(linel+1:80)='q, or ? for help: '
      linel=linel+19
      if(iplcur.lt.ipluh)line(linel:linel)='l'
c     ask for the user choice
      call inkey(15,good(1:goodl),line,utask)
      line=' '
      print11,char(13)
      print11,line(1:79)
      print11,char(13)
      if(utask.ne.'l')print10,'['//utask//']'
c     quit
      if(utask.eq.'q')then
         iplue=-1
         iplcur=-1
         ipltsk='l'
         iret=810
         goto 700
      endif
c     build-in help
      if(utask.eq.'?')then
         print10,' ',
     &    'The following keys are defined:',
     &    ' ',
     &    '  Space: Next screen.',
     &    '  Enter: Next line.',
     &    '      e: Go to end.',
     &    '      b: Backup a screen.',
     &    '      s: Go to start.',
     &    ' ',
     &    '      /: Define text to search for.',
     &    '      n: Find next occurrence of the search text.',
     &    '      p: Find previous occurrence of the search text.',
     &    '      f: Find first occurrence of the search text.',
     &    '         (Any found text will be immediately '//
     &    'above the prompt line.',
     &    '          Use the Enter key to see the next lines one '//
     &    'by one.)',
     &    ' '
         if(helpl.gt.0)print10,
     &    '      h: Show additional help.'
         print10,
     &    '      q: Quit.',
     &    ' '
         goto 864
      endif
c     external help
      if(utask.eq.'h')then
         if(help(1:1).eq.'*')then
            call system(help(2:helpl),istat)
         else
            call type(help(2:helpl))
         endif
         goto 864
      endif
c     enter search string
      if(utask.eq.'/')then
         linel=0
         call out('Enter text to find not involving ?, *, '//
     &    'or [, or enter a lone ? for help.')
 865     if(linel.gt.0)then
            tmplin(1:linel)=line(1:linel)
            line(1:linel)='Text:?'//tmplin(1:linel)
         else if(fndusl.gt.0)then
            line='Text:?'//fndus(1:fndusl)
         else
            line='Text:'
         endif
         call in(line)
         linel=0
         do 866 i=1,73
            if(line(i:i).ne.' ')linel=i
 866     continue
         if(line(1:1).eq.'?')then
            print10,' ',' ',' ',
     &       '     Any ? you want to search for must be encoded as '//
     &       '*Q, any * as *X,',
     &       '  and any [ as *O.  Encode any Tab as *T or *009, '//
     &       'line start as *010,',
     &       '  line end as *;, and any trailing blank '//
     &       'space as *W or *032.',
     &       '     Search strings are case-insensitive unless there '//
     &       'is at least one',
     &       '  capital letter in the string.',
     &       '     [Ff]irst searches for First or first, but not '//
     &       'FIRST.',
     &       '  In general, [CHARS] means any character listed '//
     &       'in character set CHARS.',
     &       '     [a:zA:Z] searches for a letter.',
     &       '  In general, a:z indicates all lowercase letters '//
     &       'from a to z, A:Z all',
     &       '  uppercase letters from A to Z, and 0:9 indicates '//
     &       'all digits.',
     &       '     [-a:zA:Z .,*C;!?-''"] searches for a character '//
     &       'that not a letter,',
     &       '  blank space, punctuation symbol, hyphen, or quote.',
     &       '  In general, [-CHARS] means any character *not* '//
     &       'listed in CHARS.',
     &       '     For the characters CHARS inside [CHARS] or '//
     &       '[-CHARS], a * must be',
     &       '  encoded as *X and a ] as *R, and probably a - as '//
     &       '*M and a : as *C.',
     &       '     [A:Z][a:z]?: searches for a capitalized word '//
     &       'followed by a colon.',
     &       '  Here [a:z]? stands for any amount of lowercase '//
     &       'letters.',
     &       '  In general, ? means *all* subsequent occurrences '//
     &       'of the preceding',
     &       '  character or character set.  (Not zero or more '//
     &       'like in a Unix RE).',
     &       '     To quit changing the text to search for, enter '//
     &       'a single q.',
     &       ' '
            linel=0
            goto 865
         endif
         if(linel.eq.1 .and. line(1:1).eq.'q')goto 864
         call rdfnd(nl,nll,line,linel,fnddim,fndmax,fnddat,istat,cstat)
         if(istat.eq.0)then
            fndusl=linel
            if(linel.gt.0)fndus(1:linel)=line(1:linel)
            fndsrc=2
            goto 864
         endif
         fndsrc=0
         call out('** '//cstat(1:istat-1)//'.')
         call out('   Please reenter the string to find, or '//
     &    'enter ? for help, or q to quit')
         goto 865
      endif
c     find lines to process
      if(utask.eq.' ')then
c        next screen
         iplub=-1
         iplue=iplcur+scrnsz
      else if(utask.eq.'l')then
c        next line
         iplub=-1
         iplue=iplcur+1
      else if(utask.eq.'e')then
c        goto end
         iplub=-1
         iplue=1234567890
      else if(utask.eq.'b')then
c        back up a screen
         iplue=iplvb
         iplub=iplue-scrnsz
         if(iplub.lt.iplul)then
            iplub=iplul
            iplue=min(iplul+scrnsz,iplve)
         endif
         print10,'[================================= backing up '//
     &    '================================]'
      else if(utask.eq.'s')then
c        go to start
         iplub=0
      else if(index('npf',utask).ne.0)then
         if(fndsrc.ne.2)call
     &    rdfnd(nl,nll,fndus,fndusl,fnddim,fndmax,fnddat,istat,cstat)
         fndsrc=2
         if(utask.eq.'n')then
c           find the next search string
            iplub=-1
            iplue=1234567890
            print10,'[================================= searching '//
     &       '=================================]'
         else if(utask.eq.'p')then
c           find the previous search string
            print10,'[============================= searching '//
     &       'backward ============================]'
            iplub=0
         else if(utask.eq.'f')then
c           find the first search string
            iplub=0
         else
            call erri('869a')
         endif
      else
         call erri('869b')
      endif
c     go process the lines
      iplwct=0
      goto 860
c     handle *p/
 867  if(tmpi1.ge.tmpi)then
         if(textl.le.0)print10
         if(textl.gt.0)print10,text(1:textl)
         goto 810
      endif
c     read TEXT or PROMPT
      tmpi2=index(tmp(tmpi1:tmpi),' ')+tmpi1-1
      if(tmpi2.lt.tmpi1)call errp('No *p.../ Space at start of text!')
      linel=0
      i2=tmpi2
 868  if(i2.lt.tmpi-1)then
         call nxtchr(tmp,tmpi-1,i2,chr,ichr)
         if(ichr.eq.-2)
     &    call errp('Incomplete * character in *p.../ TEXT!')
         if(ichr.lt.0)call errp('Invalid "*'//char(-ichr)//
     &    '" character in *p.../ TEXT!')
         linel=linel+1
         if(linel.gt.316)call errp('TEXT or PROMPT too long in *p.../!')
         tmplin(linel:linel)=chr
         goto 868
      endif
c     handle *p TEXT/
      if(tmpi1.ge.tmpi2)then
         textl=linel
         if(textl.gt.0)then
            text(1:textl)=tmplin(1:textl)
            print10,text(1:textl)
         else
            print10
         endif
         goto 810
      endif
c     initialize prompt
      if(linel.le.0)call errp('PROMPT missing in *pCHR.../!')
      if(linel.gt.76)call errp('PROMPT too long in *pCHR.../!')
      line(1:linel)=tmplin(1:linel)
      if(index(line(1:linel),':').gt.0)
     & call errp('Illegal colon in *pCHR.../ PROMPT!')
      line(linel+1:)=':'
      linel=linel+3
c     read character following *p
      tmpi1=tmpi1-1
      call nxtchr(tmp,tmpi2-1,tmpi1,chr,ichr)
      if(ichr.eq.-2)call errp('Incomplete * character as *p.../ CHR!')
      if(ichr.lt.0)call errp('Invalid "*'//char(-ichr)//
     & '" character as *p.../ CHR!')
      line(linel:linel)=chr
c     handle *pCHR PROMPT/
      if(tmpi1.ge.tmpi2-1)then
         call inkey(1,' ',line,chr)
         goto 810
      endif
c     handle *pCHR1CHR2 PROMPT/*(...*)*(...*)
      i=5
      if(ichr.ge.ichar('A') .and. ichr.le.ichar('Z'))i=4
      tmplin(1:1)=chr
      call nxtchr(tmp,tmpi2-1,tmpi1,chr,ichr)
      if(ichr.eq.-2)call errp('Incomplete * character as *p.../ CHR2!')
      if(ichr.lt.0)call errp('Invalid "*'//char(-ichr)//
     &    '" character as *p.../ CHR2!')
      if(tmpi1.lt.tmpi2-1)call errp('Junk following *p.../ CHR2!')
      if(chr.eq.tmplin(1:1))
     & call errp('CHR1 cannot equal CHR2 in *p.../!')
      if(ichr.ge.ichar('A') .and. ichr.le.ichar('Z'))i=4
      tmplin(2:2)=chr
      if(tmp(min(tmpl,tmpi+1):min(tmpl,tmpi+2)).ne.'*(')
     & call errp('Invalid *p.../*(...*)*(...*) grouping!')
      tmpi1=tmpi
      call fndcls(tmp,tmpl,tmpi1)
      if(tmp(min(tmpl,tmpi1+1):min(tmpl,tmpi1+2)).ne.'*(')
     & call errp('Invalid *p.../*(...*)*(...*) grouping!')
      tmpi2=tmpi1
      call fndcls(tmp,tmpl,tmpi2)
      if(tmpijm.ge.100)
     & call errp('Too many nested conditional commands!')
      tmpijm=tmpijm+1
      call inkey(i,tmplin(1:2),line,chr)
      if(chr.eq.tmplin(1:1))then
         tmpi=tmpi+2
         tmpij1(tmpijm)=tmpi1-2
      else
         tmpi=tmpi1+2
         tmpij1(tmpijm)=tmpi2-2
      endif
      tmpij2(tmpijm)=tmpi2
      goto 810
 869  continue

c     quit with status or set exit status on error
      if(chr.eq.'q')then
         i2=min(tmpi+1,tmpl)
         if(tmp(i2:i2).eq.'e')tmpi=tmpi+1
         call rdint(tmp,tmpl,tmpi,i,istat)
         tmpi=min(tmpi+1,tmpl)
         if(istat.gt.1 .or. i.lt.0 .or. tmp(tmpi:tmpi).ne.'/')
     &    call errp('Invalid *q.../ parameter!')
         if(tmp(i2:i2).eq.'e')then
            call errset(i)
         else
            call exit(i)
         endif
         goto 810
      endif

c     file root or file type
      if(index('rx',chr).ne.0)then
         call rdint(tmp,tmpl,tmpi,ss,istat)
         tmpi=min(tmpi+1,tmpl)
         if(istat.gt.1 .or. ss.lt.0 .or. tmp(tmpi:tmpi).ne.'/')
     &    call errp('Invalid *'//chr//'.../ parameter!')
         if(istat.eq.1)ss=ssdim
         i2=sstl(ss)
         ipt=i2+1
         do 872 i=i2,1,-1
            ichr=ichar(sst(ss)(i:i))
            if(i.eq.i2 .and. ichr.le.32)then
               i2=i2-1
               ipt=ipt-1
            endif
            if(ichr.eq.ichar('.'))then
               ipt=i
               goto 873
            endif
            if(ichr.eq.ichar(dd))goto 873
 872     continue
 873     if(chr.eq.'x')then
            if(ipt.gt.i2)goto 810
            call output(
     &       inind,nl,nll,
     &       fil,fill,trunco,
     &       crep,crepl,repmod,
     &       sst(ss)(ipt:i2),
     &       gthdim,gth,gthl,ingth,
     &       ounit,outcnt)
            goto 810
         endif
         if(ipt.le.1)goto 810
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    sst(ss)(1:ipt-1),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         goto 810
      endif

c     set truncation handling
      if(chr.eq.'t')then
         if(tmpi.ge.tmpl)call errp('Unterminated *t.../ command!')
         tmpi=tmpi+1
         tmpi1=tmpi
         chr=tmp(tmpi:tmpi)
         if(chr.lt.' ' .or. chr.gt.'~')chr='?'
         if(index('iotuv',chr).le.0)
     &    call errp('Nonexisting *t'//chr//'.../ command!')
         call rdint(tmp,tmpl,tmpi,i,istat)
         if(istat.ne.0)
     &    call errp('Invalid number in *t'//chr//'.../ command!')
         tmpi=min(tmpi+1,tmpl)
         if(tmp(tmpi:tmpi).ne.'/')
     &    call errp('Unterminated *t'//chr//'.../ command!')
         if(tmp(tmpi1:tmpi1).eq.'i')then
            if(i.le.0)call errp('Invalid *ti.../ line size!')
            if(i.gt.sstdim)call errp('*ti.../ line size too big!')
            trunci=i
         else if(tmp(tmpi1:tmpi1).eq.'o')then
            if(outcnt.ne.0)
     &       call errp('Illegal *to.../ command in mid-line!')
            trunco(1)=i
         else if(tmp(tmpi1:tmpi1).eq.'t')then
            if(outcnt.ne.0)
     &       call errp('Illegal *tt.../ command in mid-line!')
            if(i.lt.0)call errp('Invalid *tt.../ tab spacing!')
            if(i.gt.len(crep(9)))
     &       call errp('Tabs too far apart in *tt.../ command!')
            trunco(2)=i
         else if(tmp(tmpi1:tmpi1).eq.'u')then
c           if(outcnt.ne.0)
c     &      call errp('Illegal *tu.../ command in mid-line!')
            if(i.ne.0 .and. i.ne.8)
     &       call errp('*tu.../ value can only be 0 or 8!')
            trunco(3)=i/8
         else if(tmp(tmpi1:tmpi1).eq.'v')then
            if(i.le.0)call errp('Invalid *tv.../ page size!')
            scrnsz=i
         endif
         goto 810
      endif

c     unicode character
      if(chr.eq.'u')then
         if(tmpi.ge.tmpl)call errp('Unterminated *u.../ command!')
         call rdint(tmp,tmpl,tmpi,i,istat)
         if(istat.ne.0 .or. i.lt.0 .or. i.gt.1114111)
     &    call errp('Invalid unicode number in *u.../!')
         tmpi=min(tmpi+1,tmpl)
         if(tmp(tmpi:tmpi).ne.'/')
     &    call errp('Unterminated *u.../ command!')
         call wutf8(i,80,linel,line)
         if(linel.lt.1)call erri('870u')
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    line(1:linel),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         goto 810
      endif

c     verify
      if(chr.eq.'v')then
c        find the closing /
         tmpi2=tmpi-2
         call fndcls(tmp,tmpl,tmpi2)
c        read the parameters
         ss1=ssdim
         ss2=0
         task1=' '
         task2=' '
         test=' '
         i=index('0123456789-',tmp(tmpi+1:tmpi+1))
         if(i.gt.0)then
            tmpi=tmpi+1
            ss1=i-1
            if(ss1.eq.10)ss1=ssdim
            i=index('0123456789-',tmp(tmpi+1:tmpi+1))
            if(i.gt.0)then
               tmpi=tmpi+1
               ss2=i-1
               if(ss2.eq.10)ss2=ssdim
            endif
         endif
         chr=tmp(tmpi+1:tmpi+1)
         if(chr.eq.' ' .or. (chr.ge.'A' .and. chr.le.'Z'))then
            tmpi=tmpi+1
            task1=tmp(tmpi:tmpi)
            chr=tmp(tmpi+1:tmpi+1)
            if(chr.eq.' ' .or. (chr.ge.'A' .and. chr.le.'Z'))then
               tmpi=tmpi+1
               task2=tmp(tmpi:tmpi)
            endif
         endif
         if(tmp(tmpi+1:tmpi+1).ne.'/')then
            call nxtchr(tmp,tmpl,tmpi,test,ichr)
            if(ichr.lt.0 .or. ichr.eq.32)call errp('Bad *v.../ TEST!')
            if(test.eq.'!')then
               tmpi1=tmpi+1
               tmpi=tmpi2-1
               if(tmpi.lt.tmpi1)call errp('Missing *v...! COMMAND!')
            endif
         endif
         tmpi=tmpi+1
         if(tmpi.ne.tmpi2 .or. tmp(tmpi:tmpi).ne.'/')
     &    call errp('Bad *v.../ command!')
c        perform the tasks
         ss=ss1
         do 882 taski=1,2
c           check that we have the parameters involved
            if(index('ACFHMSTU',task1).ne.0 .and. sstl(ss).lt.0)
     &       call errp('No value for *v task '//task1//'!')
c           turn off gathering
            if(task1.ne.' ' .and. ingth.eq.-ss-1)ingth=0
c           clean up the file specification
            if(index('ACFMSTU',task1).gt.0)then
               call clnfol(dd,nl,nll,sst(ss),sstl(ss),icolon,istat)
               if(istat.eq.-2)call errr(
     &          'nonexisting .. folder in *g file specification!')
               if(istat.gt.0)then
                  ichr=ichar(sst(ss)(istat:istat))
                  if(ichr.lt.32 .or. ichr.eq.127)ichr=ichar('?')
                  call encint(istat,cvall,cval)
                  call errr('Character '//cval(1:cvall)//', "'//
     &             char(ichr)//'", in *'//chr//
     &             ' file specification is illegal!')
               endif
c              get the fstat data on the file
               if(index('ACMSTU',task1).gt.0)then
                  istat=stat(sst(ss)(1:sstl(ss)),flstat)
                  if(istat.ne.0)call errr('Cannot obtain file status!')
               endif
            endif
c           perform the task
            if(task1.eq.' ')then
c              nil
            else if(task1.eq.'A')then
c              file last access time
               call encint(flstat(9),sstl(ss),sst(ss))
            else if(task1.eq.'B')then
c              free space in the input buffer
               call encint(ipcsiz-ipcmax,sstl(ss),sst(ss))
            else if(task1.eq.'C')then
c              file last status change time
               call encint(flstat(11),sstl(ss),sst(ss))
            else if(task1.eq.'F')then
c              file specification already cleaned up
            else if(task1.eq.'G')then
c              free space in the gather buffer
               call encint(gthdim-gthl,sstl(ss),sst(ss))
            else if(task1.eq.'H')then
c              convert time value into human-readable form
               i=0
               call rdint(sst(ss),sstl(ss),i,i2,istat)
               if(istat.ne.0 .or. i.lt.sstl(ss))
     &          call errr('Invalid time to H convert!')
               sstl(ss)=24
               sst(ss)(1:24)=ctime(i2)
            else if(task1.eq.'I')then
c              get user ID of the process
               i=getuid()
               call encint(i,sstl(ss),sst(ss))
            else if(task1.eq.'M')then
c              get FFFFugsrwxrwxrwx file mode
               i1=flstat(3)
               sstl(ss)=31
               do 881 i=31,1,-1
                  sst(ss)(i:i)=char(mod(i1,2)+48)
                  i1=i1/2
 881           continue
            else if(task1.eq.'P')then
               i=getpid()
               call encint(i,sstl(ss),sst(ss))
            else if(task1.eq.'S')then
               call encint(flstat(8),sstl(ss),sst(ss))
            else if(task1.eq.'T')then
c              file last modification time
               call encint(flstat(10),sstl(ss),sst(ss))
            else if(task1.eq.'U')then
c              user ID of file owner
               call encint(flstat(5),sstl(ss),sst(ss))
            else
               call errp('Invalid TASK'//char(taski+48)//', "'//
     &          task1//'", in *v.../!')
            endif
            task1=task2
            ss=ss2
 882     continue
c        perform the test
         if(test.eq.' ')goto 810
         yes=.false.
         if(test.eq.'?')then
            if(sstl(ss1).lt.0)
     &       call errp('No value for *v test '//test//'!')
            inquire(file=sst(ss1)(1:sstl(ss1)),exist=yes,err=887)
         else if(test.eq.'!')then
            i2=0
            i=tmpi1-1
 883        call nxtchr(tmp,tmpi-1,i,chr,ichr)
            if(ichr.ge.0)then
               i2=i2+1
               if(i2.gt.sstdim)call errp('*v...! COMMAND is too long!')
               tmplin(i2:i2)=chr
               goto 883
            else if(ichr.eq.-1)then
            else
               if(ichr.eq.-ichar('?') .and. chr.eq.'?')then
                  ss=0
               else if(ichr.eq.-ichar('@'))then
                  call rdint(tmp,tmpi-1,i,ss,istat)
                  i=min(i+1,tmpi-1)
                  if(istat.gt.1 .or. tmp(i:i).ne.'/'.or. ss.lt.0)
     &             call errp('Invalid *@.../ in *v...! COMMAND!')
                  if(istat.eq.1)ss=ssdim
                  if(ss.gt.ssdim)call errp('Nonexisting *@LOC/ LOC!')
               else
                  call errp('Invalid character in *v...! COMMAND!')
               endif
               if(sstl(ss).le.0)goto 883
               if(i2+sstl(ss).gt.sstdim)
     &          call errp('*v...! COMMAND is too long!')
               tmplin(i2+1:i2+sstl(ss))=sst(ss)(1:sstl(ss))
               i2=i2+sstl(ss)
               goto 883
            endif
            if(i2.le.0)call errp('No COMMAND for *v test '//test//'!')
            call system(tmplin(1:i2),istat)
            if(istat.eq.0)yes=.true.
         else if(index('.:',test).ne.0)then
            if(sstl(ss1).lt.0 .or. sstl(ss2).lt.0)
     &       call errp('Missing value for *v test '//test//'!')
            if(test.eq.':')yes=.true.
            i2=sstl(ss1)-sstl(ss2)
            do 884 i=sstl(ss2),1,-1
               if(i+i2.lt.1)then
                  if(sst(ss2)(i:i).eq.'0')then
                     if(test.eq.'.')then
                        yes=.true.
                        goto 885
                     endif
                  else if(sst(ss2)(i:i).eq.'1')then
                     if(test.eq.':')then
                        yes=.false.
                        goto 885
                     endif
                  endif
               else
                  chr=sst(ss1)(i+i2:i+i2)
                  if(chr.ne.'0' .and. chr.ne.'1')
     &             call errp('*v.../ LOC1 is not a binary number!')
                  if(sst(ss2)(i:i).eq.'0')then
                     if(chr.eq.'0' .and. test.eq.'.')then
                        yes=.true.
                        goto 885
                     endif
                     if(chr.eq.'1' .and. test.eq.':')then
                        yes=.false.
                        goto 885
                     endif
                  else if(sst(ss2)(i:i).eq.'1')then
                     if(chr.eq.'0' .and. test.eq.':')then
                        yes=.false.
                        goto 885
                     endif
                     if(chr.eq.'1' .and. test.eq.'.')then
                        yes=.true.
                        goto 885
                     endif
                  endif
               endif
 884        continue
 885        continue
         else if(index('=<>',test).ne.0)then
            if(sstl(ss1).lt.0 .or. sstl(ss2).lt.0)
     &       call errp('Missing value for *v test '//test//'!')
            i=0
            call rdint(sst(ss1),sstl(ss1),i,i1,istat)
            if(istat.ne.0)
     &       call errp('Invalid number at LOC1 in *v.../!')
            i=0
            call rdint(sst(ss2),sstl(ss2),i,i2,istat)
            if(istat.ne.0)
     &       call errp('Invalid number at LOC2 in *v.../!')
            if(test.eq.'=' .and. i1.eq.i2)yes=.true.
            if(test.eq.'>' .and. i1.gt.i2)yes=.true.
            if(test.eq.'<' .and. i1.lt.i2)yes=.true.
         else if(test.eq.'d')then
            if(sstl(ss1).ne.31)call errp('File mode not found!')
            if(sst(ss1)(16:19).eq.'0100')yes=.true.
         else if(index('egl',test).ne.0)then
            if(sstl(ss1).lt.0 .or. sstl(ss2).lt.0)
     &       call errp('Missing value for *v test '//test//'!')
            i2=max(sstl(ss1),sstl(ss2))
            if(i2.eq.0)then
               if(test.eq.'e')yes=.true.
            else
               i=min(sstl(ss1),sstl(ss2))
               if(test.eq.'e')then
                  if(i.eq.i2)then
                     if(sst(ss1)(1:i).eq.sst(ss2)(1:i))yes=.true.
                  endif
               else
                  do 886 i=i+1,i2
                     if(i.gt.sstl(ss1))sst(ss1)(i:i)=char(0)
                     if(i.gt.sstl(ss2))sst(ss2)(i:i)=char(0)
 886              continue
                  if(test.eq.'g')then
                     if(sst(ss1)(1:i2).gt.sst(ss2)(1:i2))yes=.true.
                  else
                     if(sst(ss1)(1:i2).lt.sst(ss2)(1:i2))yes=.true.
                  endif
               endif
            endif
         else if(test.eq.'f')then
            if(sstl(ss1).ne.31)call errp('File mode not found!')
            if(sst(ss1)(16:19).eq.'1000')yes=.true.
         else if(test.eq.'n')then
            if(sstl(ss1).le.0)yes=.true.
         else if(test.eq.'r')then
            if(sstl(ss1).lt.0)
     &       call errp('No value for *v test '//test//'!')
            i=access(sst(ss1)(1:sstl(ss1)),'r')
            if(i.eq.0)yes=.true.
         else if(test.eq.'w')then
            if(sstl(ss1).lt.0)
     &       call errp('No value for *v test '//test//'!')
            i=access(sst(ss1)(1:sstl(ss1)),'rw')
            if(i.eq.0)yes=.true.
         else if(test.eq.'x')then
            if(sstl(ss1).lt.0)
     &       call errp('No value for *v test '//test//'!')
            i=access(sst(ss1)(1:sstl(ss1)),'x')
            if(i.eq.0)yes=.true.
         else if(test.eq.'z')then
            if(sstl(ss1).lt.0)
     &       call errp('Missing value for *v test z!')
            i=0
            call rdint(sst(ss1),sstl(ss1),i,i1,istat)
            if(istat.ne.0)
     &       call errp('Invalid number at LOC1 in *v.../!')
            if(i1.eq.0)yes=.true.
         else
            ichr=ichar(test)
            if(ichr.lt.32 .or. ichr.gt.126)ichr=63
            call errp('Invalid TEST, "'//char(ichr)//'", in *v.../!')
         endif
c        find the limits of the yes and no groupings
         if(tmpi+2.gt.tmpl)goto 888
         if(tmp(tmpi+1:tmpi+2).ne.'*(')goto 888
         tmpi1=tmpi
         call fndcls(tmp,tmpl,tmpi1)
         if(tmpi1+2.gt.tmpl)goto 888
         if(tmp(tmpi1+1:tmpi1+2).ne.'*(')goto 888
         tmpi2=tmpi1
         call fndcls(tmp,tmpl,tmpi2)
c        set the new location and jump point
         if(tmpijm.ge.100)
     &    call errp('Too many nested conditional commands!')
         tmpijm=tmpijm+1
         if(yes)then
            tmpi=tmpi+2
            tmpij1(tmpijm)=tmpi1-2
         else
            tmpi=tmpi1+2
            tmpij1(tmpijm)=tmpi2-2
         endif
         tmpij2(tmpijm)=tmpi2
         goto 810
 887     call errr('Unable to examine file existence!')
 888     call errp('Invalid *v.../*(YES*)*(NO*) grouping!')
      endif

c     current working folder
      if(chr.eq.'w')then
         call output(
     &    inind,nl,nll,
     &    fil,fill,trunco,
     &    crep,crepl,repmod,
     &    cwd(1:cwdl),
     &    gthdim,gth,gthl,ingth,
     &    ounit,outcnt)
         goto 810
      endif

c     zero the gather buffer and turn on gathering
      if(chr.eq.'z')then
         gthl=0
         ingth=1
         goto 810
      endif

c     command not found
      if(chr.lt.' ' .or. chr.gt.'~')chr='?'
      call errp('Undefined "*'//chr//'" command!')

c     close the file
 889  if(ounit.ne.0 .and. ounit.ne.6)close(abs(ounit),err=980)

c     done
      call exit(0)


c exit

c     user abort
 890  print10,'*** Aborted by the user.'
      call exit(0)

c     I/O errors
 910  call errr('Error reading standard input!')
 920  i=920
      goto 941
 930  i=930
      goto 941
 940  i=940
 941  call out('*** asku '//inind//': Input file')
      if(argtl(1).le.73)then
         print10,'       '//argt(1)(2:argtl(1))
      else
         print10,'       ...'//argt(1)(argtl(1)-68:argtl(1))
      endif
      if(i.eq.920)call out(
     & '    cannot be opened: check existence and access!')
      if(i.eq.930)call out(
     & '    cannot be read from: check existence and access!')
      if(i.eq.940)call out('    cannot be closed?!')
 950  i=950
      goto 971
 960  i=960
      goto 971
 970  i=970
 971  call out('*** asku '//inind//': List of menu items')
      if(extl.le.70)then
         print10,'       '//fil(2:extl)//'lst'
      else
         print10,'       ...'//fil(extl-65:extl)//'lst'
      endif
      if(i.eq.950)call out(
     & '    cannot be opened: check existence and access!')
      if(i.eq.960)call out(
     & '    cannot be read from: check existence and access!')
      if(i.eq.970)call out('    cannot be closed?!')
 980  call out('*** asku '//inind//': Output file')
      if(fill.le.73)then
         print10,'       '//fil(2:fill)
      else
         print10,'       ...'//fil(fill-68:fill)
      endif
      call out('    cannot be finished: check disk space and access!')

c     print usage
 990  call out('Usage: asku.exe INPUT OUTPUT TEMPLATE [TYPE DEFAULT '//
     & 'HELP [MAX P8 [SEP]]]')
      call out(
     & '       Asku comes with absolutely no warrantee of any kind.')
      call out(
     & '       Asku is licensed under the Gnu Public License v3.')
      call out('       Asku version beta 3.')
      call out('       See the asku source or dommelen.net '//
     & 'web page for details.')
      call exit(1)
      end



      subroutine edit(inind,dd,nl,nll,cwd,cwdl,tmp,tmpl,
     & tmpi,bufdim,buflt,bufchr)

c     Edit the data in buffer bufchr according to an edit command.

c     avoid typos
      implicit none

c input

c     INPUT indicator
      character*1 inind

c     directory divider
      character*1 dd

c     new line string
      character*(*) nl
      integer nll

c     current working directory
      character*(*) cwd
      integer cwdl

c     template
      character*(*) tmp

c     template length to end of edit command
      integer tmpl

c input/output

c     location in template, must initially be right before the edit command
      integer tmpi

c     declared number of characters in the buffer to edit
      integer bufdim

c     actual number of characters in the buffer to edit
      integer buflt

c     buffer characters
      character*1 bufchr(0:bufdim-1)

c common

c     stored strings
      integer ssdim,sstdim
      parameter (ssdim=16,sstdim=8192)
      integer ss
      integer sstl(0:ssdim)
      character*(sstdim) sst(0:ssdim)
      common/cmss/sstl,sst

c local

c     multiple character string due to a command in REPLACE
      integer mltl,mlti
      character*(sstdim) mlt

c     declared number of recursion levels
      integer levdim
      parameter(levdim=64)
c     level index
      integer lev,lev2
c     end of the inner edit command
      integer levte(levdim)
c     character replacement table
      character*8 levcr(0:255,levdim)
      integer levcrl(0:255,levdim)
c     current character replacement branch
      character*8 levcbc(0:levdim)
      integer levcbo(0:levdim),levcbl(0:levdim)
c     local replacement length value
      integer crl
c     offset and end of the search string
      integer levtso(levdim),levtse(levdim)
c     current offset in the replacement string
      integer levtro(0:levdim)
c     maximum parameter value
      integer levpmx(0:levdim)
c     buffer limits
      integer levbs(levdim),levbe(levdim)
c     limits of the found search string
      integer levfbs(0:9,0:levdim),levfbe(0:9,0:levdim)
c     end of the previously found search string
      integer levfbp

c     declared number of entries in the string to find
      integer fnddim
      parameter (fnddim=512)
c     actual number of entries in the string to find
      integer fndmax
c     data on the entries in the string to find,
      integer fnddat(-1:255,fnddim)

c     maximum length of the edited string
      integer bufdm2

c     buffer index
      integer buf

c     template indices
      integer tmpi1,tmpi2

c     file type point
      integer ipt

c     return label
      integer iret

c     error status
      integer istat
      character*67 cstat

c     generic character
      character*1 chr
      integer ichr

c     parameter index
      integer par

c     byte index
      integer b

c     generic index
      integer i

c executable

c     sanity checks
      if(tmpi.gt.tmpl-5)call erri('edit1')
      if(tmp(tmpi+1:tmpi+3).ne.'*(0')call erri('edit2')
      if(tmp(tmpl-1:tmpl).ne.'*)')call erri('edit3')

c     initialize basic variables
      mltl=0
      mlti=0

c     initialize the edited data, moving the original to the end of the buffer
      bufdm2=bufdim-buflt
      if(bufdm2.gt.0)then
         do 10 buf=buflt-1,0,-1
            bufchr(buf+bufdm2)=bufchr(buf)
 10      continue
      endif
      buflt=0

c     initialize the zero level
      tmpi=tmpi
      lev=0
      levtro(lev)=tmpl
      levpmx(lev)=0
      levfbs(0,lev)=bufdm2
      levfbe(0,lev)=bufdim-1

c initialize the next level

c     jump-to point
 100  continue

c     initialize the new level
      lev=lev+1
      if(lev.gt.levdim)call errr('Edit levels are nested too deep!')

c     set the limits of the template string
      tmpi=tmpi+2
      levte(lev)=levtro(lev-1)-2

c     read the parameter and corresponding buffer limits
      tmpi=tmpi+1
      par=ichar(tmp(tmpi:tmpi))-48
      if(par.lt.0 .or. par.gt.levpmx(lev-1))
     & call errp('Bad parameter number in edit command!')
      levbs(lev)=levfbs(par,lev-1)
      levbe(lev)=levfbe(par,lev-1)

c     read the character replacements
      do 110 b=0,255
         levcrl(b,lev)=-b-1
 110  continue
 120  if(tmpi.ge.levte(lev))goto 150
      if(tmp(tmpi+1:tmpi+2).ne.'*=')goto 150
      tmpi=tmpi+2
      call rdrep(nl,nll,tmp,tmpl,tmpi,levcr(0,lev),levcrl(0,lev))
      goto 120

c     read the search string
 150  levtso(lev)=-1
      if(tmpi.ge.levte(lev))goto 190
      if(tmp(tmpi+1:tmpi+2).ne.'*/')
     & call errp('Command in *(...*) is not *= nor */!')
      levtso(lev)=tmpi+2
      call fndcls(tmp,tmpl,tmpi)
      levtse(lev)=tmpi-1
      tmpi1=levtso(lev)+1
      tmpi2=levtse(lev)
      call rdfnd(nl,nll,tmp(tmpi1:tmpi2),tmpi2-tmpi1+1,
     & fnddim,fndmax,fnddat,istat,cstat)
      if(istat.ne.0)call errp(cstat(1:istat))
      levfbe(0,lev)=-2

c     done initializing the next level
 190  continue

c look for the search string

c     jump-to point
 200  continue

c     initialize as not found
      levfbs(0,lev)=levbe(lev)+2
      if(levtso(lev).lt.0)goto 300

c     search for it
      levfbp=levfbe(0,lev)
      call fndit(bufdim,bufchr,levbs(lev),levbe(lev),
     & fnddim,fndmax,fnddat,
     & levfbs(0,lev),levfbe(0,lev),levpmx(lev),istat)
      if(istat.ne.0)goto 300

c     ignore a nil match immediately following a match
      if(levfbs(0,lev).gt.levfbe(0,lev)
     & .and. levfbe(0,lev).le.levfbp)then
         levfbs(0,lev)=levbe(lev)+2
         if(levbs(lev).gt.levbe(lev))goto 300
         call fndit(bufdim,bufchr,levbs(lev)+1,levbe(lev),
     &    fnddim,fndmax,fnddat,
     &    levfbs(0,lev),levfbe(0,lev),levpmx(lev),istat)
      endif

c     initialize the replacement
      levtro(lev)=levtse(lev)+1

c insert the replacement

c     jump-to point
 300  continue

c     if not at the search string, go process the next buffer character
      if(levbs(lev).gt.levbe(lev)+1)goto 400
      if(levbs(lev).lt.levfbs(0,lev))goto 400

c     handle the case that the next replacement characters came from a command
 310  if(mlti.lt.mltl)then
         mlti=mlti+1
         ichr=ichar(mlt(mlti:mlti))
         goto 390
      endif

c     done if there is no next character in the replacement
      tmpi=levtro(lev)
      if(tmpi.ge.levte(lev))then
         levbs(lev)=levfbe(0,lev)+1
         if(lev.eq.1)bufdm2=levfbe(0,lev)+1
         goto 200
      endif

c     if an edit group is next in the replacement, go process it
      if(tmp(tmpi+1:tmpi+2).eq.'*(')then
         levtro(lev)=tmpi
         call fndcls(tmp,tmpl,levtro(lev))
         goto 100
      endif

c     read the next template character or command
      call nxtchr(tmp,tmpl,tmpi,chr,ichr)
      levtro(lev)=tmpi

c     see whether it is a *? command
      if(ichr.eq.-ichar('?') .and. chr.eq.'?')then
         if(sstl(0).lt.0)call errp('Undefined *? user input!')
         if(sstl(0).eq.0)goto 310
         mlti=0
         mltl=sstl(0)
         mlt(1:mltl)=sst(0)(1:mltl)
         goto 310
      endif

c     see whether it is a *@, *r, or *x command
      if(ichr.eq.-ichar('@')
     & .or. ichr.eq.-ichar('r') .or. ichr.eq.-ichar('x'))then
         call rdint(tmp,tmpl,tmpi,ss,istat)
         tmpi=min(tmpi+1,tmpl)
         levtro(lev)=tmpi
         if(istat.gt.1 .or. tmp(tmpi:tmpi).ne.'/')
     &    call errp('Bad or incomplete *'//char(-ichr)//'.../ command!')
         if(istat.eq.1)ss=ssdim
         if(ss.gt.ssdim)
     &    call errp('Nonexisting *'//char(-ichr)//'.../ string!')
         if(sstl(ss).lt.0)
     &    call errp('Undefined *'//char(-ichr)//'.../ string!')
         if(sstl(ss).eq.0)goto 310
         mlti=0
         mltl=sstl(ss)
         if(ichr.eq.-ichar('@'))then
            mlt(1:mltl)=sst(ss)(1:mltl)
            goto 310
         endif
         ipt=mltl+1
         do 370 i=mltl,1,-1
            if(i.eq.mltl .and. ichar(sst(ss)(i:i)).le.32)then
               mltl=mltl-1
               ipt=ipt-1
            endif
            if(sst(ss)(i:i).eq.'.')then
               ipt=i
               goto 371
            endif
            if(sst(ss)(i:i).eq.dd)goto 371
 370     continue
 371     if(ichr.eq.-ichar('r'))then
            mltl=ipt-1
            if(mltl.gt.0)mlt(1:mltl)=sst(ss)(1:mltl)
         else
            if(mltl.ge.ipt)mlt(1:mltl-ipt+1)=sst(ss)(ipt:mltl)
            mltl=mltl-ipt+1
         endif
         goto 310
      endif

c     see whether it is a newline command
      if(ichr.eq.-ichar(';'))then
         if(nll.gt.sstdim)call erri('edit380')
         mlti=0
         mltl=nll
         mlt(1:mltl)=nl(1:mltl)
         goto 310
      endif

c     see whether it is a current working directory command command
      if(ichr.eq.-ichar('w'))then
         if(cwdl.gt.sstdim)call erri('edit381')
         mlti=0
         mltl=cwdl
         mlt(1:mltl)=cwd(1:mltl)
         goto 310
      endif

c     invalid command
      if(ichr.lt.0)call errp('Invalid character in *(...*) REPLACE!')

c     copy the character to the edited string
 390  levcbl(lev)=-ichr-1
      iret=310
      goto 800

c copy the next buffer character to the edited string

c     jump-to point
 400  continue

c     if there is no next character, go up one level
      if(levbs(lev).gt.levbe(lev))then
         if(lev.eq.1)then
            tmpi=tmpl
            return
         endif
         lev=lev-1
         tmpi1=levtso(lev)+1
         tmpi2=levtse(lev)
         call rdfnd(nl,nll,tmp(tmpi1:tmpi2),tmpi2-tmpi1+1,
     &    fnddim,fndmax,fnddat,istat,cstat)
         goto 310
      endif

c     copy the character into the replacement branch storage
      levcbl(lev)=-ichar(bufchr(levbs(lev)))-1
      levbs(lev)=levbs(lev)+1
      if(lev.eq.1)bufdm2=bufdm2+1
      iret=300
      goto 800

c put a character into the edited data after all character replacements

c     jump-to point
 800  continue

c     initialize
      lev2=lev

c     put the replacement of the next character one level down
 810  crl=levcbl(lev2)
      if(lev2.eq.0)then
         if(crl.lt.0)then
            buflt=buflt+1
            if(buflt.gt.bufdm2)goto 990
            bufchr(buflt-1)=char(-crl-1)
         else
            do 820 i=1,crl
               buflt=buflt+1
               if(buflt.gt.bufdm2)goto 990
               bufchr(buflt-1)=levcbc(0)(i:i)
 820        continue
         endif
         lev2=1
      else if(crl.eq.0)then
         lev2=lev2+1
         if(lev2.gt.lev)goto 890
      else if(crl.lt.0)then
         levcbl(lev2)=0
         ichr=-crl-1
         crl=levcrl(ichr,lev2)
         levcbl(lev2-1)=crl
         if(crl.gt.0)then
            levcbc(lev2-1)=levcr(ichr,lev2)
         endif
         lev2=lev2-1
      else
         if(levcbo(lev2).ge.crl)then
            levcbl(lev2)=0
         else
            i=levcbo(lev2)+1
            levcbo(lev2)=i
            ichr=ichar(levcbc(lev2)(i:i))
            crl=levcrl(ichr,lev2)
            levcbl(lev2-1)=crl
            if(crl.gt.0)then
               levcbc(lev2-1)=levcr(ichr,lev2)
            endif
            lev2=lev2-1
         endif
      endif
      goto 810

c     return to caller
 890  if(iret.eq.300)goto 300
      if(iret.eq.310)goto 310
      call erri('edit890')

 990  call out('*** asku '//inind//
     & ': Not enough storage for editing the gathered data!')
      call out('    Try editing line by line.')
      call out(
     & '    Or increase storage for the gathered data and remake asku.')
      call out('    Must abort now!')
      end



      subroutine rdrep(nl,nll,tmp,tmpl,tmpi,crep,crepl)

c     Read a character replacement command argument.

c     avoid typos
      implicit none

c input

c     new line string
      character*2 nl
      integer nll

c     template
      character*(*) tmp

c     template length
      integer tmpl

c input/output

c     location in template, must initially be at end of *=
      integer tmpi

c     character replacement table
      character*(*) crep(0:255)
      integer crepl(0:255)

c local

c     error status
      integer istat

c     character shift
      integer ishift
c     whether there is a sign
      integer sgn

c     unicode value
      integer uc

c     local replacement length value
      integer crl
c     maximum possible value
      integer crlmax

c     ascii code
      integer asc,asc2

c     generic character
      character*1 chr
      integer ichr

c     generic index
      integer i

c executable

c     set maximum replacement size
      crlmax=len(crep(0))

c     check next character
 10   if(tmpi.ge.tmpl)call errp('Unterminated *=.../ command!')
      if(index(' /',tmp(tmpi+1:tmpi+1)).ne.0)goto 900

c     read the [first] character to replace
      call nxtchr(tmp,tmpl,tmpi,chr,ichr)
      if(ichr.eq.-2)call errp('Bad character to replace in *=.../!')
      if(ichr.lt.0)call errp('Invalid character to replace in *=.../!')
      asc=ichr
      asc2=asc
      crl=0

c     check if there is more
      if(tmpi.ge.tmpl)call errp('Unterminated *=.../ command!')
      if(index(' /',tmp(tmpi+1:tmpi+1)).ne.0)goto 800

c     see whether there is a character range
      if(tmp(tmpi+1:tmpi+1).ne.':')goto 50
      tmpi=tmpi+1
      if(tmpi.ge.tmpl)call errp('Incomplete *=.../ character range!')
      if(index(' /',tmp(tmpi+1:tmpi+1)).ne.0)
     & call errp('Missing end of a *=.../ character range!')
      call nxtchr(tmp,tmpl,tmpi,chr,ichr)
      if(ichr.lt.0)call errp('Invalid end of a *=.../ character range!')
      asc2=ichr

c     see whether a unicode character replacement is asked
 50   if(tmpi.ge.tmpl-1)goto 100
      if(tmp(tmpi+1:tmpi+2).ne.'*u')goto 100
      tmpi=tmpi+2
      i=tmpi+1
      call rdint(tmp,tmpl,tmpi,ishift,istat)
      if(istat.ne.0)
     & call errp('Invalid *u number in *=.../ command!')
      if(tmpi.ge.tmpl)call errp('Unterminated *=.../ command!')
      if(index(' /',tmp(tmpi+1:tmpi+1)).eq.0)
     & call errp('A *u... must be alone in a *=.../!')
      sgn=0
      if(index('+-',tmp(i:i)).ne.0)sgn=1
      do 60 ichr=asc,asc2
         uc=ichr*sgn+ishift
         if(uc.lt.0)call errp('Negative *u... number in *=.../!')
         if(uc.gt.1114111)
     &    call errp('*u... number too big in *=.../!')
         call wutf8(uc,crlmax,crepl(ichr),crep(ichr))
 60   continue
      goto 900

c     read the next replacement character
 100  if(tmpi.ge.tmpl)call errp('Unterminated *=.../ command!')
      if(index(' /',tmp(tmpi+1:tmpi+1)).ne.0)goto 800
      crl=crl+1
      if(crl.gt.crlmax)
     & call errp('Replacement string too long in *=.../!')

c     process a character shift
      if(index('+-',tmp(tmpi+1:tmpi+1)).ne.0)then
         call rdint(tmp,tmpl,tmpi,ishift,istat)
         if(istat.ne.0 .or. asc+ishift.lt.0 .or. asc2+ishift.gt.255)
     &    call errp('Invalid character shift in *=.../ command!')
         do 200 ichr=asc,asc2
            crep(ichr)(crl:crl)=char(ichr+ishift)
 200     continue
         goto 100
      endif

c     process a normal character
      call nxtchr(tmp,tmpl,tmpi,chr,ichr)
      if(ichr.eq.-ichar('u'))
     & call errp('A *u... must be alone in a *=.../!')
      if(ichr.eq.-ichar(';'))then
         chr=nl(1:1)
         ichr=ichar(chr)
         if(nll.eq.2)then
            tmpi=tmpi-1
            tmp(tmpi:tmpi+1)=nl(1:2)
         endif
      endif
      if(ichr.lt.0)call errp(
     & 'Bad replacement character in *=.../ command!')
      do 300 ichr=asc,asc2
         crep(ichr)(crl:crl)=chr
 300  continue
      goto 100

 800  if(crl.ne.1)then
         do 850 ichr=asc,asc2
            crepl(ichr)=crl
 850     continue
      else
         do 860 ichr=asc,asc2
            crepl(ichr)=-ichar(crep(ichr)(1:1))-1
 860     continue
      endif

c     repeat if not at end
 900  tmpi=tmpi+1
      if(tmp(tmpi:tmpi).eq.' ')goto 10

      return
      end



      subroutine fndcls(tmp,tmpl,pos)

c     Find the correct closing string, allowing for nested groups.

c     This must be initialized by calling it with initial pos=-2 and the
c     template padded with an additional trailing '*)'

c     avoid typos
      implicit none

c input

c     template with the closing string to find
      character*(*) tmp
      integer tmpl

c input/output

c     input: before the start of the opener; output: at the end of the closer
      integer pos

c local

c     whether we are doing the initial check
      integer init

c     declared nesting level
      integer nstdim
      parameter (nstdim=1024)
c     current nesting level
      integer nst
c     the unclosed openers at the current level
      integer nstopn(nstdim),opn
c     the location of those openers
      integer nstpos(nstdim)

c     the lists of recognized opening characters
      character*19 opnlst
      parameter (opnlst='(l:@#=/~_ajkopqrtvx')
c     the corresponding closing characters, if not simple slashes
      character*2 clslst
      parameter (clslst=')b')
c     allowed characters before the closing /
      character*20 allow(19)
      integer allowl(19)
      data allow/
     & '                    ',
     & '0123456789-+?:      ',
     & '                    ',
     & '0123456789          ',
     & '0123456789          ',
     & '                    ',
     & '                    ',
     & '0123456789-+?gio    ',
     & '                    ',
     & '                    ',
     & '0123456789-+?       ',
     & '0123456789          ',
     & '0123456789-         ',
     & '                    ',
     & '0123456789e         ',
     & '0123456789          ',
     & '0123456789-iotuv    ',
     & '                    ',
     & '0123456789          '
     & /
      save allow,allowl
c     whether we are reading the parameters of a command with non-slash closure.
      integer inpar

c     numbers as string
      character*20 cval1,cval2
      integer cval1l,cval2l

c     list index
      integer i

c executable

c     initialize the first opener
      if(pos+2.gt.tmpl)call erri('fndcls0')
      init=0
      if(pos.ne.-2)then
         if(pos.lt.0)call erri('fndcls1')
         pos=pos+1
         if(tmp(pos:pos).ne.'*')call erri('fndcls2')
         pos=pos+1
         opn=index(opnlst,tmp(pos:pos))
      else
         init=1
         do 10 i=1,len(opnlst)
            allowl(i)=index(allow(i),'  ')-1
 10      continue
         pos=0
         opn=1
      endif
      if(opn.le.0)call erri('fndcls3')
      nst=1
      nstopn(nst)=opn
      nstpos(nst)=pos
      inpar=0

c     find next closer or opener
 100  pos=pos+1
      if(pos.gt.tmpl)then
         call encint(nstpos(nst),cval1l,cval1)
         call errp('*'//opnlst(opn:opn)//
     &    ' at position '//cval1(1:cval1l)//' never closed!')
      endif
      if(inpar.ne.0 .or. opn.gt.len(clslst))then
         if(tmp(pos:pos).eq.'/')then
            if(inpar.ne.0)then
               inpar=0
            else
               nst=nst-1
               if(nst.le.0)return
               opn=nstopn(nst)
            endif
         else if(init.ne.0)then
            if(allowl(opn).gt.0)then
               if(index(allow(opn)(1:allowl(opn)),tmp(pos:pos)).le.0)
     &          then
                  call encint(nstpos(nst),cval1l,cval1)
                  call errp('Bad parameter for *'//opnlst(opn:opn)//
     &             ' at position '//cval1(1:cval1l)//'!')
               endif
            endif
         endif
      endif
      if(tmp(pos:pos).ne.'*')goto 100
      if(pos.ge.tmpl)call errp('Incomplete * command at end!')
      pos=pos+1
      i=index(clslst,tmp(pos:pos))
      if(i.gt.0)then
         if(i.ne.nstopn(nst))then
            call encint(pos,cval1l,cval1)
            call encint(nstpos(nst),cval2l,cval2)
            call errp('*'//clslst(i:i)//' at '//
     &       cval1(1:cval1l)//' cannot close *'//
     &       opnlst(nstopn(nst):nstopn(nst))//' at '//
     &       cval2(1:cval2l)//'!')
         endif
         nst=nst-1
         if(nst.eq.0)return
         opn=nstopn(nst)
         goto 100
      endif
      i=index(opnlst,tmp(pos:pos))
      if(i.gt.0)then
         opn=i
         if(nst.ge.nstdim)
     &    call errr('TEMPLATE groups are too deeply nested!')
         nst=nst+1
         nstopn(nst)=opn
         nstpos(nst)=pos
         if(opn.le.len(clslst) .and. allowl(opn).gt.0)inpar=1
         goto 100
      endif
      goto 100

      end



      subroutine rdfnd(nl,nll,line,linel,fnddim,
     & fndmax,fnddat,cstatl,cstat)

c     Read a string to find.

c     avoid typos
      implicit none

c input

c     new line string
      character*2 nl
      integer nll

c     line with the string to find
      character*(*) line
      integer linel

c     declared number of entries in the string to find
      integer fnddim

c output

c     actual number of entries in the string to find
      integer fndmax
c     data on the entries in the string to find,
      integer fnddat(-1:255,fnddim)

c     error status
      integer cstatl
      character*67 cstat

c common

c     stored strings
      integer ssdim,sstdim
      parameter (ssdim=16,sstdim=8192)
      integer ss
      integer sstl(0:ssdim)
      character*(sstdim) sst(0:ssdim)
      common/cmss/sstl,sst

c local

c     whether we are case sensitive
      integer icase

c     whether we are in a character set
      integer inset
c     whether we are in not condition
      integer innot

c     whether we are in a group
      integer ingrp

c     group count
      integer grpct

c     error status
      integer istat

c     character
      character*1 chr
      integer ichr

c     previous character
      integer prvchr

c     input string character index
      integer iin

c     generic character index
      integer i

c     byte index
      integer b

c executable

c     see whether we have an uppercase character
      icase=0
      do 10 iin=1,linel
         if(line(iin:iin).lt.'A' .or. line(iin:iin).gt.'Z')goto 10
         i=max(1,iin-1)
         if(line(i:i).eq.'*')goto 10
         icase=1
         goto 11
 10   continue
 11   continue

c     read the characters in the string
      fndmax=0
      inset=0
      innot=0
      prvchr=-1
      ingrp=0
      grpct=0
      iin=0
 100  iin=iin+1
      if(iin.gt.linel)goto 800
      chr=line(iin:iin)
      ichr=ichar(chr)
c     handle some commands
      if(ichr.eq.ichar('*') .and. iin.lt.linel)then
         if(line(iin+1:iin+1).eq.';')then
            if(nll.eq.2)then
               iin=iin-1
               line(iin+1:iin+2)=nl(1:2)
               goto 100
            else if(nll.eq.1)then
               iin=iin+1
               chr=nl(1:1)
               ichr=ichar(chr)
            else
               call erri('rdfnd100')
            endif
         else if(line(iin+1:iin+1).eq.'i')then
            icase=0
            iin=iin+1
            goto 100
         else if(line(iin+1:iin+1).eq.'s')then
            icase=1
            iin=iin+1
            goto 100
         else if(index('?@',line(iin+1:iin+1)).gt.0)then
            iin=iin+1
            i=iin
            ss=0
            if(line(iin:iin).eq.'@')then
               call rdint(line,linel,iin,ss,istat)
               iin=min(iin+1,linel)
               if(istat.gt.1 .or. line(iin:iin).ne.'/'.or. ss.lt.0)
     &          goto 901
               if(istat.eq.1)ss=ssdim
               if(ss.gt.ssdim)goto 902
            endif
            if(sstl(ss).lt.0)goto 903
            if(inset.ne.0)goto 904
            do 150 i=1,sstl(ss)
               ichr=ichar(sst(ss)(i:i))
               fndmax=fndmax+1
               if(fndmax.gt.fnddim)goto 940
               fnddat(-1,fndmax)=0
               do 140 b=0,255
                  fnddat(b,fndmax)=0
 140           continue
               fnddat(ichr,fndmax)=1
               if(icase.eq.0)then
                  if(ichr.ge.ichar('A') .and. ichr.le.ichar('Z'))
     &             fnddat(ichr+32,fndmax)=1
                  if(ichr.ge.ichar('a') .and. ichr.le.ichar('z'))
     &             fnddat(ichr-32,fndmax)=1
               endif
 150        continue
            goto 100
         endif
      endif

c     handle the case that we are reading a character set
      if(inset.ne.0)then
         if(ichr.eq.ichar(']'))then
            inset=0
            if(innot.ne.0)then
               do 210 b=0,255
                  fnddat(b,fndmax)=1-fnddat(b,fndmax)
 210           continue
            endif
         else if(iin.ge.linel)then
               goto 990
         else if(ichr.eq.ichar('-') .and. prvchr.lt.0)then
            innot=1
         else if(ichr.eq.ichar(':')
     &       .and. prvchr.ge.0 .and. line(iin+1:iin+1).ne.']')then
            if(prvchr.eq.256)goto 970
            call nxtchr(line,linel,iin,chr,ichr)
            if(ichr.eq.-2)goto 910
            if(ichr.lt.0)goto 920
            do 240 b=prvchr,ichr
               fnddat(b,fndmax)=1
               if(icase.eq.0)then
                  if(b.ge.ichar('A') .and. b.le.ichar('Z'))
     &             fnddat(b+32,fndmax)=1
                  if(b.ge.ichar('a') .and. b.le.ichar('z'))
     &             fnddat(b-32,fndmax)=1
               endif
 240        continue
            prvchr=256
         else
            if(ichr.eq.ichar('*'))then
               iin=iin-1
               call nxtchr(line,linel,iin,chr,ichr)
               if(ichr.eq.-2)goto 910
               if(ichr.lt.0)goto 920
            endif
            fnddat(ichr,fndmax)=1
            if(ichr.eq.32 .and. line(iin:iin).eq.'W')then
               fnddat(9,fndmax)=1
               fnddat(10,fndmax)=1
               fnddat(13,fndmax)=1
            endif
            if(icase.eq.0)then
               if(ichr.ge.ichar('A') .and. ichr.le.ichar('Z'))
     &          fnddat(ichr+32,fndmax)=1
               if(ichr.ge.ichar('a') .and. ichr.le.ichar('z'))
     &          fnddat(ichr-32,fndmax)=1
            endif
            prvchr=ichr
         endif
         goto 100
      endif

c     handle the case that we are starting a set
      if(ichr.eq.ichar('['))then
         fndmax=fndmax+1
         if(fndmax.gt.fnddim)goto 940
         fnddat(-1,fndmax)=0
         do 310 b=0,255
            fnddat(b,fndmax)=0
 310     continue
         inset=1
         innot=0
         prvchr=-1
         goto 100
      endif

c     handle a repeat count on the previous character or set
      if(ichr.eq.ichar('?'))then
         if(fndmax.le.0)goto 930
         fnddat(-1,fndmax)=-1
         goto 100
      endif

c     handle a star character
      if(ichr.eq.ichar('*'))then
         if(iin.ge.linel)goto 910
         if(line(iin+1:iin+1).eq.'(')then
            if(ingrp.ne.0)goto 950
            ingrp=1
            grpct=grpct+1
            if(grpct.gt.9)goto 980
            fndmax=fndmax+1
            if(fndmax.gt.fnddim)goto 940
            fnddat(-1,fndmax)=1
            iin=iin+1
            goto 100
         endif
         if(line(iin+1:iin+1).eq.')')then
            if(ingrp.eq.0)goto 960
            ingrp=0
            fndmax=fndmax+1
            if(fndmax.gt.fnddim)goto 940
            fnddat(-1,fndmax)=2
            iin=iin+1
            goto 100
         endif
         iin=iin-1
         call nxtchr(line,linel,iin,chr,ichr)
         if(ichr.eq.-2)goto 910
         if(ichr.lt.0)goto 920
      endif

c     handle a normal character
      fndmax=fndmax+1
      if(fndmax.gt.fnddim)goto 940
      fnddat(-1,fndmax)=0
      do 710 b=0,255
         fnddat(b,fndmax)=0
 710  continue
      fnddat(ichr,fndmax)=1
      if(ichr.eq.32 .and. line(iin:iin).eq.'W')then
         fnddat(9,fndmax)=1
         fnddat(10,fndmax)=1
         fnddat(13,fndmax)=1
      endif
      if(icase.eq.0)then
         if(ichr.ge.ichar('A') .and. ichr.le.ichar('Z'))
     &    fnddat(ichr+32,fndmax)=1
         if(ichr.ge.ichar('a') .and. ichr.le.ichar('z'))
     &    fnddat(ichr-32,fndmax)=1
      endif
      goto 100

 800  if(inset.ne.0)goto 990
      if(ingrp.ne.0)goto 950
      cstatl=0
      return

 901  cstat='Invalid *@.../ in SEARCH!'
      goto 999
 902  cstat='Nonexisting *@.../ in SEARCH!'
      goto 999
 903  if(line(i:i).eq.'?')then
         cstat='*? in SEARCH is undefined!'
      else if(ss.eq.ssdim)then
         cstat='*@/ in SEARCH is undefined!'
      else
         cstat(1:1)='@'
         call encint(ss,i,cstat(2:21))
         cstat(i+2:)='/ in SEARCH is undefined!'
      endif
      goto 999
 904  if(line(i:i).eq.'?')then
         cstat='*? cannot be in a character set!'
      else if(ss.eq.ssdim)then
         cstat='*@/ cannot be in a character set!'
      else
         cstat(1:1)='@'
         call encint(ss,i,cstat(2:21))
         cstat(i+2:)='/ cannot be in a character set!'
      endif
      goto 999
 910  cstat='Incomplete * sequence in search text!'
      goto 999
 920  cstat='Undefined *'//char(-ichr)//' character!'
      goto 999
 930  cstat='? must follow a character or set!'
      goto 999
 940  cstat='Too many characters in text to find!'
      goto 999
 950  cstat='Unclosed *(...*) group in search text!'
      goto 999
 960  cstat='No *(...*) group to close!'
      goto 999
 970  cstat='Triplets like A:Z:a are not allowed!'
      goto 999
 980  cstat='Too many *(...*) groups!'
      goto 999
 990  cstat='Unterminated [...] character set!'
      goto 999
 999  cstatl=index(cstat,'!')-1
      fndmax=0
      return
      end



      subroutine fndit(bufsiz,buf,ibeg,iend,fnddim,fndmax,fnddat,
     & fndbeg,fndend,parmax,istat)

c     Find a string in a, potentially wrapped, buffer.

c     Returns istat=0 if found.  In that case, the string limits are
c     fndbeg(0) and fndend(0) while the limits of parameter i are
c     fndbeg(i) to fndend(i).

c     A trivial search string, e.g. fndmax = 0, produces fndbeg(0)=ibeg,
c     fndend(0)=ibeg-1.  That is true even for an empty buffer area,
c     iend < ibeg.

c     If the string is not found, fndbeg(0) and fndend(0) are unchanged.

c     If an i in the range from ibeg to iend equals bufsiz or more, it
c     is assumed that the corresponding element can be found in the
c     buffer at location mod(i,bufsiz).

c     avoid typos
      implicit none

c input

c     total declared size of the buffer
      integer bufsiz
c     buffer with the line to search
      character*1 buf(0:bufsiz-1)
c     area to search for the string
      integer ibeg,iend

c     declared number of entries in the string to find
      integer fnddim
c     actual number of entries in the string to find
      integer fndmax
c     data on the entries in the string to find,
      integer fnddat(-1:255,fnddim)

c output

c     the start and end points of the string parts found
      integer fndbeg(0:9),fndend(0:9)
c     last defined parameter
      integer parmax

c     error status
      integer istat

c local

c     index over the entries in the string to find
      integer fnd

c     character number
      integer ichr

c     character indices and reduced values
      integer i,i2,ir,i2r

c executable

c     initialize location
      i=ibeg-1
      ir=i
 10   if(ir.lt.0)then
         ir=ir+bufsiz
         goto 10
      endif
      if(ir.ge.bufsiz)ir=mod(i,bufsiz)

c     loop over the potential string starting characters
 100  i=i+1
      ir=ir+1
      if(ir.ge.bufsiz)ir=ir-bufsiz
      i2=i
      i2r=ir
      parmax=0
      fnd=0
c     loop over the entries of the search string
 200  fnd=fnd+1
      if(fnd.gt.fndmax)then
         istat=0
         fndbeg(0)=i
         fndend(0)=i2-1
         return
      endif
      if(fnddat(-1,fnd).eq.1)then
         parmax=parmax+1
         fndbeg(parmax)=i2
         goto 200
      endif
      if(fnddat(-1,fnd).eq.2)then
         fndend(parmax)=i2-1
         goto 200
      endif
c     loop over the buffer characters that match
 300  ichr=-1
      if(i2.le.iend)ichr=ichar(buf(i2r))
c     handle the lack of a match
      if(ichr.eq.-1 .or. fnddat(ichr,fnd).ne.1)then
         if(fnddat(-1,fnd).eq.-1)goto 200
         if(i.ge.iend)then
            istat=1
            return
         endif
         goto 100
      endif
c     handle a match
      i2=i2+1
      i2r=i2r+1
      if(i2r.ge.bufsiz)i2r=i2r-bufsiz
      if(fnddat(-1,fnd).eq.-1)goto 300
      goto 200

      return
      end



      subroutine output(
     & inind,nl,nll,
     & fil,fill,trunco,
     & crep,crepl,repmod,
     & string,
     & gthdim,gth,gthl,ingth,
     & ounit,outcnt)

c     Output string, taking care of gathering, character replacements,
c     and output truncation.

c     avoid typos
      implicit none

c input

c     INPUT indicator
      character*1 inind
c     new line string
      character*2 nl
      integer nll

c     output file
      character*256 fil
      integer fill
c     how we are truncating/wrapping output: line length, tab stops, utf-8 mode
      integer trunco(3)

c     selection character replacement table
      character*(*) crep(0:255)
      integer crepl(0:255)
c     whether we are in replacement mode
      integer repmod

c     string to output
      character*(*) string

c input/output

c     declared number of characters in the gathering storage
      integer gthdim
c     gathering storage
      character*(*) gth
c     actual number of characters in the gathering storage
      integer gthl
c     whether we are gathering
      integer ingth

c     output unit number
      integer ounit
c     output character count
      integer outcnt

c common

c     stored strings
      integer ssdim,sstdim
      parameter (ssdim=16,sstdim=8192)
      integer ss
      integer sstl(0:ssdim)
      character*(sstdim) sst(0:ssdim)
      common/cmss/sstl,sst

c local

c     output units
      integer osto,ofil
      save osto,ofil

c     whether the file exists
      logical exists

c     local value of truncation length
      integer trunc

c     local value of crepl
      integer crl

c     whether we are using utf-8
      integer utf8
c     utf-8 string length and character count
      integer utf8l,utf8ct
      data utf8ct/0/
      save utf8l,utf8ct
c     utf-8 value
      integer utf8vl
      save utf8vl
c     utf-8 character string
      character*4 utf8ch
      save utf8ch
c     long character to send as a unit to standard output
      character*4 lc
      integer lcl

c     whether we are converting Tabs into spaces
      integer cnvtab
c     local value of tab spacing
      integer tabspc

c     whether we are suppressing cr
      integer docr
      data docr/-1/
      save docr
c     pending carriage control characters
      integer pend
      data pend/0/
      save pend

c     count of wrapped characters
      integer wrpcnt
      data wrpcnt/0/

c     ascii code
      integer asc

c     character
      character*1 chr,chr0
      integer ichr,ichr0,u8chr
c     avoid annoying compiler messages
      data chr0/' '/,ichr0/0/

c     input character string index
      integer iin
c     replacement character string index
      integer irep
c     generic character string index
      integer ic

c     generic index
      integer i

c executable

c     write without newline
 10   format(a,$)
c     write with newline
 11   format(a)

c     see whether we should suppress carriage return
      if(docr.eq.-1)then
         docr=1
         if(nll.eq.2 .and. nl(1:1).eq.char(13))docr=0
      endif

c     take the data out of trunco
      trunc=trunco(1)
      tabspc=trunco(2)
      cnvtab=0
      if(tabspc.gt.0 .and. crepl(9).eq.-10)then
         if(tabspc.gt.len(crep(0)))call errp('Tab stops too far apart!')
         cnvtab=1
         crep(9)=' '
      endif
      utf8=trunco(3)

c     define ss
      ss=-ingth-1

c     loop over the characters of string
      do 500 iin=1,len(string)

c        character to write or replace
         chr=string(iin:iin)

c        if we are gathering or storing, just add it to the proper location
         if(ingth.gt.0)then
            gthl=gthl+1
            if(gthl.gt.gthdim)
     &       call errr('Program limit for gathering exceeded!')
            gth(gthl:gthl)=chr
            goto 500
         else if(ingth.lt.0)then
            sstl(ss)=sstl(ss)+1
            if(sstl(ss).gt.sstdim)
     &       call errr('Stored string length exceeded!')
            sst(ss)(sstl(ss):sstl(ss))=chr
            goto 500
         endif

c        assume the character replaces itself
         asc=ichar(chr)
         ichr=asc
         crl=1
         irep=1

c        handle tab special
         if(asc.eq.9 .and. cnvtab.ne.0)then
            crl=(outcnt/tabspc+1)*tabspc-outcnt
            irep=0
            goto 200
         endif

c        if not replacing, write it
         if(repmod.eq.0)goto 300

c        find the replacement data
         crl=crepl(asc)

c        if crl is negative, there is a single replacement character
         if(crl.lt.0)then
            ichr=-crl-1
            if(ichr.eq.asc)goto 300
            chr=char(ichr)
            goto 300
         endif

c        done if the replacement is nil
         if(crl.eq.0)goto 500

c        loop over the replacement characters
         irep=0
 200     irep=irep+1
         chr=crep(asc)(irep:irep)
         ichr=ichar(chr)

c        output the character
 300     continue
c        open output as needed
         if(ounit.eq.0)then
            if(fil(1:fill).eq.'-')then
               ounit=6
               ofil=0
               osto=6
            else
               ounit=2
               ofil=2
               inquire(file=fil(2:fill),exist=exists,err=910)
               if(.not.exists)goto 310
               open(ofil,file=fil(2:fill),status='old',err=910)
               close(ofil,status='delete',err=910)
 310           open(ofil,file=fil(2:fill),form='unformatted',err=910)
               osto=0
               if(fil(1:1).eq.'+')then
                  ounit=-ounit
                  osto=6
               endif
            endif
            outcnt=0
            wrpcnt=0
            utf8ct=0
            pend=0
         endif
c        buffer partial utf-8 characters as needed
         lcl=1
         lc(1:1)=chr
         if(utf8.gt.0)then
            if(ichr.le.127 .and. utf8ct.gt.0)goto 320
            if(ichr.le.127)goto 329
            utf8ch(utf8ct+1:utf8ct+1)=chr
            u8chr=ichr
            if(u8chr.lt.192)then
c              not the first byte
               if(utf8ct.eq.0)goto 320
               u8chr=u8chr-128
               utf8vl=utf8vl*64+u8chr
               if(utf8ct.ge.utf8l-1)then
c                 final byte
                  if(utf8vl.gt.1114111)goto 320
c                 don't count zero-width unicode for wrap
                  if(utf8vl.eq.173 .or. utf8vl.eq.8203)outcnt=outcnt-1
c                 go output the character
                  lcl=utf8l
                  lc(1:lcl)=utf8ch(1:utf8l)
                  utf8ct=0
                  goto 329
               else
c                 inner byte
                  utf8ct=utf8ct+1
                  goto 490
               endif
            else
c              the first byte
               if(utf8ct.ne.0)goto 320
               u8chr=u8chr-192
               if(u8chr.lt.32)then
                  utf8l=2
               else
                  u8chr=u8chr-32
                  if(u8chr.lt.16)then
                     utf8l=3
                  else
                     u8chr=u8chr-16
                     if(u8chr.lt.8)then
                        utf8l=4
                     else
                        goto 320
                     endif
                  endif
               endif
               utf8vl=u8chr
               utf8ct=1
               goto 490
            endif
         endif
c        handle any error termination of utf-8 mode
         goto 321
 320     utf8=0
 321     if(utf8.ne.0 .or. utf8ct.eq.0)goto 329
         utf8l=utf8ct+1
         ichr0=ichr
         chr0=chr
 325     chr=utf8ch(utf8l-utf8ct:utf8l-utf8ct)
         ichr=ichar(chr)
         goto 328
 327     ichr=ichr0
         chr=chr0
 328     lcl=1
         lc(1:1)=chr
 329     continue
c        take care of suppressing carriage returns
         if(docr.eq.0 .and. osto.ne.0)then
            if(ichr.eq.10)pend=pend-1
            if(pend.gt.0)write(osto,10,err=930)char(13)
            pend=0
            if(ichr.eq.13)pend=1
         endif
c        output the character with truncation
         if(trunc.eq.0)then
            if(ichr.eq.10)then
               if(ofil.gt.0)call putchr(ofil,chr,*920)
               if(osto.gt.0)write(osto,10,err=930)chr
               outcnt=0
               wrpcnt=0
            else if(ichr.eq.13)then
               if(ofil.gt.0)call putchr(ofil,chr,*920)
               if(osto.gt.0 .and. pend.eq.0)write(osto,10,err=930)chr
               outcnt=0
               wrpcnt=0
            else
               if(ofil.gt.0)then
                  do 410 ic=1,lcl
                     call putchr(ofil,lc(ic:ic),*920)
 410              continue
               endif
               if(osto.gt.0 .and. pend.eq.0)
     &          write(osto,10,err=930)lc(1:lcl)
               outcnt=outcnt+1
            endif
         else
            if(ichr.eq.10)then
               if(ofil.gt.0)call putchr(ofil,chr,*920)
               if(osto.gt.0)write(osto,10,err=930)chr
               outcnt=0
               wrpcnt=0
            else if(ichr.eq.13)then
               if(ofil.gt.0)call putchr(ofil,chr,*920)
               if(osto.gt.0 .and. pend.eq.0)write(osto,10,err=930)chr
               outcnt=0
               wrpcnt=0
            else
               outcnt=outcnt+1
               if(outcnt-wrpcnt.le.abs(trunc))then
                  if(ofil.gt.0)then
                     do 430 ic=1,lcl
                        call putchr(ofil,lc(ic:ic),*920)
 430                 continue
                  endif
                  if(osto.gt.0)write(osto,10,err=930)lc(1:lcl)
               else if(trunc.eq.-1)then
                  if(ofil.gt.0)then
                     do 450 ic=1,nll
                        call putchr(ofil,nl(ic:ic),*920)
 450                 continue
                     do 455 ic=1,lcl
                        call putchr(ofil,lc(ic:ic),*920)
 455                 continue
                  endif
                  if(osto.gt.0)
     &             write(osto,10,err=930)nl(2-docr:nll)//lc(1:lcl)
                  wrpcnt=outcnt-1
               else if(trunc.le.-2)then
                  if(ofil.gt.0)then
                     do 470 ic=1,nll
                        call putchr(ofil,nl(ic:ic),*920)
 470                 continue
                     call putchr(ofil,'+',*920)
                     do 475 ic=1,lcl
                        call putchr(ofil,lc(ic:ic),*920)
 475                 continue
                  endif
                  if(osto.gt.0)
     &             write(osto,10,err=930)nl(2-docr:nll)//'+'//lc(1:lcl)
                  wrpcnt=outcnt-2
               endif
            endif
         endif

c        loop if we are dumping a buffered bad utf-8 character
         if(utf8.eq.0 .and. utf8ct.gt.0)then
            utf8ct=utf8ct-1
            if(utf8ct.gt.0)goto 325
            goto 327
         endif

c        next character of the replacement
 490     if(irep.lt.crl)goto 200

 500  continue

c     remember it if we turned off utf-8
      trunco(3)=utf8

c     done
      return

c     errors
 910  i=910
      goto 921
 920  i=920
 921  call out('*** asku '//inind//': Output file')
      if(fill.le.73)then
         print11,'       '//fil(2:fill)
      else
         print11,'       ...'//fil(fill-68:fill)
      endif
      if(i.eq.910)call out(
     & '    cannot be opened: check disk space and access!')
      if(i.eq.920)call out(
     & '    cannot be written to: check disk space and access!')
 930  call errr(
     & 'Cannot write to standard output: check disk space and access!')
      return
      end

      subroutine putchr(iunit,chr,*)

c     Copyright 2012 Leon van Dommelen.  This software is made available
c     under the GNU Public License version 3.

c     Write a character to the output file open on unit iunit.

c     Takes exit 1 on error.

c     This version for g77.  Unit iunit must have been opened using
c     "form='unformatted'".

c     avoid typos
      implicit none

c input:

c     I/O unit to write to
      integer iunit

c     character to write
      character*1 chr

c local:

c     error status
      integer stat

c executable:

c     write the character to the file
      call fputc(iunit,chr,stat)

c     check for problems
      if(stat.ne.0)return 1

c     all OK
      return
      end



      subroutine errp(msg)

c     Exit on a program (i.e. invocation) error.

c     avoid typos
      implicit none

c input

c     error message
      character*(*) msg

c common

c     INPUT indicator
      character*1 inind
c     parameter
      character*8 param
c     location in TEMPLATE
      integer tmpi
      common/cmerr/tmpi,param,inind

c local

c     message length
      integer imax

c     parameter length
      integer paraml

c     total error message
      character*79 line
      integer linel

c     whether we need to add an exclamation mark
      integer iadd

c     offset in the error message
      integer ioff

c     number as string
      character*20 cval
      integer cvall

c     character index
      integer i

c executable

c     initialize the total error message
      line(1:27)='*** asku '//inind//': Program error: '
      linel=27
      paraml=0
      do 100 i=1,len(param)
         if(param(i:i).ne.' ')paraml=i
 100  continue
      if(paraml.gt.0)then
         call encint(tmpi,cvall,cval)
         line(linel+1:linel+3+paraml+cvall)=
     &    param(1:paraml)//' '//cval(1:cvall)//': '
         linel=linel+3+paraml+cvall
      endif

c     find message length
      imax=len(msg)
      if(imax.lt.1)
     & call out(line(1:27)//'Internal error too: Lost error message!!!')
      ioff=0

c     see whether the exclamation mark is there
      iadd=0
      if(msg(imax:imax).ne.'!')iadd=1

c     if the total message is too long, truncate it
      if(linel+imax+iadd.le.79)then
      else if(27+paraml+2+imax+iadd.le.79)then
         linel=27+paraml+2
         line(linel-1:linel)=': '
      else if(27+imax+iadd.le.79)then
         linel=27
      else if(12+imax+iadd.le.79)then
         linel=12
      else
         linel=12
         ioff=12+imax+iadd-79
      endif
      line(linel+1:linel+imax-ioff)=msg(ioff+1:imax)
      linel=linel+imax+iadd-ioff
      line(linel:linel)='!'

c     terminate execution
      call out(line(1:linel))

      end



      subroutine errr(msg)

c     Exit on a run-time error.

c     avoid typos
      implicit none

c input

c     error message
      character*(*) msg

c common

c     INPUT indicator
      character*1 inind
c     parameter
      character*8 param
c     location in TEMPLATE
      integer tmpi
      common/cmerr/tmpi,param,inind

c local

c     message length
      integer imax

c     parameter length
      integer paraml

c     total error message
      character*79 line
      integer linel

c     whether we need to ask an exclamation mark
      integer iadd

c     offset in the error message
      integer ioff

c     number as string
      character*20 cval
      integer cvall

c     character index
      integer i

c executable

c     initialize the total error message
      line(1:12)='*** asku '//inind//': '
      linel=12
      paraml=0
      do 100 i=1,len(param)
         if(param(i:i).ne.' ')paraml=i
 100  continue
      if(paraml.gt.0)then
         call encint(tmpi,cvall,cval)
         line(linel+1:linel+3+paraml+cvall)=
     &    param(1:paraml)//' '//cval(1:cvall)//': '
         linel=linel+3+paraml+cvall
      endif

c     find message length
      imax=len(msg)
      if(imax.lt.1)call out(line(1:linel)//
     & 'Internal error too: Lost error message!!!')
      ioff=0

c     see whether the exclamation mark is there
      iadd=0
      if(msg(imax:imax).ne.'!')iadd=1

c     if the total message is too long, truncate it
      if(linel+imax+iadd.le.79)then
      else if(12+paraml+2+imax+iadd.le.79)then
         linel=12+paraml+2
         line(linel-1:linel)=': '
      else if(12+imax+iadd.le.79)then
         linel=12
      else
         linel=12
         ioff=12+imax+iadd-79
      endif
      line(linel+1:linel+imax-ioff)=msg(ioff+1:imax)
      linel=linel+imax+iadd-ioff
      line(linel:linel)='!'

c     terminate execution
      call out(line(1:linel))

      end



      subroutine erri(lab)

c     Exit on an internal (Leon is to blame) error.

c     avoid typos
      implicit none

c input

c     error label
      character*(*) lab

c local

c     label length
      integer imax

c     total error message
      character*79 line
      integer linel

c executable

c     create message
      line(1:24)='*** asku internal error '
      linel=24
      imax=len(lab)
      if(imax.lt.1)then
         line(linel+1:linel+4)='erri'
         linel=linel+4
      else
         imax=min(imax,79-24-22)
         line(linel+1:linel+imax)=lab
         linel=linel+imax
      endif
      line(linel+1:linel+22)='. Fix and remake asku!'
      linel=linel+22

c     terminate execution
      call out(line(1:linel))

      end



      subroutine sysini(cwd,cwdl,dd,nl,nll)

c     Find the current working folder.

c     avoid typos
      implicit none

c output

c     current working directory
      character*1024 cwd
      integer cwdl

c     directory divider
      character*1 dd

c     new line string
      character*2 nl
      integer nll

c local

c     return status
      integer istat

c     character index
      integer i

c executable

c     get the working directory
      cwd=' '
      call getcwd(cwd,istat)
      if(istat.ne.0)
     & call out('*** System error: asku: cannot obtain current folder!')

c     find the length
      cwdl=1024
      do 100 i=1024,1,-1
         if(cwd(i:i).gt.' ')goto 110
         cwdl=i-1
 100  continue
      call out('*** System error: asku: cannot obtain current folder!')
 110  continue

c     find the directory separator
      if(cwd(1:1).eq.'/')then
         dd='/'
      else if(((cwd(1:1).ge.'A' .and. cwd(1:1).le.'Z') .or.
     &    (cwd(1:1).ge.'a' .and. cwd(1:1).le.'z'))
     &    .and. cwd(2:2).eq.':' .and. cwd(3:3).eq.'\\')then
         dd='\\'
      else
         call out(
     &    '*** System error: asku: cannot recognize current folder!')
      endif

c     find the new-line sequence
      if(dd.eq.'/')then
         nll=1
         nl(1:1)=char(10)
      else
         nll=2
         nl(1:2)=char(13)//char(10)
      endif

      return
      end



      subroutine nxtchr(line,linel,pos,chr,ichr)

c     Return the next, possible *-encoded, character in line.

c     Returned values of ichr:
c     >0: read character number
c      0: read character number (NUL)
c     -1: end of line
c     -2: incomplete * sequence
c     -32 to -126: unrecognized *[chr] sequence, with ichr=-ichar(chr) if
c         in the given range, otherwise ichr=-63, corresponding to '?'

c     This subroutine must be called the first time to initialize
c     itself, at which time line(1:linel) must be the single-character
c     folder separator.  The output of that call is undefined.

c     avoid typos
      implicit none

c input

c     line to read
      character*(*) line
      integer linel

c input/output

c     last read position the line
      integer pos

c output

c     character
      character*1 chr

c     character number or negative as described above
      integer ichr

c local

c     star replacement table
      character*26 orgs, reps
      data orgs/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      data reps/'&B:"!/>%$ `<- [+?]ST^|W*Y '/
      save orgs,reps

c     generic index
      integer i

c executable

c     finish the star replacement table
      if(reps(25:25).eq.'Y')then
         if(linel.eq.1)then
            reps(25:25)=line(1:1)
            i=index(orgs,'B')
            reps(i:i)='\\'
            i=index(orgs,'S')
            reps(i:i)=''''
            i=index(orgs,'T')
            reps(i:i)=char(9)
            i=index(orgs,'W')
            reps(i:i)=' '
            return
         else
            call erri('nxtchr1')
         endif
      endif

c     done if at end
      ichr=-1
      if(pos.ge.linel)return

c     return a non-star character as is
      pos=pos+1
      chr=line(pos:pos)
      ichr=ichar(chr)
      if(chr.ne.'*')return

c     check for incomplete * sequence
      ichr=-2
      if(pos.ge.linel)return

c     examine the next character
      pos=pos+1
      chr=line(pos:pos)
      ichr=ichar(chr)

c     if it is a digit, read the number
      if(ichr-48.ge.0 .and. ichr-48.le.9)then
         ichr=ichr-48
         if(pos.eq.linel)goto 150
         i=ichar(line(pos+1:pos+1))-48
         if(i.lt.0 .or. i.gt.9)goto 150
         ichr=ichr*10+i
         pos=pos+1
         if(pos.eq.linel)goto 150
         i=ichar(line(pos+1:pos+1))-48
         if(i.lt.0 .or. i.gt.9)goto 150
         if(ichr*10+i.gt.255)goto 150
         ichr=ichr*10+i
         pos=pos+1
 150     chr=char(ichr)
         return
      endif

c     try to find it in the star replacement table
      if(ichr.lt.32 .or. ichr.gt.126)ichr=63
      ichr=-ichr
      i=index(orgs,chr)
      if(i.gt.0)then
         if(reps(i:i).eq.' ' .and. chr.ne.'W')return
         chr=reps(i:i)
         ichr=ichar(chr)
      endif

      return
      end



      subroutine clnfol(dd,nl,nll,spec,specl,icolon,istat)

c     Clean up a folder or file specification.

c     For a string [D:][FOL0]/FOL1/FOL2/FOL3/.../FOLN[/FILE], where /
c     stands for the folder separator, (/ in unix, \ in DOS), and D
c     for the DOS drive letter,
c     1. removes a trailing new line
c     2. removes doubled separators (maybe unjustly for DOS);
c     3. removes any /. that is followed by / or end of string;
c     4. removes any /FOLI/.. that is followed by / or end of string;
c        replaces FOL0/.. by . if it is followed by / or end of string;
c     5. replaces ./F?L? by F?L? if it is followed by / or end of string.
c
c     Note that the top folder is the nil string in the used logic, and
c     will be returned that way.  (Except for any additional DOS D:.)  A
c     relative path should never be empty, it should be . at least.  If
c     the input string ends in /, that will stay that way.  To remove
c     it, and get a nil top folder, add a . at the end.  Do not remove
c     the / instead (there might be a second one).
c
c     The error status returns as
c      0: valid absolute path
c     -1: valid relative path (may contain .. and/or not a drive letter)
c     -2: absolute path with nonexisting .. folder
c     >0: number of the illegal character in DOS.

c     avoid typos
      implicit none

c input

c     directory divider
      character*1 dd

c     new line string
      character*2 nl
      integer nll

c input/output

c     file specification
      character*(*) spec
      integer specl

c output

c     location of the DOS drive letter colon (2) or 0 if none
      integer icolon

c     error status
      integer istat

c local

c     character index
      integer i0,i1,i

c     string shift or number of characters to delete
      integer di

c executable

c     remove any trailing new line
      if(specl.ge.nll)then
         if(spec(specl-nll+1:specl).eq.nl(1:nll))specl=specl-nll
      endif

c     find the DOS drive letter colon if any and check for illegal characters
      icolon=0
      if(dd.eq.'\\')then
         if(specl.ge.2)then
            if(spec(2:2).eq.':')then
               if(spec(1:1).ge.'a' .and. spec(1:1).le.'z')
     &          spec(1:1)=char(ichar(spec(1:1))-32)
               i=1
               if(spec(1:1).lt.'A' .or. spec(1:1).gt.'Z')goto 900
               icolon=2
            endif
         endif
         do 10 i=icolon+1,specl
            if(spec(i:i).lt.' ' .or. spec(i:i).eq.char(127))goto 900
            if(index('/:*?"<>|',spec(i:i)).gt.0)goto 900
 10      continue
      endif

c     remove duplicate dd
      i0=icolon+1
 100  if(specl.le.i0)goto 190
      i=i0
      i0=index(spec(i0:specl),dd//dd)+i0-1
      if(i0.lt.i)goto 190
      di=1
      do 150 i=i0+di,specl
         spec(i-di:i-di)=spec(i:i)
 150  continue
      specl=specl-di
      goto 100
 190  continue

c     remove /.
      i0=icolon+1
 200  if(specl.le.i0)goto 290
      i=i0
      i0=index(spec(i0:specl),dd//'.'//dd)+i0-1
      if(i0.lt.i .and. i.le.specl-1)then
         if(spec(specl-1:specl).eq.dd//'.')i0=specl-1
      endif
      if(i0.lt.i)goto 290
      di=2
      do 250 i=i0+di,specl
         spec(i-di:i-di)=spec(i:i)
 250  continue
      specl=specl-di
      goto 200
 290  continue

c     remove /subfolder/..
 300  if(specl.le.icolon+3)goto 390
      i0=icolon+index(spec(icolon+1:specl),dd//'..'//dd)
      if(i0.le.icolon .and. icolon+1.le.specl-2)then
         if(spec(specl-2:specl).eq.dd//'..')i0=specl-2
      endif
      if(i0.le.icolon+1)goto 390
      do 320 i1=i0-1,icolon+1,-1
         if(spec(i1:i1).eq.dd)goto 330
 320  continue
      if(spec(icolon+1:i0).eq.'./')goto 390
      if(spec(icolon+1:i0).eq.'../')goto 390
      spec(icolon+1:icolon+1)='.'
      i1=icolon+2
 330  di=i0-i1+3
      do 350 i=i1+di,specl
         spec(i-di:i-di)=spec(i:i)
 350  continue
      specl=specl-di
      goto 300
 390  continue

c     remove a leading ./ if possible
      if(specl.lt.icolon+3)goto 490
      if(spec(icolon+1:icolon+2).ne.'./')goto 490
      di=2
      do 450 i=icolon+1+di,specl
         spec(i-di:i-di)=spec(i:i)
 450  continue
      specl=specl-di
 490  continue

c     return path status
      istat=0
      if(specl.eq.icolon .and. (dd.ne.'\\' .or. icolon.eq.2))return
      istat=-1
      if(specl.eq.icolon)return
      if(spec(icolon+1:icolon+1).ne.dd)return
      istat=-2
      if(index(spec(icolon+1:specl),dd//'..'//dd).ne.0)return
      if(spec(max(1,specl-2):specl).eq.dd//'..')return
      istat=-1
      if(dd.eq.'\\' .and. icolon.ne.2)return
      istat=0
      return

c     invalid path character i
 900  istat=i
      return
      end



      subroutine askcol(addhlp,prompt,def,color)

c     Copyright 2012 Leon van Dommelen.  This software is made available
c     under the GNU Public License version 3.

c     Ask for a color and return it in hex format.  The default can
c     either be blank or a valid uppercase 6 digit hex.

c     If the user quits, color will be 'q'.

c     If the user asks for external help, color will be '?'.

c     avoid typos
      implicit none

c input

c     greater than zero if additional help is available
      integer addhlp

c     prompt to use, can be up to 66 characters
      character*(*) prompt

c     default color (blank for no default, otherwise an uppercase HHHHHH)
      character*(*) def

c output

c     selected color in hex format or q to quit or ? for additional help
      character*6 color

c local

c     input line
      character*80 line
      integer linel

c     numerical color value
      integer val
      character*20 cval
      integer cvall

c     hex characters
      character*16 hex
      parameter (hex='0123456789ABCDEF')

c     error status
      integer istat

c     indices
      integer i,i1,i2

c executable

c     formats
 1    format(a)

c     form the basic prompt line
      goto 20
 10   call out('   Please reenter the color, or enter ? for help, '//
     & 'or q to quit')
 20   linel=len(prompt)
      if(linel.gt.66)
     & call out('*** Program error: asku c: prompt too long!')
      line(1:linel)=prompt
      line(linel+1:80)=':'
      linel=linel+2

c     add the default if any in numeric style
      if(def.ne.' ')then
         if(len(def).ne.6)
     &    call out('*** Program error: asku c: default length not 6!')
         do 30 i=1,6
            if(index(hex,def(i:i)).eq.0)call out('*** Program error: '//
     &       'asku c: nonhex digit in default !')
 30      continue
         call encint((index(hex,def(1:1))-1)*16+index(hex,def(2:2))-1,
     &    cvall,cval)
         line(linel+1:linel+cvall)=cval(1:cvall)
         linel=linel+cvall
         call encint((index(hex,def(3:3))-1)*16+index(hex,def(4:4))-1,
     &    cvall,cval)
         line(linel+1:linel+1+cvall)=','//cval(1:cvall)
         linel=linel+1+cvall
         call encint((index(hex,def(5:5))-1)*16+index(hex,def(6:6))-1,
     &    cvall,cval)
         line(linel+1:linel+1+cvall)=','//cval(1:cvall)
      endif

c     get the user input
      call in2(line,linel)

c     refuse blank inputs
      if(line(1:linel).eq.' ')then
         call out('** The color cannot be blank.')
         goto 10
      endif

c     allow quit
      if(line(1:linel).eq.'q')then
         color='q'
         return
      endif

c     external help requests
      if(index(line(1:linel),'???').ne.0 .and. addhlp.gt.0)then
         color='?'
         return
      endif

c     advanced help request
      if(index(line(1:linel),'??').gt.0)then
         print1,' ',' ',' ',
     &    '                          MORE HELP ON ENTERING COLORS',
     &    ' ',
     &    'The HTML or RGB formats are different ways '//
     &    'to specify colors, and many web',
     &    'resources will give you appropriate values.  '//
     &    'Some web pages I saw (in 2012):',
     &    '   http://visibone.com/colorlab/   '//
     &    'http://the-light.com/colclick.html',
     &    '         http://www.webmonkey.com/2010/02/color_charts/',
     &    ' ',
     &    'Under Windows, one fairly sure way is to '//
     &    'open Paint, (from Start/ Programs/',
     &    'Accessories or from Start/ Run/ mspaint.exe,) and '//
     &    'select "Colors", "Edit',
     &    'Colors", "Define Custom Colors".  Double clicking '//
     &    'a suitable color and using',
     &    'the color bar will show the RGB values on a scale '//
     &    'from 0 to 255.',
     &    'You can also simply click the sample colors '//
     &    'for RGB values.',
     &    ' ',
     &    'I also like the "Anny Color Picker", '//
     &    'http://annystudio.com/software/ - put your',
     &    'mouse on any color and hit the Alt-x key '//
     &    'combination to see what it is, as well',
     &    'as harmonious colors.  You can swipe other '//
     &    'people''s color schemes for free!',
     &    ' ',
     &    'You can either enter Red, Green, Blue values, '//
     &    'on a scale of 0 to 255, and',
     &    'separated by commas, such as 0,0,255 for '//
     &    'blue, or the 2+2+2 hex equivalent of',
     &    'the same, such as 0000FF for blue.  For '//
     &    'examples enter a single question mark',
     &    ' '
         goto 20
      endif

c     basic help request
      if(index(line(1:linel),'?').ne.0)then
         print1,
     &    ' ',' ',' ',
     &    '                         BASIC HELP ON ENTERING COLORS',
     &    ' ',
     &    'Please enter the desired color in either '//
     &    'HTML or RGB format.',
     &    'A few example colors in RGB format are shown in '//
     &    'the list below:',
     &    ' black: 0,0,0      gray: 128,128,128   '//
     &    'silver: 192,192,192   white: 255,255,255',
     &    ' maroon: 128,0,0   red: 255,0,0        '//
     &    'olive: 128,128,0      yellow: 255,255,0',
     &    ' green: 0,128,0    lime: 0,255,0       '//
     &    'teal: 0,128,128       aqua: 0,255,255',
     &    ' navy: 0,0,128     blue: 0,0,255       '//
     &    'purple: 128,0,128     fuchsia: 255,0,255',
     &    ' gold: 255,215,0   pink: 255,192,203   '//
     &    'orange: 255,165,0     brown: 165,42,42',
     &    'To get a color above, enter its numbers '//
     &    'separated by commas as shown.',
     &    ' ',
     &    'For more help on specifying colors, enter '//
     &    'a double question mark.'
         if(addhlp.gt.0)print1,
     &    'For help on the color, enter a triple question mark.'
         print1,'To quit, and abort what you are doing, enter a q.'
         goto 20
      endif

c     check color for o typos
      if(index(line(1:linel),'o').gt.0 .or.
     & index(line(1:linel),'O').gt.0)then
         call out('** Invalid color. Mistyped an "o" for a zero?')
         goto 20
      endif

c     check for decimal points
      if(index(line(1:linel),'.').gt.0)then
         call out('** The color may not contain decimal points.  Or '//
     &    'mistyped a point for a comma?')
         goto 10
      endif

c     check for minus signs
      if(index(line(1:linel),'-').gt.0)then
         call out('** Negative RGB values are not allowed.')
         goto 10
      endif

c     see whether this seems decimal
      i1=index(line(1:linel),',')
      if(i1.ne.0)then

c        find the second comma
         i2=0
         if(i1.lt.linel)i2=index(line(i1+1:linel),',')
         if(i2.eq.0)then
            call out('** A decimal color should contain two commas, '//
     &       'not just one')
            goto 10
         endif
         i2=i2+i1

c        read red
         call readiv('** red: ',line,1,i1-1,val,istat)
         if(istat.ne.0)goto 10
         if(val.gt.255)then
            call out('** The red value cannot exceed 255.')
            goto 10
         endif
         color(1:1)=hex(val/16+1:val/16+1)
         color(2:2)=hex(mod(val,16)+1:mod(val,16)+1)

c        read green
         call readiv('** green: ',line,i1+1,i2-1,val,istat)
         if(istat.ne.0)goto 10
         if(val.gt.255)then
            call out('** The green value cannot exceed 255.')
            goto 10
         endif
         color(3:3)=hex(val/16+1:val/16+1)
         color(4:4)=hex(mod(val,16)+1:mod(val,16)+1)

c        read blue
         call readiv('** blue: ',line,i2+1,linel,val,istat)
         if(istat.ne.0)goto 10
         if(val.gt.255)then
            call out('** The blue value cannot exceed 255.')
            goto 10
         endif
         color(5:5)=hex(val/16+1:val/16+1)
         color(6:6)=hex(mod(val,16)+1:mod(val,16)+1)

      else

c        hex format checks
         i1=0
         if(linel.eq.6)then
            color=line(1:6)
         else if(linel.eq.7 .and. line(1:1).eq.'#')then
            i1=1
            color=line(2:7)
         else
            call out('** A color should consist of exactly six '//
     &       'hexadecimal digits from 0 to F,')
            call out('   or of three decimal numbers from 0 to 255 '//
     &       'separated by commas.')
            goto 10
         endif
         do 40 i=1,6
            if(color(i:i).ge.'a' .and. color(i:i).le.'z')
     &       color(i:i)=char(ichar(color(i:i))-32)
            if(index(hex,color(i:i)).le.0)then
               call out('** Character '//
     &          char(i+48+i1)//' out of '//char(6+48+i1)//
     &          'is illegal for an HTML color: not 0-9 or A-F.')
               goto 10
            endif
 40      continue

      endif

c     return the valid color
      return
      end



      subroutine readiv(erri,line,i1,i2,int,istat)

c     Copyright 2012 Leon van Dommelen.  This software is made available
c     under the GNU Public License version 3.

c     Read an integer value entered by the user.

c     Ignores leading and trailing spaces.

c     avoid typos
      implicit none

c input

c     error message introducer, up to 25 characters
      character*(*) erri

c     line as entered by the user
      character*(*) line

c     part of the line with the number
      integer i1,i2

c output

c     entered value
      integer int

c     error status, 0 on success
      integer istat

c local

c     local value of erri
      character*25 ei
      integer eil

c     nonzero if a sign was read
      integer sgn

c     number as local string
      character*11 cnum

c     character index
      integer i
c     the index as string
      character*20 ci
      integer cil

c     first nonblank character and last one
      integer is,ie

c     number length
      integer il

c executable

c     output format
 1    format(a)

c     localize error prefix
      eil=min(len(erri),len(ei))
      ei(1:eil)=erri(1:eil)

c     ignore leading blanks
      if(i2.lt.i1)goto 910
      do 100 i=i1,i2
         if(line(i:i).ne.' ')goto 110
 100  continue
      goto 910
 110  is=i

c     ignore trailing blanks
      do 200 i=i2,is,-1
         if(line(i:i).ne.' ')goto 210
 200  continue
 210  ie=i

c     transfer to local storage
      il=ie-is+1
      cnum=line(is:ie)

c     read the sign if any
      i=1
      sgn=0
      if(cnum(i:i).eq.'-')then
         sgn=1
         i=i+1
         if(i.gt.il)goto 920
      endif

c     check the length
      if(il.gt.10+sgn)goto 930

c     check that the next character is a digit
      if(cnum(i:i).lt.'0' .or. cnum(i:i).gt.'9')goto 940

c     read the number
      int=0
      do 500 i=i,il
         if(cnum(i:i).ge.'0' .and. cnum(i:i).le.'9')then
            if(int.ge.214748364)goto 950
            int=int*10+(ichar(cnum(i:i))-48)
         else
            goto 940
         endif
 500  continue

c     set the sign
      if(sgn.ne.0)int=-int

c     return
      istat=0
      return

c     errors
 910  call out(ei(1:eil)//'Missing number.')
      istat=1
      goto 990
 920  call out(ei(1:eil)//'Number "-" has no digits.')
      istat=2
      goto 990
 930  print1,ei(1:eil)//'Number "'//cnum(1:10+sgn)//
     & '..." is too long.'
      istat=3
      goto 990
 940  if(cnum(i:i).lt.' ' .or. cnum(i:i).gt.'~')cnum(i:i)='?'
      call encint(i,cil,ci)
      print1,ei(1:eil)//'Character '//ci(1:cil)//' in number "'//
     & cnum(1:il)//'", "'//cnum(i:i)//'", is invalid.'
      istat=4
      goto 990
 950  print1,ei(1:eil)//'Number "'//cnum(1:il)//'" is too big.'
      istat=5
      goto 990
 990  return
      end



      subroutine readrv(erri,line,i1,i2,val,istat)

c     Copyright 2012 Leon van Dommelen.  This software is made available
c     under the GNU Public License version 3.

c     Read a real value entered by the user.

c     Ignores leading and trailing spaces.

c     avoid typos
      implicit none

c input

c     error message introducer, up to 15 characters
      character*(*) erri

c     line as entered by the user
      character*(*) line

c     part of the line with the number
      integer i1,i2

c output

c     entered value
      real val

c     error status, 0 on success
      integer istat

c local

c     local value of erri
      character*15 ei
      integer eil

c     nonzero if a sign was read
      integer sgn

c     nonzero if a point was read
      integer pt
c     mult of the fractional digits
      real mult

c     number as local string that cannot over/underflow in 32 bit IEEE floats
      character*39 cnum

c     character index
      integer i
c     the index as string
      character*20 ci
      integer cil

c     first nonblank character and last one
      integer is,ie

c     number length
      integer il

c executable

c     output format
 1    format(a)

c     localize error prefix
      eil=min(len(erri),len(ei))
      ei(1:eil)=erri(1:eil)

c     ignore leading blanks
      if(i2.lt.i1)goto 910
      do 100 i=i1,i2
         if(line(i:i).ne.' ')goto 110
 100  continue
      goto 910
 110  is=i

c     ignore trailing blanks
      do 200 i=i2,is,-1
         if(line(i:i).ne.' ')goto 210
 200  continue
 210  ie=i

c     transfer to local storage
      il=ie-is+1
      cnum=line(is:ie)

c     read the sign if any
      sgn=0
      i=1
      if(cnum(i:i).eq.'-')then
         sgn=1
         i=i+1
         if(i.gt.il)goto 920
      endif

c     check the length
      if(il.gt.38+sgn)goto 930

c     check for a decimal point
      mult=1.
      pt=0
      if(cnum(i:i).eq.'.')then
         pt=1
         i=i+1
         if(i.gt.il)goto 920
      endif

c     check that the next character is a digit
      if(cnum(i:i).lt.'0' .or. cnum(i:i).gt.'9')goto 940

c     read the number
      val=0.
      do 500 i=i,il
         if(cnum(i:i).ge.'0' .and. cnum(i:i).le.'9')then
            if(pt.eq.0)then
               val=val*10.+(ichar(cnum(i:i))-48)
            else
               mult=mult*0.1
               val=val+(ichar(cnum(i:i))-48)*mult
            endif
         else if(cnum(i:i).eq.'.')then
            if(pt.gt.0)goto 940
            pt=1
         else
            goto 940
         endif
 500  continue

c     set the sign
      if(sgn.ne.0)val=-val

c     return
      istat=0
      return

c     errors
 910  call out(ei(1:eil)//'Missing number.')
      istat=1
      goto 990
 920  print1,ei(1:eil)//'Number "'//cnum(1:il)//'" has no digits.'
      istat=2
      goto 990
 930  print1,ei(1:eil)//'Number "'//cnum(1:38+sgn)//
     & '..." is too long.'
      istat=3
      goto 990
 940  if(cnum(i:i).lt.' ' .or. cnum(i:i).gt.'~')cnum(i:i)='?'
      call encint(i,cil,ci)
      i1=79-eil-10-cil-12-4-1-14
      if(i1.le.il)then
         print1,ei(1:eil)//'Character '//ci(1:cil)//' in number "'//
     &    cnum(1:il)//'", "'//cnum(i:i)//'", is invalid.'
      else
         print1,ei(1:eil)//'Character '//ci(1:cil)//' in number "'//
     &    cnum(1:i1-3)//'...", "'//cnum(i:i)//'", is invalid.'
      endif
      istat=4
      goto 990
 990  return
      end



      subroutine wutf8(chrno,strdim,strmax,strchr)

c     Write a utf 8 character to string strchr.

      implicit none

c input

c     character number to write
      integer chrno

c     declared dimension of the string
      integer strdim

c output

c     number of characters in string
      integer strmax

c     string
      character*(*) strchr

c local

c     maximum unicode character number
      integer uclim
      parameter (uclim=1114111)

c     local value of chrno
      integer ichr
c     subparts of ichr
      integer i1,i2,i3

c     temporary
      integer itemp

c executable

c     copy the number to local variable
      ichr=chrno

c     check validity
      if(ichr.lt.0 .or. ichr.gt.uclim)
     & call errp('UTF-8 number to write is invalid!')

c     standard ASCII
      if(ichr.le.127)then
         strmax=1
         if(strmax.gt.strdim)call erri('wutf8a')
         strchr(1:1)=char(ichr)
         goto 990
      endif

c     put the last 6 bits in i1 and remove them from ichr
      itemp=ichr/64
      i1=ichr-itemp*64
      ichr=itemp
c     a two-byte string can hold 5 more bits, i.e. up to 31
      if(ichr.le.31)then
         strmax=2
         if(strmax.gt.strdim)call erri('wutf8b')
         strchr(1:1)=char(ichr+192)
         strchr(2:2)=char(i1+128)
         goto 990
      endif

c     put the next 6 bits in i2 and remove them from ichr
      itemp=ichr/64
      i2=ichr-itemp*64
      ichr=itemp
c     a three-byte string can hold 4 more bits, i.e. up to 15
      if(ichr.le.15)then
         strmax=3
         if(strmax.gt.strdim)call erri('wutf8c')
         strchr(1:1)=char(ichr+224)
         strchr(2:2)=char(i2+128)
         strchr(3:3)=char(i1+128)
         goto 990
      endif

c     put the next 6 bits in i3 and remove them from ichr
      itemp=ichr/64
      i3=ichr-itemp*64
      ichr=itemp
c     a four-byte string can hold 3 more bits, i.e. up to 7
      if(ichr.gt.7)call erri('wutf8d')
      strmax=4
      if(strmax.gt.strdim)call erri('wutf8e')
      strchr(1:1)=char(ichr+240)
      strchr(2:2)=char(i3+128)
      strchr(3:3)=char(i2+128)
      strchr(4:4)=char(i1+128)

 990  return
      end



      subroutine encint(int,cnuml,cnum)

c     Copyright 2012 Leon van Dommelen.  This software is made available
c     under the GNU Public License version 3.

c     Encode an integer in 20 character string cnum

      implicit none

c input:

c     integer to encode
      integer int

c output:

c     encoded string length
      integer cnuml
c     encoded string
      character*20 cnum

c local:

c     string limits
      integer i1,i2
c     character index
      integer i

c executable

      write(cnum,10)int
 10   format(i20)

      do 20 i=1,20
         i1=i
         if(cnum(i:i).gt.' ')goto 21
 20   continue
 21   do 30 i=20,1,-1
         i2=i
         if(cnum(i:i).gt.' ')goto 31
 30   continue
 31   do 40 i=i1,i2
         cnum(i-i1+1:i-i1+1)=cnum(i:i)
 40   continue
      cnuml=i2-i1+1

      return
      end



      subroutine rdint(line,linel,i,int,istat)

c     Copyright 2012 Leon van Dommelen.  This software is made available
c     under the GNU Public License version 3.

c     Tries to read an integer value behind current position i.
c     Returns error status 1 if the first nonblank character is not
c     a number or sign or the string is empty.
c     Returns error status 2 if the first nonblank character is a sign
c     but the next character is not a digit.
c     Returns error status 3 if the number overflows.
c     Skips past leading spaces and a leading sign even on error status.

c     avoid typos
      implicit none

c input

c     line as entered by the user
      character*(*) line
      integer linel

c input/output

c     current position in the line
      integer i

c output

c     read value
      integer int

c     error status, 0 on success
      integer istat

c local

c     nonzero if a sign was read
      integer sgn

c executable

c     initialize as zero
      int=0

c     ignore leading blanks
      istat=1
 100  if(i.ge.linel)return
      if(line(i+1:i+1).eq.' ')then
         i=i+1
         goto 100
      endif

c     read the sign if any
      sgn=0
      if(index('+-',line(i+1:i+1)).ne.0)then
         istat=2
         i=i+1
         if(line(i:i).eq.'-')sgn=1
      endif

c     read the number
 200  if(i.ge.linel)goto 290
      if(line(i+1:i+1).lt.'0' .or. line(i+1:i+1).gt.'9')goto 290
      istat=0
      i=i+1
      if(int.ge.214748364)then
         istat=3
         return
      endif
      int=int*10+(ichar(line(i:i))-48)
      goto 200
 290  if(sgn.ne.0)int=-int

      return
      end



      subroutine type(fil)

c     Type a help file.  Uses unit 3.  Ignores errors.

c     avoid typos
      implicit none

c input

c     the file to type
      character*(*) fil

c local

c     local value of fil
      character*79 f
      integer fl

c     whether the file exists
      logical exists

c     line to print to the screen
      character*79 in
      integer inl

c     prompt line
      character*80 line

c     line count
      integer cnt

c     character
      character*1 chr

c     character index
      integer i

c executable

c     output format
 1    format(a)

c     create local file name
      fl=len(fil)+3
      if(fl.le.79)then
         f='   '//fil
      else
         f='   ...'//fil(fl-72:fl)
         fl=79
      endif

c     see whether the file exists
      inquire(file=fil,exist=exists)
      if(.not.exists)then
         call out('** Program error:  Info file does not exist:')
         print1,'   '//f(1:fl)
         goto 900
      endif

c     open it
      open(3,file=fil,status='old',err=110)
      goto 120
 110  call out('** Unable to open info file:')
      print1,'   '//f(1:fl)
      goto 900
 120  continue

c     read from the file
      cnt=0
 200  read(3,210,err=220,end=800)in
 210  format(a79)
      goto 230
 220  call out('** Unable to read from info file:')
      print1,f(1:fl)
      goto 800
 230  if(cnt.ge.21)then
         line='Press Space to see more or Enter to quit: q'
         call inkey(5,' mq',line,chr)
         if(chr.eq.'q')goto 800
         cnt=0
      endif
      inl=1
      do 250 i=1,79
         if(in(i:i).gt.' ')inl=i
         if(in(i:i).eq.char(9))in(i:i)=' '
         if(in(i:i).lt.' ')in(i:i)='?'
 250  continue
      print260,in(1:inl)
 260  format(a)
      cnt=cnt+1
      goto 200

 800  close(3,err=810)
      goto 900
 810  call out('** Unable to close info file:')
      print1,f(1:fl)

c     done
 900  return
      end
